#ifndef _ADD_EFFECT_TABLE_H
#define _ADD_EFFECT_TABLE_H
#include "osl/ptype.h"
#include "osl/board.h"
#include "osl/carray.h"
#include "osl/carray2d.h"

namespace osl{
  /**
   * board basepiece base2बͤ
   * Ƥɤ
   * 10˵ˤĤ canMoveTo 10 ӥå, canPutTo 10 ӥå ȤäƤߤ
   * ptypeoffset˴ؤ table
   */
  typedef unsigned int NearMask;
   
  /**
   * Ĥ뤿Υơ֥롥
   * 
   */
  class AddEffectTable
  {
    CArray<NearMask,OFFSET32_SIZE> nearMask[PTYPE_SIZE];
    CArray<NearMask,OFFSET32_SIZE> nearMaskWithPromote[PTYPE_SIZE];
    CArray<NearMask,OFFSET32_SIZE> nearMaskLong[PTYPE_SIZE];
    /** ¤ 4 bit * 8 Υơ֥ˤΤä */
    CArray2d<Offset,OFFSET32_SIZE,8> offsetLong[PTYPE_SIZE];
    CArray<NearMask,OFFSET32_SIZE> nearMaskPBISHOP;
    CArray2d<Offset,OFFSET32_SIZE,8> offsetPBISHOP;
    CArray<NearMask,OFFSET32_SIZE> nearMaskPROOK;
    CArray2d<Offset,OFFSET32_SIZE,8> offsetPROOK;
    void setNearMaskLong(Ptype ptype,int dx, int dy);
  public:
    AddEffectTable();
    /**
     * @param P(template) - ֤Υץ쥤䡼
     * @param ptype - ưȤμ
     * @param from - ưȤΰ
     * @param to - Ĥޥ
     */
    template<Player P>
    NearMask getNearMask(Ptype ptype,Position from, Position to) const{
      assert(isValid(ptype) && isOnBoard(from) && isOnBoard(to));
      Offset32 offset32=makeBlackOffset32<P>(positionDiff(to,from));
      return nearMask[ptype][static_cast<int>(offset32)-OFFSET32_MIN];
    }
    template<Player P>
    NearMask getNearMaskWithPromote(Ptype ptype,Position from, Position to) const{
      assert(isValid(ptype) && isOnBoard(from) && isOnBoard(to));
      Offset32 offset32=makeBlackOffset32<P>(positionDiff(to,from));
      return nearMaskWithPromote[ptype][static_cast<int>(offset32)-OFFSET32_MIN];
    }
    template<Player P>
    NearMask getNearMaskLong(Ptype ptype,Position from, Position to) const{
      assert(isValid(ptype) && isOnBoard(from) && isOnBoard(to));
      Offset32 offset32=makeBlackOffset32<P>(positionDiff(to,from));
      return nearMaskLong[ptype][static_cast<int>(offset32)-OFFSET32_MIN];
    }
    template<Player P>
    Offset getOffsetLong(Ptype ptype,Position from, Position to,int n){
      assert(isValid(ptype) && isOnBoard(from) && isOnBoard(to) && 
	     0<=n && n<8);
      Offset32 offset32=makeBlackOffset32<P>(positionDiff(to,from));
      return offsetLong[ptype](static_cast<int>(offset32)-OFFSET32_MIN,n);
    }
    template<Player P>
    NearMask getNearMaskPBISHOP(Position from, Position to) const{
      assert(isOnBoard(from) && isOnBoard(to));
      Offset32 offset32=makeBlackOffset32<P>(positionDiff(to,from));
      return nearMaskPBISHOP[static_cast<int>(offset32)-OFFSET32_MIN];
    }
    template<Player P>
    Offset getOffsetPBISHOP(Position from, Position to,int n){
      assert(isOnBoard(from) && isOnBoard(to) && 0<=n && n<8);
      Offset32 offset32=makeBlackOffset32<P>(positionDiff(to,from));
      return offsetPBISHOP(static_cast<int>(offset32)-OFFSET32_MIN,n);
    }
    template<Player P>
    NearMask getNearMaskPROOK(Position from, Position to) const{
      assert(isOnBoard(from) && isOnBoard(to));
      Offset32 offset32=makeBlackOffset32<P>(positionDiff(to,from));
      return nearMaskPROOK[static_cast<int>(offset32)-OFFSET32_MIN];
    }
    template<Player P>
    Offset getOffsetPROOK(Position from, Position to,int n){
      assert(isOnBoard(from) && isOnBoard(to) && 0<=n && n<8);
      Offset32 offset32=makeBlackOffset32<P>(positionDiff(to,from));
      return offsetPROOK(static_cast<int>(offset32)-OFFSET32_MIN,n);
    }
  };

  extern AddEffectTable addEffectTable;

}
#endif /* _ADD_EFFECT_TABLE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
