/* carray.h
 */
#ifndef _CARRAY_H
#define _CARRAY_H
#include <cstddef>
#include <cassert>
#include <algorithm>
namespace osl
{
  /**
   * boost::array Τޤ͡operator[]  assert 򤤤줿äΤǡ
   */
  template <typename T, size_t Capacity>
  class CArray
  {
  public:
    /** {} ˤ public ˤƤ */
    T elements[Capacity];
  public:
    typedef T* iterator;
    iterator begin() { return &elements[0]; }
    iterator end() { return &elements[Capacity]; }

    void clear(){
      std::fill(begin(),end(),T());
    }
    T& operator[] (size_t i) 
    {
      assert(i < Capacity);
      return elements[i];
    }

    size_t capacity() const { return Capacity; }
    
    T const& operator[] (size_t i) const
    {
      assert(i < Capacity);
      return elements[i];
    }

    typedef const T* const_iterator;
    const_iterator begin() const { return &elements[0]; }
    const_iterator end()   const { return &elements[Capacity]; }
  };
}


#endif /* _FIXED_CAPACITY_VECTOR_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
