/* addEffect.h
 */
#ifndef _CATEGORY_ADDEFFECT_H
#define _CATEGORY_ADDEFFECT_H

#include "osl/category/categoryEnv.h"
#include "osl/category/categoryTraits.h"
#include "osl/carray.h"
#include "osl/moveVector.h"
#include "osl/moveLogProbVector.h"
#include "osl/moveStack.h"
#include "osl/effectUtil.h"
#include "osl/category/ptypePtypeProbTable.h"
#include <utility>

namespace osl
{
  namespace category
  {
    /**
     * ŨζĤ
     */
    struct AddEffect : public TableProbabilityCategory
    {
      static PtypePtypeProbTable probTable;
      static const char *getName() { return "AddEffect"; }
      static std::pair<bool,size_t> 
      getIndexIf(const CategoryEnv& env, Move move, int pieceValue)
      {
	const Player opponent = alt(env.state->getTurn());
	const Piece highest = EffectUtil::mostValuableEffectOfMoveNotKing
	  (opponent, *env.state, move);
	if (highest != PIECE_EMPTY)
	{
	  const bool supported 
	    = env.state->hasEffectBy(opponent, getPosition(highest));
	  const size_t index = 
	    probTable.getIndex(unpromote(getPtype(highest)), supported, 
			       getPtype(move), pieceValue);
	    return std::make_pair(true,index);
	}
	return std::make_pair(false,0u);
      }

    };

    /**
     * ľưŨζĤ
     *
     * Ǥ϶»ʤΤΤߤоݤˤ (»ޤ)
     * (ϸ AddEffect )
     * 
     * FIXME: isInCategory Ǥ hasEffectFromTo ȤäƤ뤿
     * generate  ̵
     */
    struct AddEffectToLastMove : public TableProbabilityCategory
    {
      static PtypePtypeProbTable probTable;
      static const char *getName();
      static const int minProb() { return 381; }
      static const int pieceValueLimit;
      static std::pair<bool,size_t> 
      getIndexIf(const CategoryEnv& env, Move move, int pieceValue)
      {
	if ((! env.history->hasLastMove())
	    || (pieceValue < pieceValueLimit))
	  return std::make_pair(false,0u);
	if (env.state->hasEffectFromTo(getPtypeO(move),getTo(move),
				       getTo(env.history->lastMove())))
	{
	  const Move lastMove = env.history->lastMove();
	  const Ptype target = getPtype(lastMove);
	  const bool supported 
	    = env.state->hasEffectBy(alt(getPlayer(lastMove)),getTo(lastMove));
	  const size_t index 
	    = probTable.getIndex(target, supported,getPtype(move), pieceValue);
	  return std::make_pair(true,index);
	}
	return std::make_pair(false,0u);
      }
      static void generate(const CategoryEnv& env, MoveLogProbVector& out);
      static void generate(const CategoryEnv& env, MoveLogProbVector& out,
			   int *indices);
    };

  } // namespace category
} // namespace osl

#endif /* _CATEGORY_ADDEFFECT_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
