/* capture.h
 */
#ifndef _CAPTURE_H
#define _CAPTURE_H

#include "osl/category/categoryEnv.h"
#include "osl/category/categoryTraits.h"
#include "osl/category/probTable.h"
#include "osl/moveStack.h"
#include <boost/static_assert.hpp>

namespace osl
{
  namespace category
  {
    /**
     * ̤ capture
     * @param PTYPE μζ
     */
    template <Ptype PTYPE>
    struct Capture : public StandardProbabilityCategory
    {
      static PieceValueTable probTable;
      BOOST_STATIC_ASSERT(PtypeTraits<PTYPE>::isBasic);	// ȴ
      static const char *getName();
      static bool isInCategory(const CategoryEnv& env, Move move)
      {
	const Ptype target = getCapturePtype(move);
	return (target != PTYPE_EMPTY) && (unpromote(target) == PTYPE);
      }
      static void generate(const CategoryEnv& env, MoveVector& out);
    };

    /**
     * ľľμʬλؼ³ΤΤȤ
     */
    struct ContinueCapture : public StandardProbabilityCategory
    {
      static PieceValueTable probTable;
      static const char *getName() { return "ContinueCapture"; }
      static bool isEffective(const CategoryEnv& env)
      {
	return env.history->hasLastMove(2);
      }
      static bool isInCategory(const CategoryEnv& env, Move move)
      {
	if (! isEffective(env))
	  return false;
	const Move lastLastMove=env.history->lastMove(2);
	return (getFrom(move) == getTo(lastLastMove)) 
	  && (getCapturePtype(move) != PTYPE_EMPTY);
      }
      struct PositionAction;
      static void generate(const CategoryEnv& env, MoveVector& out);
    };

  } // namespace category
} // namespace osl

#endif /* _CAPTURE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
