#ifndef _CATEGORYFLAGS_H_
#define _CATEGORYFLAGS_H_
#include <bitset>

namespace osl
{
  namespace category
  {
    struct CategoryFlags
    {
      static const size_t maxCategories = 64;
      std::bitset<maxCategories> data;
      bool isSet(size_t i) const
      {
	assert(i < maxCategories);
	return data[i];
      }
      void set(size_t i)
      {
	assert(i < maxCategories);
	data.set(i);
      }
      void clear()
      {
	data.reset();
      }
    };
    

  } // namespace category
} // namespace osl

#endif /* _CATEGORYFLAGS_H_ */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
