/* categoryListUtil.tcc
 */
#ifndef _CATEGORYLISTUTIL_TCC
#define _CATEGORYLISTUTIL_TCC

#include "osl/category/categoryListUtil.h"
#include "osl/category/categoryUtil.h"
#include "osl/moveLogProbSet.h"

namespace osl
{
  namespace category
  {
    struct CategoryListUtilGatherAll
    {
      MoveLogProbSet *out;
      CategoryListUtilGatherAll(MoveLogProbSet *o)
	: out(o)
      {
      }
      template <bool isKingEscape>
      bool operator()(const char */*categoryName*/,
		      const MoveLogProbVector& moves)
      {
	for(MoveLogProbVector::const_iterator p=moves.begin(); 
	    p!=moves.end(); ++p)
	{
	  out->assignIfBetter(*p);
	}
	return true;
      }
    };
  } // namespace category
} // namespace osl

template <typename Categories>
void osl::category::CategoryListUtil::
gatherAllMoves(const CategoryEnv& env, MoveLogProbSet& out)
{
  forEachCategory(Categories(), env, CategoryListUtilGatherAll(&out));
}

template <class Generator>
void osl::category::CategoryListUtil::
generate(const CategoryEnv& env, MoveLogProbVector& out)
{
  boost::function_requires<category::CategoryConcept<Generator> >();
  CategoryUtil<Generator>::generate(env, out);
}

#endif /* _CATEGORYLISTUTIL_TCC */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
