/* categoryTraits.h
 */
#ifndef _CATEGORYTRAITS_H
#define _CATEGORYTRAITS_H

#include "osl/category/probTable.h"
#include "osl/move.h"
#include "osl/loki.h"

namespace osl
{
  namespace category
  {
    struct CategoryTraits
    {
      static const size_t maxProb() { return 2000; }
    };
    
    
    struct CategoryEnv;

    /**
     * Ѿˤꥫƥ default /Ϳ߷
     * 
     * â®٤ͤ virtual ϻѤʤ
     */
    struct CategoryRoot
    {
      /** 
       * "Υƥ꤬ؤ顢ʹߤΥƥϻɬפ
       * ̵" ȸȤ˿
       *
       * 򡤵;ʤɡdefault  false
       */
      static const bool isKingEscape = false;
      /** 
       * ˻ȤƥƤϤޤäƤȤʤ
       *
       * PtypePosition Τ߿
       */
      static const bool firstMatchOnly = false;
    };
    
    /** ƥγΨ˴ؤ */
    enum ProbabilityType {
      /** Ψ */
      FIXED,
      /**
       * ֤ͤɽ (PiceValueTable) ƱɽѤ
       */
      STANDARD_TABLE,
      /**
       * ȼɽѤ
       * MoveVector ͳˤʤ MoveLogProbVector Ψ褤
       */
      TABLE,
      /** ϤǳΨդ */
      SPECIAL,
    };

    struct FixedProbabilityCategory : public CategoryRoot
    {
      static const ProbabilityType probType = FIXED;
      static int getIndex(const CategoryEnv&, Move, int)
      {
	return 0;
      }
      static int indexMax() { return 1; }
    };
    struct StandardProbabilityCategory : public CategoryRoot
    {
      static const ProbabilityType probType = STANDARD_TABLE;
      static int getIndex(const CategoryEnv&, Move, int pieceValue)
      {
	return PieceValueTable::getIndex(pieceValue);
      }
      static int indexMax() { return PieceValueTable::indexMax(); }
    };
    struct TableProbabilityCategory : public CategoryRoot
    {
      static const ProbabilityType probType = TABLE;
      // ʲҥ饹
      // static int getIndex(const CategoryEnv&, Move, int pieceValue);
    };
    struct SpecialProbabilityCategory : public CategoryRoot
    {
      static const ProbabilityType probType = SPECIAL;
    };
    
    /**
     * Category κǾ(äȤؤ䤹)ΨĴ٤
     */
    template <class Category> 
    struct MinProb
    {
    private:
      static int minProb(Int2Type<true>)
      {
	return Category::probTable.minProb();
      }
      static int minProb(Int2Type<false>)
      {
	return Category::minProb();
      }
    public:
      static int minProb()
      {
	return minProb(Int2Type<Category::probType!=SPECIAL>());
      }
    };
    
  } // namespace category
} // namespace osl

#endif /* _CATEGORYTRAITS_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
