/* check.h
 */
#ifndef _CHECK_H
#define _CHECK_H

#include "osl/category/categoryEnv.h"
#include "osl/category/probTable.h"
#include "osl/category/categoryTraits.h"
#include "osl/move_generator/addEffect.h"
#include "osl/move_action/store.h"

namespace osl
{
  namespace category
  {
    /**
     * 
     */
    struct Check : public StandardProbabilityCategory
    {
      static PieceValueTable probTable;
      static const char *getName() { return "Check"; }
      static void generate(const CategoryEnv& env, MoveVector& out)
      {
	move_action::Store store(out);
	const Position target = 
	  env.state->getKingPosition(alt(env.state->getTurn()));
	move_generator::AddEffect<CategoryEnv::effect_state_t,move_action::Store>::
	  generateMoves(env.state->getTurn(), *env.state, target, store);
      }
    };

  } // namespace category
} // namespace osl

#endif /* _CHECK_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
