/* escape.h
 */
#ifndef _ESCAPE_H
#define _ESCAPE_H

#include "osl/category/categoryEnv.h"
#include "osl/category/categoryTraits.h"
#include "osl/category/probTable.h"
#include "osl/category/ptypePtypeProbTable.h"
#include "osl/moveStack.h"
#include "osl/effectUtil.h"
#include <boost/static_assert.hpp>
namespace osl
{
  class MoveLogProbVector;
  namespace category
  {
    /**
     * Escape Τν饹
     */
    struct EscapeCommon
    {
      struct Generator;
    };
    
    /**
     * ̤ escape.
     * դƼ̤Υƥ
     * FIX: 
     * - isInCategory Ǥ乶ϥåƤʤ
     * - capture ϰϤʤΤƨȹ
     *   ͤɤ⤷ʤ
     * @param PTYPE μζƨ
     */
    template <Ptype PTYPE>
    struct Escape : public TableProbabilityCategory
    {
      BOOST_STATIC_ASSERT(PtypeTraits<PTYPE>::isBasic);	// ȴ
      static PtypeValueTable probTable;
      static const char *getName();
      static std::pair<bool,size_t> 
      getIndexIf(const CategoryEnv& env, Move move, int pieceValue)
      {
	const Position from = getFrom(move);
	const Player myself = getPlayer(move);
	const Player opponent = alt(myself);
	if ((unpromote(getPtype(move)) == PTYPE)
	    && env.state->hasEffectBy(opponent,from))
	{
	  const bool supported 
	    = env.state->hasEffectBy(myself, from);
	  const Piece attacker = 
	    EffectUtil::cheapestPiece(opponent, *env.state, from);
	  const size_t index = probTable.getIndex(supported,
						  getPtype(attacker),
						  pieceValue);
	  return std::make_pair(true,index);
	}
	return std::make_pair(false,0u);
      }
      static void generate(const CategoryEnv& env, MoveLogProbVector& out);
      static void generate(const CategoryEnv& env, MoveLogProbVector& out,
			   int *indices);
    };

    /**
     * ľζˤ attack 򤫤줿ư.
     * FIXME: 
     * - isInCategory ǤƨƤ뤫ɤϥåƤʤ
     * - ľι⤬狼ɤ֤ͤ򸫤ɾ٤
     */
    struct ImmediateEscape : public TableProbabilityCategory
    {
      static PtypePtypeProbTable probTable;
      static const char *getName() { return "Escape!"; }
      static std::pair<bool,size_t> 
      getIndexIf(const CategoryEnv& env, Move move, int pieceValue)
      {
	if (!env.history->hasLastMove()) 
	  return std::make_pair(false,0u);
	if (getFrom(move)==OFFBOARD) 
	  return std::make_pair(false,0u);
	const Move lastMove=env.history->lastMove();
	if (env.state->hasEffectTo
	    (env.state->getPieceOnBoard(getTo(lastMove)), getFrom(move)))
	{
	  const bool supported 
	    = env.state->hasEffectBy(env.state->getTurn(), getTo(lastMove));
	  const size_t index = 
	    probTable.getIndex(getPtype(move), supported,
			       getPtype(lastMove), pieceValue);
	  return std::make_pair(true,index);
	}
	return std::make_pair(false,0u);
      }
      struct PositionAction;
      static void generate(const CategoryEnv& env, MoveLogProbVector& out);
      static void generate(const CategoryEnv& env, MoveLogProbVector& out,
			   int *indices);
    };


  } // namespace category
} // namespace osl

#endif /* _ESCAPE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
