/* kingEscape.h
 */
#ifndef _KINGESCAPE_H
#define _KINGESCAPE_H

#include "osl/category/categoryEnv.h"
#include "osl/category/categoryTraits.h"
#include "osl/move_generator/escape.h"
#include "osl/move_action/store.h"
#include "osl/neighboring8.h"
#include "osl/moveStack.h"
namespace osl
{
  namespace category
  {
    /**
     * ˲꤬äƤȤƨ
     */
    struct KingEscape : public StandardProbabilityCategory
    {
      static PieceValueTable probTable;
      static const char *getName() { return "KingEscape"; }
      static const bool isKingEscape = true;
      static void generate(const CategoryEnv& env, MoveVector& out)
      {
	const Player player = env.state->getTurn();
	const Piece kingPiece=env.state->getKingPiece(player);
	const Position kingPosition=getPosition(kingPiece);
	if (! env.state->hasEffectBy(alt(player), kingPosition))
	  return;

	move_action::Store store(out);
	if (player == BLACK)
	  move_generator::Escape<BLACK,CategoryEnv::effect_state_t,move_action::Store>::
	    generateMoves(*env.state,(*env.state).getPieceAt(kingPosition),store);
	else
	  move_generator::Escape<WHITE,CategoryEnv::effect_state_t,move_action::Store>::
	    generateMoves(*env.state,(*env.state).getPieceAt(kingPosition),store);
      }
    };

    /**
     * 
     */
    struct EnteringKing : public FixedProbabilityCategory
    {
      static FixedValueTable probTable; // 700;
      static const char *getName() { return "EnteringKing"; }

      static bool isInCategory(const CategoryEnv& env, Move move)
      {
	return (getPtype(move) == KING)
	  && canPromotePosition(getPlayer(move), getTo(move));
      }
    };

    /**
     * ư(dropޤ)ξ꤫ư𤬼̤8˵
     * ⤷8˵Ǥ
     */
    struct DirectDefenseToKing8 : public StandardProbabilityCategory
    {
      static PieceValueTable probTable; // { return 800; }
      static const char *getName() { return "DirectDefenseToKing8"; }
    public:
      static bool isInCategory(const CategoryEnv& env, Move move)
      {
	const PtypeO ptypeo = getPtypeO(move);
	const Position to = getTo(move);
	const Position kingPosition =
	  env.state->getKingPosition(env.state->getTurn());
	return Neighboring8::isNeighboring8(getTo(move),kingPosition)
	  || Neighboring8::hasEffectFromNeighboring8(*env.state, ptypeo, 
						     to, kingPosition);
      }
    };
    
  } // namespace category
} // namespace osl

#endif /* _KINGESCAPE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
