/* mate.h
 */
#ifndef _CATEGORY_MATE_H
#define _CATEGORY_MATE_H

#include "osl/category/categoryEnv.h"
#include "osl/category/categoryTraits.h"
#include "osl/neighboring8.h"

/**
 * @file
 * 󤻴طΥƥ
 */

namespace osl
{
  namespace category
  {
    class PieceValueTable;
    /**
     * ư(dropޤ)ξ꤫ư̤8˵
     */
    struct DirectAttackToKing8 : public StandardProbabilityCategory
    {
      static PieceValueTable probTable;
      static const char *getName() { return "DirectAttackToKing8"; }
    public:
      static bool isInCategory(const CategoryEnv& env, Move move)
      {
	const PtypeO ptypeo = getPtypeO(move);
	const Position to = getTo(move);
	const Position opKingPosition =
	  env.state->getKingPosition(alt(env.state->getTurn()));
	return Neighboring8::hasEffectFromNeighboring8
	  (*env.state, ptypeo, to, opKingPosition);
      }
    };

    /**
     * ȶΤϤ ʤ
     */
    struct SlowApproach : public StandardProbabilityCategory
    {
      static PieceValueTable probTable;
      static const char *getName() { return "SlowApproach"; }

      static bool isInCategory(const CategoryEnv& env, Move move)
      {
	if (getCapturePtype(move) != PTYPE_EMPTY)
	  return false;
	if ((getPtype(move) != PPAWN)
	    && (getPtype(move) != PLANCE)
	    && (getPtype(move) != PKNIGHT)
	    && (getPtype(move) != KNIGHT)
	    && (getPtype(move) != GOLD)
	    && (getPtype(move) != SILVER)
	    && (getPtype(move) != PSILVER)
	    && (getPtype(move) != PBISHOP)
	    && (getPtype(move) != PROOK)
	  )
	  return false;
	const Position from = getFrom(move);
	if (from == OFFBOARD)
	  return false;
	const Position to = getTo(move);
	const Position opKingPosition =
	  env.state->getKingPosition(alt(env.state->getTurn()));
	return approaching(from, to, opKingPosition)
	  || (directionTable.nextPosition(getPlayer(move), from, D) == to);
      }
      /** ̤˶դƤ뤫ɤ */
      static bool approaching(Position from, Position to, Position target)
      {
	// FIXME: sloow
	int fromX = getX(from);
	int fromY = getY(from);
	int toX = getX(to);
	int toY = getY(to);
	int targetX = getX(target);
	int targetY = getY(target);
	return (abs(toY-targetY) < 4)
	  && ((abs(toX-targetX) < abs(fromX-targetX)) // ŪˤŨؤľ
	      || (abs(toY-targetY) < abs(fromY-targetY)));
      }
    };
  } // namespace category
} // namespace osl

#endif /* _CATEGORY_MATE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
