/* probTable.h
 */
#ifndef _PROBTABLE_H
#define _PROBTABLE_H

#include "osl/carray.h"
namespace osl
{
  namespace category
  {
    /**
     * 
     */
    template <size_t IndexMax>
    class ProbTable
    {
    protected:
      CArray<int,IndexMax> prob;
      int min;
    public:
      ProbTable();
      virtual ~ProbTable() {}
      explicit ProbTable(const char *home,const char *name);
      void init(const char *filename);
      int operator[](int i) const { return prob[i]; }
      int minProb() const { return min; }
      /** init ƤФ */
      virtual void interpolate();
      static size_t indexMax() { return IndexMax; }
      /** 0 0 ¸ޤ32 ߤˤ褦Ȼפäα */
      static int roundUp(int val) { return val; /*(val + 31) & (~31);*/ }
    };

    /** 
     * ֤ͤˤʤΨ
     */
    struct FixedValueTable : public ProbTable<1>
    {
      typedef ProbTable<1> base_t;
      FixedValueTable(const char *home, const char *name)
	: base_t(home, name)
      {
      }
      FixedValueTable(size_t val)
      {
	prob[0] = val;
	min = val;
      }
    };

    const size_t PieceValueTableLength = 86;
    /**
     * ɸγΨɽ
     */
    struct PieceValueTable : public ProbTable<PieceValueTableLength>
    {
      typedef ProbTable<PieceValueTableLength> base_t;
      PieceValueTable(const char *home, const char *name);
      void interpolate();
      /**
       * -2750ʾ64ȤprobͿ롣
       * @param ֤
       */
      static int getIndex(int diff)
      {
	if (diff>=2750)
	  return indexMax()-1;
	diff += 2750;
	if (diff < 0)
	  return 0;
	return diff >> 6;
      }
    };
    
  } // namespace category
} // osl

#define DEF_CATEGORY_TABLE(T,C) T C::probTable(OSL_HOME, C::getName())

#endif /* _PROBTABLE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
