/* ptypePtypeProbTable.h
 */
#ifndef _PTYPEPTYPEPROBTABLE_H
#define _PTYPEPTYPEPROBTABLE_H

#include "osl/category/probTable.h"
#include "osl/ptype.h"
namespace osl
{
  namespace category
  {
    class PtypePtypeProbTable : public ProbTable<2*16*16*PieceValueTableLength>
    {
      typedef ProbTable<2*16*16*PieceValueTableLength> base_t;
    public:
      PtypePtypeProbTable(const char *h, const char *n);
      static size_t getIndex(Ptype targetPtype,
			     bool targetHasSupport,
			     Ptype attackerPtype,
			     int pieceValue)
      {
	const size_t support = targetHasSupport*16*16*PieceValueTableLength;
	const size_t ptypeIndex = static_cast<int>(targetPtype)*16
	  + static_cast<int>(attackerPtype);
	// ݻνѹ? â interpolate ʣˤʤ
	return ptypeIndex*PieceValueTable::indexMax() 
	  + PieceValueTable::getIndex(pieceValue) + support;
      }
      void interpolate();
    };

    /**
     * escape ǻȤɽ
     */
    struct PtypeValueTable : public ProbTable<PieceValueTableLength*16*2>
    {
      typedef ProbTable<PieceValueTableLength*16*2> base_t;
      PtypeValueTable(const char *h, const char *n);
      static size_t getIndex(bool hasSupport,
			     Ptype attackerPtype,
			     int pieceValue)
      {
	const size_t support = hasSupport*PieceValueTableLength*16;
	const size_t ptypeIndex = static_cast<int>(attackerPtype);
	return ptypeIndex*PieceValueTableLength
	  + PieceValueTable::getIndex(pieceValue) + support;
      }
      void interpolate();
    };
  } // namespace category
} // namespace osl

#endif /* _PTYPEPTYPEPROBTABLE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
