/* takeBack.h
 */
#ifndef _TAKEBACK_H
#define _TAKEBACK_H

#include "osl/category/categoryEnv.h"
#include "osl/category/categoryTraits.h"
#include "osl/category/probTable.h"
#include "osl/move_generator/capture.h"
#include "osl/move_action/store.h"
#include "osl/moveStack.h"

namespace osl
{
  namespace category
  {
    /**
     * ֤
     */
    struct TakeBack : public StandardProbabilityCategory
    {
      static PieceValueTable probTable;
      static const char *getName() { return "TakeBack"; }
      static bool isEffective(const CategoryEnv& env)
      {
	return env.history->hasLastMove();
      }
      static bool isInCategory(const CategoryEnv& env, Move move)
      {
	return isEffective(env) 
	  && (getTo(env.history->lastMove()) == getTo(move));
      }
      static void generate(const CategoryEnv& env, MoveVector& out)
      {
	if (! isEffective(env))
	  return;
	move_action::Store store(out);
	move_generator::Capture<CategoryEnv::effect_state_t,move_action::Store>::
	  generateMoves(env.state->getTurn(), *env.state, 
			getTo(env.history->lastMove()), store);
      }
    };

  } // namespace category
} // namespace osl

#endif /* _TAKEBACK_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
