/* arrayCheckHashTable.h
 */
#ifndef _ARRAY_CHECK_HASHTABLE_H
#define _ARRAY_CHECK_HASHTABLE_H

#include "osl/checkmate/proofDisProof.h"
#include "osl/checkmate/checkHashRecord.h"
#include "osl/checkmate/checkHashRecordList.h"
#include "osl/hashKey.h"
#include <boost/scoped_array.hpp>
#include <ext/slist>
#include <cassert>

/** ʲȶ̤ͥ۴طˤ (dis)proof number νԤ */
// #define USE_ESTIMATION_BY_DOMINANCE

#define BOOST_DISABLE_ASSERTS
namespace osl
{
  namespace checkmate
  {
    /**
     * ;ѤΥơ֥
     * SimpleCheckHashTable ִ
     *
     * - bucket ƬǤ֤ƤȤ̤chain hash Ȱ㤦
     * - ̤Ѥ뤿ˡޤ׾ζʬष˻ʬह
     */
    class ArrayCheckHashTable
    {
      typedef std::pair<PieceStand,CheckHashRecord> element_t;
      typedef __gnu_cxx::slist<element_t> same_board_list_t;
      struct BoardEntry
      {
	unsigned int v0;
#ifdef HASH_KEY_128_BIT
	unsigned int v3;
#endif
	same_board_list_t colleagues;
	void setKey(const HashKey& key)
	{
	  v0 = key.value(0);
#ifdef HASH_KEY_128_BIT
	  v3 = key.value(3);
#endif
	}
	bool unused() const { return colleagues.empty(); }
	/** value(1)ӺѤǤ뤳Ȥ */
	bool equalKey(const HashKey& key) const
	{
	  if (key.value(0) != v0)
	    return false;
#ifdef HASH_KEY_128_BIT
	  assert(key.value(3) == v3);
#endif
	  return true;
	}
	CheckHashRecord *find(const HashKey& key)
	{
	  for (same_board_list_t::iterator p=colleagues.begin(); 
	       p!=colleagues.end(); ++p)
	  {
	    if (p->first == key.blackStand())
	      return &p->second;
	  }
	  return 0; 
	}
	void setMoreProvable(unsigned int& proofLL, unsigned int& disProofUL,
			     CheckHashRecord *& finalByDominance, 
			     CheckHashRecord& record,
			     CheckHashRecordList& moreProvableStates)
	{
	  // key ͤߤˤ
	  if (! record.isVisited)
	  {
	    proofLL = std::max(getProof(record.proofDisProof), proofLL);
	    if ((record.proofDisProof != NoEscape)
		&& (getDisProof(record.proofDisProof) == 0))
	    {
	      disProofUL = 0;
	      finalByDominance = &record;
	    }
	  }
#ifdef CHECK_PROPAGATE_BY_DOMINANCE
	  moreProvableStates.push_front(&record);
#endif
	}
	void setLessProvable(unsigned int& proofUL, unsigned int& disProofLL, 
			     CheckHashRecord *& finalByDominance,
			     CheckHashRecord& record,
			     CheckHashRecordList& lessProvableStates)
	{
	  // key ͤߤ䤹
	  if (! record.isVisited)
	  {
	    disProofLL = std::max(getDisProof(record.proofDisProof), 
				  disProofLL);
	    if (getProof(record.proofDisProof) == 0)
	    {
	      proofUL = 0;
	      finalByDominance = &record;
	    }
	  }
#ifdef CHECK_PROPAGATE_BY_DOMINANCE
	  lessProvableStates.push_front(&record);
#endif
	}
      
	CheckHashRecord *allocate(Player attacker, 
				  const HashKey& key, size_t& counter)
	{
	  CheckHashRecord *result=0;
#ifdef USE_ESTIMATION_BY_DOMINANCE
	  const bool isBlackTurn = (attacker==BLACK);
	  unsigned int proofUL=BigProofNumber; // upper limit
	  unsigned int proofLL=1;	// lower limit
	  unsigned int disProofUL=BigProofNumber;
	  unsigned int disProofLL=1;
	  CheckHashRecord *finalByDominance = 0;
	  CheckHashRecordList moreProvableStates, lessProvableStates;
#endif
	  for (same_board_list_t::iterator p=colleagues.begin(); 
	       p!=colleagues.end(); ++p)
	  {
	    if (p->first == key.blackStand())
	    {
	      result = &p->second;
#ifdef USE_ESTIMATION_BY_DOMINANCE
	      if (isFinal(result->proofDisProof))
#endif
		return result;
#ifdef USE_ESTIMATION_BY_DOMINANCE
	      if (finalByDominance)
		break;
#endif
	    }
#ifdef USE_ESTIMATION_BY_DOMINANCE
	    else if (p->first.isSuperiorOrEqualTo(key.blackStand()))
	    {
	      if (isBlackTurn)
	      {
		setMoreProvable(proofLL, disProofUL, finalByDominance, p->second,
				moreProvableStates);
	      }
	      else
	      {
		setLessProvable(proofUL, disProofLL, finalByDominance, p->second,
				lessProvableStates);
	      }
	    }
	    else if (key.blackStand().isSuperiorOrEqualTo(p->first))
	    {
	      if (isBlackTurn)
	      {
		setLessProvable(proofUL, disProofLL, finalByDominance, p->second,
				lessProvableStates);
	      }
	      else
	      {
		setMoreProvable(proofLL, disProofUL, finalByDominance, p->second,
				moreProvableStates);
	      }
	    }
#endif
	  }
	  if (! result)
	  {
	    ++counter; 
	    colleagues.push_front(std::make_pair(key.blackStand(),
						 CheckHashRecord()));
	    result = &colleagues.front().second;
	  }
#ifdef USE_ESTIMATION_BY_DOMINANCE
	  if (proofUL == 0)
	  {
	    assert(disProofUL && finalByDominance);
	    result->proofDisProof = CheckMate;
	    result->finalByDominance = finalByDominance;
	    result->bestMove = finalByDominance->bestMove;
	    return result;
	  }
	  if (disProofUL == 0)
	  {
	    assert(finalByDominance);
	    result->proofDisProof = NoCheckMate;
	    result->finalByDominance = finalByDominance;
	    result->bestMove = 0;
	    return result;
	  }
	  if (proofLL == 0)
	    proofLL+=1;
	  if (disProofLL == 0)
	    disProofLL+=1;
	  result->proofDisProof 
	    = makeProofDisProof(std::max(getProof(result->proofDisProof),proofLL),
				std::max(getDisProof(result->proofDisProof),
					 disProofLL));
#  ifdef CHECK_PROPAGATE_BY_DOMINANCE
	  for (CheckHashRecordList::iterator p=moreProvableStates.begin();
	       p!=moreProvableStates.end(); ++p)
	  {
	    (*p)->lessProvableStates.push_front(result);
	  }
	  for (CheckHashRecordList::iterator p=lessProvableStates.begin();
	       p!=lessProvableStates.end(); ++p)
	  {
	    (*p)->moreProvableStates.push_front(result);
	  }
	  result->moreProvableStates.swap(moreProvableStates);
	  result->lessProvableStates.swap(lessProvableStates);
#  endif
#endif
	  return result;
	}
	const CheckHashRecord *find(const HashKey& key) const
	{
	  for (same_board_list_t::const_iterator p=colleagues.begin(); 
	       p!=colleagues.end(); ++p)
	  {
	    if (p->first == key.blackStand())
	      return &p->second;
	  }
	  return 0; 
	}
      };
      typedef __gnu_cxx::slist<BoardEntry> list_t;
      struct ElementList
      {
	BoardEntry elem;
	list_t list;

	CheckHashRecord *allocate(Player attacker,
				  const HashKey& key, size_t& counter)
	{
	  if (elem.equalKey(key))
	    return elem.allocate(attacker, key, counter);
	  if (elem.unused())
	  {
	    elem.setKey(key);
	    return elem.allocate(attacker, key, counter);
	  }
	  for (list_t::iterator p=list.begin(); p!=list.end(); ++p)
	  {
	    if (p->equalKey(key))
	      return p->allocate(attacker, key, counter);
	  }
	  list.push_front(BoardEntry());
	  list.front().setKey(key);
	  return list.front().allocate(attacker, key,counter);
	}
  
	CheckHashRecord *find(const HashKey& key)
	{
	  if (elem.equalKey(key))
	    return elem.find(key);
	  for (list_t::iterator p=list.begin(); p!=list.end(); ++p)
	  {
	    if (p->equalKey(key))
	      return p->find(key);
	  }
	  return 0; 
	}
	const CheckHashRecord *find(const HashKey& key) const
	{
	  if (elem.equalKey(key))
	    return elem.find(key);
	  for (list_t::const_iterator p=list.begin(); p!=list.end(); ++p)
	  {
	    if (p->equalKey(key))
	      return p->find(key);
	  }
	  return 0; 
	}
      };
      static const size_t bucketSize = 786433ul; // 1572869ul;
#if 0
      // stack ֤̤ǤϤʤΤǡݤˤʤ
      ElementList buckets[bucketSize];
#else
      boost::scoped_array<ElementList> buckets;
#endif
      size_t numElements;
      const Player attacker;
      static unsigned int makeHash(const HashKey& key)
      {
	// 1(>0) ܤǤbucket λ˻Ȥ
	return key.value(1) % bucketSize;
      }
    public:
      explicit ArrayCheckHashTable(Player attacker);
      ~ArrayCheckHashTable();

      CheckHashRecord *find(const HashKey& key);
      CheckHashRecord *allocate(const HashKey& key);
    private:
      void clear();		// not implemented yet
    public:
      const CheckHashRecord *find(const HashKey& key) const;
      size_t size() const { return numElements; }
      Player getAttacker() const { return attacker; }
      void confirmNoVisitedRecords() const;
    };

    inline
    const CheckHashRecord* ArrayCheckHashTable::find(const HashKey& key) const
    {
      const ElementList& e = buckets[makeHash(key)];
      return e.find(key);
    }
    inline
    CheckHashRecord* ArrayCheckHashTable::find(const HashKey& key)
    {
      ElementList& e = buckets[makeHash(key)];
      return e.find(key);
    }
    inline
    CheckHashRecord* ArrayCheckHashTable::allocate(const HashKey& key)
    {
      ElementList& e = buckets[makeHash(key)];
      return e.allocate(attacker, key, numElements);
    }

  } // namespace checkmate
} // namespace osl

#endif /* _ARRAY_CHECK_HASHTABLE_H_ */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
