/* checkHashRecord.h
 */
#ifndef _CHECKHASHRECORD_H
#define _CHECKHASHRECORD_H

#include "osl/checkmate/proofDisProof.h"
#include "osl/checkmate/checkMoveList.h"
#include "osl/checkmate/checkHashRecordList.h"
#include "osl/move.h"

/** ȶ̤ͥ۴ط򵭲/ԵͤǤʤŤ */
// #define PROOF_NUMBER_PROPAGATE_BY_DOMINANCE
/** ȶ̤ͥ۴ط򵭲/ԵͤŤ */
#define CHECK_PROPAGATE_BY_DOMINANCE
#if (defined PROOF_NUMBER_PROPAGATE_BY_DOMINANCE) && (! defined CHECK_PROPAGATE_BY_DOMINANCE)
#  define CHECK_PROPAGATE_BY_DOMINANCE
#endif
namespace osl
{
  namespace checkmate
  {
    class CheckMove;  
    /** 
     * ;ǥΡɤȤ˥ơ֥ݻǡ
     */
    struct CheckHashRecord
    {
      ProofDisProof proofDisProof;
      /** ͤξεͤޤ finalByDominance ξ硢̤ΥΡɤmoves ؤ礬*/
      CheckMove *bestMove;
      /** Ѥؼꥹ ͤͥ۴ط¾ΥΡɤؤΥݥ󥿤ľ礬Τ */
      CheckMoveList moves;
      /** ¦ͤäȤȤѤλؼꥹ */
      CheckMoveList noPromoteMoves;
      /** ¦ǵͤäȤʳ礤ꥹ */
      CheckMoveList interposeMoves;
      /** ƤΰġήθФ˻Ȥ */
      CheckHashRecord *parent;
      // դbool ϸbit field ˤ뤳Ȥ
      /** Ȥǹήξ翿 */
      bool isConfluence;
      /** Loop γ(==λ)Ρɤǿ */
      bool isLoopOrigin;
      /** ʤ loop/dag к sum max  */
      bool useMaxInsteadOfSum;
      /** õ˽񤭴 */
      bool isVisited;
      bool dagOriginFound;
      /** Dag ʬõõֹ桤롼׸ */
      int dagFindingID;
      static int currentDagFindingID;
      /** ͥ۴طǵ/Եͤʬä˵Ͽ */
      CheckHashRecord *finalByDominance;
#ifdef CHECK_PROPAGATE_BY_DOMINANCE
      CheckHashRecordList moreProvableStates, lessProvableStates;
#endif
      CheckHashRecord() 
	: proofDisProof(makeProofDisProof(1,1)),
	  // 1,1 ͥ۴طĤʤäνͤˤʤ
	  bestMove(0), parent(0), isConfluence(false),
	  isLoopOrigin(false), useMaxInsteadOfSum(false), isVisited(false),
	  dagOriginFound(false), dagFindingID(0), finalByDominance(0)
      {
      }
    private:
      void propagateCheckMateRecursive();
      void propagateNoCheckMateRecursive();
    public:
      /** ͤλ proofDisProof ꤷͥ۴ط̤ */
      void propagateCheckMate(ProofDisProof pdp=CheckMate)
      {
	assert(getProof(pdp)==0);
	proofDisProof = pdp;
#ifdef CHECK_PROPAGATE_BY_DOMINANCE
	if (! moreProvableStates.empty())
	  propagateCheckMateRecursive();
#endif
      }
      /** Եͤλ proofDisProof ꤷͥ۴ط̤ */
      void propagateNoCheckMate(ProofDisProof pdp=NoCheckMate)
      {
	assert(getDisProof(pdp)==0);
	proofDisProof = pdp;
#ifdef CHECK_PROPAGATE_BY_DOMINANCE
	if (! lessProvableStates.empty())
	  propagateNoCheckMateRecursive();
#endif
      }
      void propagateProof(unsigned int proof);
      void propagateDisProof(unsigned int disProof);
      void propagateProofDisProof(unsigned int proof, unsigned int disProof)
      {
	proofDisProof = makeProofDisProof(proof, disProof);
#ifdef CHECK_PROPAGATE_BY_DOMINANCE
	if (proof == 0)
	{
	  propagateCheckMate(proofDisProof);
	}
	else if (disProof == 0)
	{
	  propagateNoCheckMate(proofDisProof);
	}
#  ifdef PROOF_NUMBER_PROPAGATE_BY_DOMINANCE
	else
	{
	  propagateProof(proof);
	  propagateDisProof(disProof);
	}
#  endif
#endif
      }
      /** origin --> ... --> this --> origin Ȥloop ˰Ĥ */
      void markLoop(CheckHashRecord *origin)
      {
	/** loop õĹlimit ̵¥롼פΤȤꤢк
	 * ɬפɤϸɵ */
	const int maxTraverse = 100;
	if (origin->isLoopOrigin && useMaxInsteadOfSum)
	  return;
	useMaxInsteadOfSum = true;
	origin->useMaxInsteadOfSum = true;
	origin->isLoopOrigin = true;
	assert(this != origin);
	assert(parent);
	CheckHashRecord *cur = this->parent;
	int traverse=0;
	while (cur != origin)
	{
	  assert(! cur->finalByDominance);
	  if (! cur)		// kisenCheckMate 2ܤǤ
	    return;
	  assert(cur);
	  cur->useMaxInsteadOfSum = true;
	  cur = cur->parent;
	  if (++traverse > maxTraverse)
	    return;
	}
      }
    private:
      CheckHashRecord *grandParentOfDag(bool isAttackNode, int ID);
    public:
      /** ̤ʬĴ٤ (Ĺʸ)
       * - ήľξ:
       *   ORΡɤǤϾ˿ƤéꡤANDΡɤǤϾƤȰפ礿ɤ
       * - ήľξ:
       *   ANDΡɤǤϾ˿ƤéꡤORΡɤǤȿڿƤȰפ礿ɤ
       *   ( and/or ϹΩΤ)
       * @return Ĥʤ 0
       */
      CheckHashRecord *findDagOrigin(CheckHashRecord *other, bool isAttackNode);

      /** ƤȤǧ */
      void confirmParent(CheckHashRecord *parent, bool isAttackNode)
      {
	if ((this->parent != parent) && parent)
	{
	  // root λ this->parent == 0 ǸƤФ
#if 0
	  // ήкˤäƸ/ո̤ΤפäƤ
	  /** ή򵤤ˤlimit */
	  const unsigned int disProofTolerance=100;
	  const unsigned int proofTolerance=10;
	  if ((isAttackNode
	       ? (getProof(proofDisProof) > proofTolerance)
	       : (getDisProof(proofDisProof) > disProofTolerance))
	      && (! dagOriginFound))
	  {
	    CheckHashRecord *origin 
	      = parent->findDagOrigin(this->parent, ! isAttackNode);
	    if (origin)
	    {
	      dagOriginFound = true;
	      origin->useMaxInsteadOfSum = true;
	    }
	  }
#endif
	  isConfluence = true;
	  this->parent = parent;	// 
	}
      }
    };

  } // namespace checkmate

  using checkmate::CheckHashRecord;
} // namespace osl

#endif /* _CHECKHASHRECORD_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
