#ifndef _CHECKMATE_SEARHCER_H
#define _CHECKMATE_SEARHCER_H
#include "osl/checkmate/proofDisProof.h"
#include "osl/checkmate/checkHashTable.h"
#include "osl/ptype.h"
#include "osl/move.h"
#include <cstddef>

#ifndef CHECKMATE_DEFAULT_TOTAL_NODE_LIMIT
#define CHECKMATE_DEFAULT_TOTAL_NODE_LIMIT 5000000
#endif

namespace osl
{
  namespace checkmate
  {
    class CheckMove;
    class CheckMoveList;
    class CheckHashRecord;
    /**
     * ͤߤå
     * StateEffectStateǡHashStateǤɬפϤ뤬EvalState
     * ɬפϤʤ
     * @param P ¦ץ쥤䡼
     */
    template<Player P,typename State>
    class CheckmateSearcher{
      State *state;		// acquaintance, delete ʤ
      CheckHashTable& table;
      size_t nodeCount;
      size_t totalNodeCount;
      const size_t totalNodeLimit;
      size_t searchNodeLimit;
      /** 롼к򤹤⡼ */
      bool antiLoopHack;
      bool verboseDestructor;
      void clearNodeCount(){ totalNodeCount+=nodeCount; nodeCount=0; }
    public:
      explicit CheckmateSearcher(CheckHashTable& t,
				 size_t limit=CHECKMATE_DEFAULT_TOTAL_NODE_LIMIT,
				 bool verboseDestructor=true);
      ~CheckmateSearcher();
      size_t getTotalNodeCount() const { return totalNodeCount; }
      bool verbose() const { return verboseDestructor; }
    
      /**
       * stateP̤֤ͤ
       * stateμ֤PȰפƤȤ
       * @param searchNodeLimit õnodeܰ
       * SuccessλbestMoveˤμ
       *  best μȤʤ롥
       */
      ProofDisProof hasCheckmateMove(State & state,size_t searchNodeLimit,
				     Move& bestMove);
      /**
       * statePˤäƵͤǤ̤֤
       * ΤȤǤͤˤбƤʤ
       * ꤬äƤʤˤϸƤФʤ
       * stateμ֤alt(P)ȰפƤȤ
       * statePˤäƲ꤬äƤȤ
       * @param searchNodeLimit õnodeܰ
       * @param lastMove ǤͤȽɬ
       */
      ProofDisProof hasEscapeMove(State & state,size_t searchNodeLimit,
				  Move lastMove);
      /**
       * attack¦
       * @param record ΥΡɤ CheckHashRecord Υǡ
       *   0 ʳϤ attack ǥơ֥ҤѤ
       *   0 Ϥ attack ǿ˥쥳ɤä礽Υݥ󥿤
       *   ݥ󥿤λȤʤΤ
       *   ProofDisProof  record->proofDisProof ˳ǼƵ
       * @param parent ƥΡɤΥݥ󥿡ήåѡ
       */
      void attack(unsigned int proofLimit, unsigned int disProofLimit, 
		  CheckHashRecord *parent, CheckHashRecord *& record);
      /**
       * ͤߤƨ
       * alt(P)ˤ
       * @param record ΥΡɤ CheckHashRecord Υǡ
       *   0 ʳϤ attack ǥơ֥ҤѤ
       *   0 Ϥ attack ǿ˥쥳ɤä礽Υݥ󥿤
       *   ProofDisProof  record->proofDisProof ˳ǼƵ
       */
      void defense(unsigned int proofLimit, unsigned int disProofLimit,
		   CheckHashRecord *parent, CheckHashRecord *& record);

    private:
      /**
       * attack ν: ˬ̤ǡήåǡݡʤɤԤ
       * @param record ƤӽФ0, ƤӽФϳݤǡؤΥݥ
       * @return true ʤlimit over
       */
      bool setUpAttack(unsigned int proofLimit, unsigned int disProofLimit, 
		       CheckHashRecord *parent, CheckHashRecord *& record);
      /**
       * defense ν: ˬ̤ǡήåǡݡʤɤԤ
       * @param record ƤӽФ0, ƤӽФϳݤǡؤΥݥ
       * @return true ʤlimit over
       */
      bool setUpDefense(unsigned int proofLimit, unsigned int disProofLimit, 
			CheckHashRecord *parent, CheckHashRecord *& record);

      /** ¦ move  out ˽񤭽Ф 
       * @return ο
       */
      inline size_t generateAttackMoves(Position opKingPosition, 
					CheckMoveList& out,
					CheckMoveList& noPromotionOut) const;
      /** ¦ move Ф cost ׻ */
      void computeAttackCost(Move move, int& proof, int& disproof) const;
      /** ɸ¦ move Ф cost ׻ */
      inline void computeDefenseCost(Move move, int& proof, int& disproof) const;

      /** ¦ move Ф proofNumber  disProofNumber ͽۤ */
      void estimateAttackH(Move move, unsigned int& proofNumber, unsigned int& disProofNumber) const;
      /** ɸ¦ move Ф proofNumber  disProofNumber ͽۤ */
      inline void estimateDefenseH(Move move, unsigned int& proofNumber, unsigned int& disProofNumber) const;

      /**
       * ¦ moves ̤įᡤƼ(dis)proof number 򽸷פμ bestChild ¸
       * @param confluence ûή(ηϩɤ٤Ǥʤ)äȤ˥ݥ󥿤¸
       */
      void selectBestAttackMove(CheckHashRecord *record,
				unsigned int& currentBestProofNumber,
				unsigned int& currentSecondBestProofNumber,
				unsigned int& currentDisProofNumber,
				unsigned int& currentBestDisProofNumber,
				CheckMove *& bestChild);
      /**
       * ɸ¦ moves ̤įᡤƼ(dis)proof number 򽸷פμ bestChild ¸
       * @param confluence ûή(ηϩɤ٤Ǥʤ)äȤ˥ݥ󥿤¸
       */
      void selectBestDefenseMove(CheckHashRecord *record,
				 unsigned int& currentBestDisProofNumber,
				 unsigned int& currentSecondBestDisProofNumber,
				 unsigned int& currentProofNumber,
				 unsigned int& currentBestProofNumber,
				 CheckMove *& bestChild);

    public:
      /** @return move ζ̤ΤޤΤʤޥ(ͽ) */
      int safePositionsAfterAttack(Move attack) const;
      /** @return move ζ̤ΤޤΤޥ(ͽ) */
      inline int dangerousPositionsAfterDefense(Move defense) const;
    };
  } // namespace checkmate
  using checkmate::CheckmateSearcher;
} // namespace osl
#endif // _CHECKMATE_SEARHCER_H
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
