#ifndef _CHECKMATE_SEARHCER_TCC
#define _CHECKMATE_SEARHCER_TCC

#include "osl/checkmate/checkmateSearcher.h"
#include "osl/checkmate/checkMoveList.h"
#include "osl/checkmate/checkHashRecord.h"
#include "osl/checkmate/checkMateRecorder.h"
#include "osl/checkmate/checkHashTable.h"
#include "osl/checkmate/checkMoveGenerator.h"
#include "osl/move_generator/addEffect.h"
#include "osl/move_action/store.h"
#include "osl/moveVector.h"
#include "osl/applyMove.h"
#include <algorithm>

/** root ̤ŸΤޤޤäڤ */
#define ROOT_NOEXPAND_TOL 100u
/** root ڤ */
#define ROOT_PROOF_TOL 65536ul
/** root ڤȿڿ */
#define ROOT_DISPROOF_TOL 65536ul


/** dfpn+ Ȥƹ⤹ cost Ĵ */
#define ENABLE_ATTACK_COST
// #define ENABLE_DEFENSE_COST

/** ΥΡɤǥȥå򤵤ʤϰʲ */ 
// #define CHECKMATE_NO_INTERNAL_COUNT_CHECK

/** ̤ͤԵ̤ͤȤ
 * ʤ PawnCheckMate ֤٤Ȥ NoCheckMate 뤳Ȥ
 * ȡͤˤʤޤǡ⤬ʤɤޤʤŬԤ
 */
#define PAWN_CHECKMATE_SENSITIVE

/**
 * ȹήкǡήοƤ \sum  \max 
 * (Ĺʸ)
 * â(6/17)μϡʸ̤μǤϤʤ
 * ޤн褷褦ȤƤ꤬ۤʤ
 */
#define ENABLE_CONFLUENCE_HACK

namespace osl
{
  namespace checkmate
  {
    static const unsigned int toleranceForExpandFailure = 3;
  
    template<Player P,typename State> 
    struct ChildDefenseHelper
    {
      typedef CheckmateSearcher<P,State> searcher_t;
      searcher_t& searcher;
      int proofNumber, disProofNumber;
      CheckHashRecord * parent;
      CheckHashRecord *& record;
      ChildDefenseHelper(searcher_t& s,int pn, int dn,
			 CheckHashRecord *p, CheckHashRecord *&r)
	: searcher(s),proofNumber(pn),disProofNumber(dn),
	  parent(p), record(r)
      {
      }
      void operator()(Position p)
      {
	searcher.defense(proofNumber, disProofNumber, parent, record);
      }
    };

    template<Player P,typename State> 
    struct ChildAttackHelper
    {
      typedef CheckmateSearcher<P,State> searcher_t;
      searcher_t& searcher;
      int proofNumber, disProofNumber;
      CheckHashRecord * parent;
      CheckHashRecord *& record;
      ChildAttackHelper(searcher_t& s,int pn, int dn,
			CheckHashRecord *p, CheckHashRecord *&r)
	: searcher(s),proofNumber(pn),disProofNumber(dn),
	  parent(p), record(r)
      {
      }
      void operator()(Position p)
      {
	searcher.attack(proofNumber,disProofNumber,parent,record);
      }
    };

    template<Player P,typename State>
    CheckmateSearcher<P,State>::
    CheckmateSearcher(CheckHashTable& t, size_t limit, bool verbose)
      : table(t), nodeCount(0), totalNodeCount(0), totalNodeLimit(limit),
	searchNodeLimit(0), antiLoopHack(false), verboseDestructor(verbose)
    {
      assert(t.getAttacker() == P);
    }

    template<Player P,typename State>
    CheckmateSearcher<P,State>::~CheckmateSearcher()
    {
      clearNodeCount();
      if (verboseDestructor && totalNodeCount)
	CheckMateRecorder::stat("~CheckmateSearcher", P, table.size(), 
				totalNodeCount, totalNodeLimit);
    }

    template<Player P,typename State>
    void CheckmateSearcher<P,State>::
    estimateDefenseH(Move move, unsigned int& proofNumber, 
		     unsigned int& disProofNumber) const
    {
#if 0
      // ΤޥθĿϲɤɬפȤ
      // Ӥϰ
      disProofNumber = std::max(1, dangerousPositionsAfterDefense(move));
#endif
      /** captureϲͤ⤤ */
      if (getCapturePtype(move)!=PTYPE_EMPTY)
      {
	proofNumber=2;
	disProofNumber=1;
      }
      else if (getPtype(move)==KING)
      {
	proofNumber=1;
	disProofNumber=1;
      }
      else if (! isOffBoard(getFrom(move))
	       && state->hasEffectNotBy(alt(P),state->getPieceOnBoard(getFrom(move)),
					getTo(move)))
      {
	proofNumber=2;
	disProofNumber=1;
      }
      else
      {
	proofNumber=1;
	disProofNumber = 2;
      }
    }

    template<Player P,typename State>
    void CheckmateSearcher<P,State>::
    computeDefenseCost(Move move, int& proof, int& disProof) const
    {
      proof = 0;
      disProof = 0;
      const Position to=getTo(move);
      const Ptype capturePtype = getCapturePtype(move);

      static const signed char captureCost[PTYPE_MAX+1] = 
	{ 0, 0,			// empty, edge
	  0, -2, -2, -2,		// ppawn - psilver
	  -3, -3,			// pbishop, prook
	  0, -2, 			// king, gold
	  0, -1, -1, -2,
	  -2, -2,
	};
      // ǤȤˤȤ
      if (! state->hasEffectBy(P,to))
      {
	disProof += captureCost[capturePtype];
      }
    }

    template<Player P,typename State>
    void CheckmateSearcher<P,State>::
    estimateAttackH(Move move, unsigned int& proofNumber, unsigned int& disProofNumber) const
    {
      proofNumber = std::max(safePositionsAfterAttack(move),1);

      /** ʤ or ˤäƤߤ */
      Position from=getFrom(move);
      Position to=getTo(move);
      if (!state->hasEffectBy(alt(P),to)
	  || (isOffBoard(from) && state->hasEffectBy(P,to))
	  || (!isOffBoard(from) && state->hasEffectNotBy(P,state->getPieceOnBoard(from),to)))
      {
	disProofNumber=2;
      }
      /**  */
      else if (getCapturePtype(move)!=PTYPE_EMPTY)
      {
	Ptype capturePtype=unpromote(getCapturePtype(move));
	if ((capturePtype == SILVER)
	    || (capturePtype == GOLD))
	{
	  disProofNumber=2;
	}
	else
	{
	  proofNumber+=1;
	  disProofNumber=1;
	}
      }
      else
      {
	proofNumber+=1;
	disProofNumber=1;
      }
    }

    template<Player P,typename State>
    void CheckmateSearcher<P,State>::
    computeAttackCost(Move move, int& proof, int& disProof) const
    {
      proof = 0;
      disProof = 0;
      static const signed char sacrificeCost[PTYPE_MAX+1] = 
	{ 0, 0,			// empty, edge
	  0, 1, 1, 1,		// ppawn - psilver
	  2, 2,			// pbishop, prook
	  0, 2, 			// king, gold
	  0, 1, 1, 1,
	  2, 1,
	};
      const Position from=getFrom(move);
      const Position to=getTo(move);
      const Ptype capturePtype = getCapturePtype(move);
      // ʳǡǤȤϸ
      // 餯ƬˤʤɤǤڤ򥻥åȤˤȤʤɤ
      if ((capturePtype == PTYPE_EMPTY)
	  && state->hasEffectBy(alt(P),to))
      {
	if ((isOffBoard(from)
	     && (! state->hasEffectBy(P,to)))
	    || (!isOffBoard(from)
		&& (! state->hasEffectNotBy(P,state->getPieceOnBoard(from),to))))
	{
	  const Ptype ptype = getPtype(move);
	  proof = sacrificeCost[ptype];
	}
      }
    }

    // proof number Ʊʤdisproof number ֤ɤ
    template<Player P,typename State>
    void CheckmateSearcher<P,State>::
    selectBestAttackMove(CheckHashRecord *record,
			 unsigned int& childBestProofNumber,
			 unsigned int& childSecondBestProofNumber,
			 unsigned int& currentDisProofNumber,
			 unsigned int& childBestDisProofNumber,
			 CheckMove *& bestChild)
    {
      childBestProofNumber=BigProofNumber;
      childSecondBestProofNumber=BigProofNumber;
      currentDisProofNumber=0;
      childBestDisProofNumber=BigProofNumber;
      bestChild = 0;
      for (CheckMoveList::iterator p=record->moves.begin(); 
	   p!=record->moves.end(); ++p)
      {
	const Move move=p->move;
	unsigned int childProof, childDisProof;
	if (p->record)		// move ؤrecord
	{
	  if (p->record->isVisited)
	    record->markLoop(p->record);
	  const ProofDisProof& childProofDisProof = p->record->proofDisProof;
	  childProof=getProof(childProofDisProof);
	  childDisProof=getDisProof(childProofDisProof);
	  if (childProof==0)
	  {
	    if (! isPawnDropFoul(childProofDisProof, move))
	    {
	      // ήä̤Υ롼Ȥǵͤʬä
	      bestChild = &*p;
	      return;
	    }
	    else
	    {
	      assert(isPawnDropFoul(childProofDisProof, move));
#ifdef PAWN_CHECKMATE_SENSITIVE
	      if (childBestProofNumber>PAWN_CHECK_MATE_PROOF)
	      {
		childBestProofNumber=PAWN_CHECK_MATE_PROOF;
		childBestDisProofNumber = 0;
	      }
#endif
	      // ٤ƤμƤͤϤԵͤǤ褤
	      // currentDisProofNumber 䤵ʤˡ continue
	      continue;
	    }
	  }
	  if (antiLoopHack 
	      /* && (p->record->parent != record) */
	      && (getDisProof(record->proofDisProof) <= childDisProof))
	  {
	    record->useMaxInsteadOfSum = true;
	  }
	}
	else
	{
	  // childRecord ϿƤʤä
	  estimateAttackH(move, childProof,childDisProof);
	}
	assert(childProof != 0);
	if (childDisProof != 0)
	  p->addCost(childProof,childDisProof);

	if (childProof <= childSecondBestProofNumber)
	{
	  if ((childProof < childBestProofNumber)
	      || ((childProof == childBestProofNumber)
		  && (childDisProof < childBestDisProofNumber)))
	  {
	    bestChild=&*p;
	    childSecondBestProofNumber=childBestProofNumber;
	    childBestProofNumber=childProof;
	    childBestDisProofNumber=childDisProof;
	  }
	  else
	  {
	    childSecondBestProofNumber=childProof;
	  }
	}
#ifdef ENABLE_CONFLUENCE_HACK
	if (record->useMaxInsteadOfSum)
	  currentDisProofNumber = std::max(childDisProof, currentDisProofNumber);
	else
#endif
	  currentDisProofNumber+=childDisProof;
      }
    }

    template<Player P,typename State>
    bool CheckmateSearcher<P,State>::
    setUpAttack(unsigned int proofLimit, unsigned int disProofLimit, 
		CheckHashRecord *parent, CheckHashRecord *& record)
    {
      HashKey const& hashKey=state->getHash();
      record = table.allocate(hashKey);
      if (record->moves.empty())
      {
	// ˬ
	record->parent = parent;
	const Position opKingPosition
	  =(*state).template getKingPosition<PlayerTraits<P>::opponent>();
	/** ƨˤʤäƤʤä */
	if (state->hasEffectBy(P,opKingPosition))
	{
	  record->propagateCheckMate(NoEscape);
	  return true; // ͤ
	}
	if (isFinal(record->proofDisProof))
	{
	  CheckMateRecorder::setLeaveReason("final by dominance");
	  return true;
	}

	/** Ҷμ */
	const size_t moveSize = 
	  generateAttackMoves(opKingPosition, 
			      record->moves, record->noPromoteMoves);
	// 򤫤꤬ʤ
	if (moveSize == 0)
	{
	  record->propagateNoCheckMate(NoCheckMate);
	  return true; // Եͤ
	}
	if ((getProof(record->proofDisProof) >= proofLimit)
	    || (getDisProof(record->proofDisProof) >= disProofLimit))
	{
	  CheckMateRecorder::setLeaveReason("limit over by dominance");
	  return true;
	}
      }
      else
      {
	// ή
	record->confirmParent(parent, true);
	if (record->isVisited)
	{
	  CheckMateRecorder::setLeaveReason("loop detection in confluence");
	  return true;
	}
	const ProofDisProof& proofDisProof = record->proofDisProof;
	if (isFinal(proofDisProof))
	{
	  CheckMateRecorder::setLeaveReason("final in confluence");
	  return true;
	}
	if ((getProof(proofDisProof) >= proofLimit)
	    || (getDisProof(proofDisProof) >= disProofLimit))
	{
	  CheckMateRecorder::setLeaveReason("limit over in confluence");
	  return true;
	}
      }
      return false;
    }

    template<Player P,typename State>
    void CheckmateSearcher<P,State>::
    attack(unsigned int proofLimit, unsigned int disProofLimit, 
	   CheckHashRecord *parent, CheckHashRecord *& record)
    {
#ifndef NDEBUG
      CheckMateRecorder::Tracer tracer("attack", record, proofLimit, disProofLimit);
#endif
      nodeCount++;
    
      if (! record) 
      {
	const bool leave = setUpAttack(proofLimit, disProofLimit, parent, record);
#ifndef NDEBUG
	tracer.allocate();
#endif
	if (leave)
	  return;
      }
      else
      {
	// ơ֥ϿƤ뤳ȤǧƤ
	record->confirmParent(parent, true);
	assert(! isFinal(record->proofDisProof));
	assert(! (getProof(record->proofDisProof) >= proofLimit));
	assert(! (getDisProof(record->proofDisProof) >= disProofLimit));
      }
      assert(record);
      assert(! record->moves.empty());
      assert(! record->isVisited);
      record->isVisited = true;
      /**
       * 롼פɤ˥ơ֥Ͽ
       * Ϣ³϶ؼʤΤǡöϵͤޤʤȤˤƤ
       * ϼ¤GHI꤬(Ĺʸ򻲾ȤΤ)
       */
      record->proofDisProof = NoCheckMate;
      /**
       * childͤ update¿˵ʤȹͤΤ
       * ʲ priority queueˤɤ
       */
      for (;;)
      {
	unsigned int childBestProofNumber, childSecondBestProofNumber;
	unsigned int currentDisProofNumber, childBestDisProofNumber;
	CheckMove *& bestMove = record->bestMove;	// short alias
      
	selectBestAttackMove(record, childBestProofNumber,
			     childSecondBestProofNumber,
			     currentDisProofNumber, childBestDisProofNumber,
			     bestMove);
	if (bestMove && bestMove->record
	    && getProof(bestMove->record->proofDisProof)==0)
	{
	  record->propagateCheckMate();
	  CheckMateRecorder::setLeaveReason("checkmate found");
	  return; // ͤ
	}

	if ((childBestProofNumber == PAWN_CHECK_MATE_PROOF)
	    && (! record->noPromoteMoves.empty()))
	{
	  std::copy(record->noPromoteMoves.begin(), record->noPromoteMoves.end(),
		    std::back_inserter(record->moves));
	  record->noPromoteMoves.clear();
	  selectBestAttackMove(record, childBestProofNumber,
			       childSecondBestProofNumber,
			       currentDisProofNumber, childBestDisProofNumber,
			       bestMove);
	}
      
	if (childBestProofNumber>=proofLimit 
	    || currentDisProofNumber>=disProofLimit
	    || currentDisProofNumber==0
#ifndef CHECKMATE_NO_INTERNAL_COUNT_CHECK
	    || (nodeCount > searchNodeLimit)
	    || ((nodeCount + childBestProofNumber) > searchNodeLimit)
#endif
	  )
	{
	  assert((currentDisProofNumber<=DISPROOF_LIMIT)
		 || (CheckMateRecorder::dumpRecord
		     (*state, record, proofLimit, disProofLimit,
		      childBestProofNumber, currentDisProofNumber),0));
	  CheckMateRecorder::setLeaveReason("limit over");
	  record->propagateProofDisProof
	    (childBestProofNumber, 
	     std::min(currentDisProofNumber,DISPROOF_LIMIT));
	  return;
	}

	assert(((bestMove 
		 && ((! bestMove->record)
		     || (! isFinal(bestMove->record->proofDisProof))))
		|| (CheckMateRecorder::dumpRecord
		    (*state, record, proofLimit, disProofLimit, 
		     childBestProofNumber, currentDisProofNumber),0)));
	CheckMateRecorder::setNextMove(bestMove);
	const unsigned int nextProofLimit
	  = ((proofLimit <= childSecondBestProofNumber)
	     ? proofLimit
	     : childSecondBestProofNumber +1)
	  - bestMove->costProof;
	const unsigned int nextDisProofLimit
	  = disProofLimit-currentDisProofNumber+childBestDisProofNumber;
	ChildDefenseHelper<P,State> 
	  helper(*this, nextProofLimit, nextDisProofLimit, 
		 record, bestMove->record);
	ApplyMove<P>::doUndoMove(*state,bestMove->move,helper);
	bestMove->record->isVisited = false;
	assert(bestMove->record->isConfluence
	       || (bestMove->record->parent == record)
	       || record->finalByDominance);

	if ((getProof(bestMove->record->proofDisProof) == 0)
	    && (! isPawnDropFoul(bestMove->record->proofDisProof, 
				 bestMove->move)))
	{
	  record->propagateCheckMate();
	  CheckMateRecorder::setLeaveReason("checkmate found after move");
	  return; // ͤ
	}
	if (record->useMaxInsteadOfSum)
	  continue;
	if (! record->noPromoteMoves.empty())
	  continue;
	// bestMove Ѳͤ
	// ߤΥΡɤ (dis)proof number θ
	// useMaxInsteadOfSum  noPromoteMoves ˤбƤʤ
	if (getProof(bestMove->record->proofDisProof) == 0)
	{
	  // ͤ
	  const unsigned int newDisProofNumber
	    = currentDisProofNumber - childBestDisProofNumber;
	  if (newDisProofNumber == 0)
	  {
	    record->proofDisProof = PawnCheckMate; // propagate ΤϤäݤ
	    return;
	  }
	  if (childSecondBestProofNumber >= proofLimit)
	  {
	    record->propagateProofDisProof(childSecondBestProofNumber, 
					   newDisProofNumber);
	    CheckMateRecorder::setLeaveReason("limit over by pawn checkmate");
	    return;
	  }
	}
	else
	{
	  unsigned int childProof = getProof(bestMove->record->proofDisProof);
	  unsigned int childDisProof = getDisProof(bestMove->record->proofDisProof);
	  if (! isFinal(bestMove->record->proofDisProof))
	    bestMove->addCost(childProof, childDisProof);
	  const unsigned int newProofNumber 
	    = std::min(childProof, childSecondBestProofNumber);
	  const unsigned int newDisProofNumber
	    = std::min(currentDisProofNumber - childBestDisProofNumber
		       + childDisProof, DISPROOF_LIMIT);
	  if (((newProofNumber >= proofLimit)
	       || (newDisProofNumber >= disProofLimit))
#ifdef PAWN_CHECKMATE_SENSITIVE
	      && (newDisProofNumber!=0) // ͤɤȽƤμ򸫤ʤʬʤ
#else
	      || (newDisProofNumber==0)
#endif
	    )
	  {
	    record->propagateProofDisProof(newProofNumber, newDisProofNumber);
	    CheckMateRecorder::setLeaveReason("limit over or no checkmate after move");
	    return;
	  }
	}
      }
    }

    template<Player P,typename State>
    void CheckmateSearcher<P,State>::
    selectBestDefenseMove(CheckHashRecord *record,
			  unsigned int& childBestDisProofNumber,
			  unsigned int& childSecondBestDisProofNumber,
			  unsigned int& currentProofNumber,
			  unsigned int& childBestProofNumber,
			  CheckMove *& bestChild)
    {
      childBestDisProofNumber=BigProofNumber;
      childSecondBestDisProofNumber=BigProofNumber;
      currentProofNumber=0;
      childBestProofNumber=BigProofNumber;
      for (CheckMoveList::iterator p=record->moves.begin(); 
	   p!=record->moves.end(); ++p)
      {
	unsigned int childProof, childDisProof;
	if (p->record)
	{
	  if (p->record->isVisited)
	    record->markLoop(p->record);
	  const ProofDisProof& childProofDisProof = p->record->proofDisProof;
	  childProof=getProof(childProofDisProof);
	  childDisProof=getDisProof(childProofDisProof);
	  if (antiLoopHack 
	      /* && (p->record->parent != record) */
	      && (getProof(record->proofDisProof) <= childProof))
	  {
	    record->useMaxInsteadOfSum = true;
	  }
	}
	else
	{
	  estimateDefenseH(p->move, childProof,childDisProof);
	}
      
	if (childDisProof==0)
	{
	  // ήȤԵͤʬ礬
	  bestChild=&*p;
	  return;
	}
	if (childProof != 0)
	  p->addCost(childProof, childDisProof);

	if ((childDisProof < childBestDisProofNumber)
	    || ((childDisProof == childBestDisProofNumber)
		&& (childProof < childBestProofNumber)))
	{
	  bestChild=&*p;

	  childSecondBestDisProofNumber=childBestDisProofNumber;
	  childBestDisProofNumber=childDisProof;
	  childBestProofNumber=childProof;
	}
	else if (childDisProof < childSecondBestDisProofNumber)
	{
	  childSecondBestDisProofNumber=childDisProof;
	}
#ifdef ENABLE_CONFLUENCE_HACK
	if (record->useMaxInsteadOfSum)
	  currentProofNumber = std::max(currentProofNumber, childProof);
	else
#endif
	  currentProofNumber += childProof;
      }
    }

    template<Player P,typename State>
    bool CheckmateSearcher<P,State>::
    setUpDefense(unsigned int proofLimit, unsigned int disProofLimit, 
		 CheckHashRecord *parent, CheckHashRecord *& record)
    {
      HashKey const& hashKey=state->getHash();
      record = table.allocate(hashKey);
      if (record->moves.empty())
      {
	// ˬ
	record->parent = parent;
	const Position opKingPosition=(*state).template getKingPosition<P>();
	/** 򤫤鼫̤֤ˤʤä */
	if (state->hasEffectBy(alt(P),opKingPosition)){
	  record->propagateNoCheckMate();
	  return true; // Եͤ
	}
	if (isFinal(record->proofDisProof))
	{
	  CheckMateRecorder::setLeaveReason("final by dominance");
	  return true;
	}
	/** Ҷμ */
	const size_t moveSize = 
	  CheckMoveGenerator<P>::generateEscape(*state, record->moves, 
						record->interposeMoves,
						(record->parent 
						 ? record->parent->bestMove->move
						 : MOVE_INVALID));
#ifdef ENABLE_DEFENSE_COST
	int minCost = BigProofNumber;
	for (CheckMoveList::iterator p=record->moves.begin();
	     p!=record->moves.end(); ++p)
	{
	  int proof, disProof;
	  computeDefenseCost(p->move, proof, disProof);
	  p->costProof = proof;
	  p->costDisProof = disProof;
	  minCost = std::min(disProof, minCost);
	}
	for (CheckMoveList::iterator p=record->moves.begin();
	     p!=record->moves.end(); ++p)
	  p->costDisProof -= minCost;
#endif
	// ƨ꤬ʤ
	if (moveSize == 0) {
	  record->propagateCheckMate(NoEscape);
	  return true; // Фä
	}
	if ((getProof(record->proofDisProof) >= proofLimit)
	    || (getDisProof(record->proofDisProof) >= disProofLimit))
	{
	  CheckMateRecorder::setLeaveReason("limit over by dominance");
	  return true;
	}
      }
      else
      {
	// ή
	record->confirmParent(parent, false);
	if (record->isVisited)
	{
	  CheckMateRecorder::setLeaveReason("loop detection in confluence");
	  return true;
	}
	const ProofDisProof& proofDisProof = record->proofDisProof;
	if (isFinal(proofDisProof))
	{
	  CheckMateRecorder::setLeaveReason("final in confluence");
	  return true;
	}
	if ((getProof(proofDisProof) >= proofLimit)
	    || (getDisProof(proofDisProof) >= disProofLimit))
	{
	  CheckMateRecorder::setLeaveReason("limit over in confluence");
	  return true;
	}
      }
      return false;
    }
  
    template<Player P,typename State>
    void CheckmateSearcher<P,State>::
    defense(unsigned int proofLimit, unsigned int disProofLimit, 
	    CheckHashRecord *parent, CheckHashRecord *& record)
    {
#ifndef NDEBUG
      CheckMateRecorder::Tracer tracer("defense", record, proofLimit, disProofLimit);
#endif
      nodeCount++;

      if (! record)
      {
	const bool leave = setUpDefense(proofLimit, disProofLimit, parent, record);
#ifndef NDEBUG
	tracer.allocate();
#endif
	if (leave)
	  return;
      }
      else
      {
	// ơ֥ϿƤ뤳ȤǧƤ
	record->confirmParent(parent, false);
	assert(! isFinal(record->proofDisProof)
	       || (CheckMateRecorder::dumpRecord
		   (*state, record, proofLimit, disProofLimit,
		    0, 0),0));
	assert(! (getProof(record->proofDisProof)>proofLimit));
	assert(! (getDisProof(record->proofDisProof)>disProofLimit));
      }
      assert(record);
      assert(! record->moves.empty());
      assert(! record->isVisited);
      record->isVisited = true;
      /**
       * Ϣ³϶ؼʤΤǡöϵͤޤʤȤˤƤ
       * ϼ¤GHI꤬(Ĺʸ򻲾ȤΤ)
       */
      record->proofDisProof = NoCheckMate;
      /**
       * childͤ update¿˵ʤȹͤΤ
       * ʲ priority queueˤɤ
       */
      for (;;){
	unsigned int childBestDisProofNumber, childSecondBestDisProofNumber;
	unsigned int currentProofNumber, childBestProofNumber;
	CheckMove *& bestChild = record->bestMove; // short alias
	selectBestDefenseMove(record,
			      childBestDisProofNumber,
			      childSecondBestDisProofNumber,
			      currentProofNumber, childBestProofNumber,
			      bestChild);
	if (bestChild && bestChild->record 
	    && getDisProof(bestChild->record->proofDisProof)==0)
	{
	  record->propagateNoCheckMate();
	  CheckMateRecorder::setLeaveReason("no checkmate found");
	  return; // ͤߤʤ
	}
	if ((! bestChild) && (! record->interposeMoves.empty()))
	{
	  const CheckMove nextTry = record->interposeMoves.back();
	  record->moves.push_back(nextTry);
	  record->interposeMoves.pop_back();
	  bestChild = &record->moves.back();
	  if (bestChild->record)
	  {
	    childBestDisProofNumber = getDisProof(bestChild->record->proofDisProof);
	    childBestProofNumber = getDisProof(bestChild->record->proofDisProof);
	  }
	  else
	  {
	    childBestDisProofNumber = 1;
	    childBestProofNumber = 1;
	  }
	  childSecondBestDisProofNumber = BigProofNumber;
	  currentProofNumber = 1;
	}
	if (childBestDisProofNumber>=disProofLimit 
	    || currentProofNumber>=proofLimit
	    || currentProofNumber==0
#ifndef CHECKMATE_NO_INTERNAL_COUNT_CHECK
	    || (nodeCount > searchNodeLimit)
	    || (nodeCount + currentProofNumber > searchNodeLimit)
#endif
	  )
	{
	  assert((currentProofNumber<=PROOF_LIMIT)
		 || (CheckMateRecorder::dumpRecord
		     (*state, record, proofLimit, disProofLimit,
		      currentProofNumber, childBestDisProofNumber),0));
	  record->propagateProofDisProof(std::min(currentProofNumber,PROOF_LIMIT),
					 childBestDisProofNumber);
	  CheckMateRecorder::setLeaveReason("limit over");
	  return;
	}

	assert((bestChild || 
		(CheckMateRecorder::dumpRecord
		 (*state, record, proofLimit, disProofLimit, 
		  currentProofNumber, childBestDisProofNumber),0)));
	CheckMateRecorder::setNextMove(bestChild);
	const unsigned int nextProofLimit
	  = proofLimit-currentProofNumber+childBestProofNumber;
	const unsigned int nextDisProofLimit
	  = ((disProofLimit <= childSecondBestDisProofNumber)
	     ? disProofLimit 
	     : childSecondBestDisProofNumber +1)
	  - bestChild->costDisProof;
	ChildAttackHelper<P,State> 
	  helper(*this, nextProofLimit, nextDisProofLimit, 
		 record, bestChild->record);
	ApplyMove<PlayerTraits<P>::opponent>::doUndoMove(*state,bestChild->move,helper);
	bestChild->record->isVisited = false;
	assert(bestChild->record->isConfluence
	       || (bestChild->record->parent == record)
	       || record->finalByDominance
	       || (CheckMateRecorder::dumpRecord
		   (*state, record, proofLimit, disProofLimit,
		    nextProofLimit, nextDisProofLimit),0));
	if (getDisProof(bestChild->record->proofDisProof)==0)
	{
	  record->propagateNoCheckMate(bestChild->record->proofDisProof);
	  record->bestMove = bestChild;
	  CheckMateRecorder::setLeaveReason("no checkmate after move");
	  return; // Եͤ or 
	}
      
	if ((getProof(bestChild->record->proofDisProof)==0)
	    && (! record->interposeMoves.empty()))
	  continue;
	if (record->useMaxInsteadOfSum)
	  continue;
	// bestChild Ѳͤ
	// ߤΥΡɤ (dis)proof number θ
	// useMaxInsteadOfSum  interposeMoves ϹθƤʤ
	unsigned int childProof = getProof(bestChild->record->proofDisProof);
	unsigned int childDisProof = getDisProof(bestChild->record->proofDisProof);
	if (! isFinal(bestChild->record->proofDisProof))
	  bestChild->addCost(childProof, childDisProof);

	const unsigned int newProofNumber 
	  = std::min(currentProofNumber - childBestProofNumber 
		     + childProof, PROOF_LIMIT);
	const unsigned int newDisProofNumber
	  = std::min(childDisProof, childSecondBestDisProofNumber);
	if ((newProofNumber >= proofLimit)
	    || (newDisProofNumber >= disProofLimit)
	    || (newProofNumber==0))
	{
	  record->propagateProofDisProof(newProofNumber, newDisProofNumber);
	  CheckMateRecorder::setLeaveReason("limit over after move");
	  return;
	}
      }
    }

    template<Player P,typename State>
    ProofDisProof CheckmateSearcher<P,State>::
    hasCheckmateMove(State& s, size_t searchNodeLimit, Move& bestMove)
    {
      state = &s;
      assert(state->getTurn()==P);
      clearNodeCount();

      CheckHashRecord *record = table.find(state->getHash());
      if (record && isFinal(record->proofDisProof))
      {
	if (record->bestMove)
	  bestMove = record->bestMove->move;
	assert((getProof(record->proofDisProof) != 0) || 
	       (record->bestMove && bestMove && isValid(bestMove)));
	return record->proofDisProof;
      }
      if (totalNodeCount>totalNodeLimit)
	return CheckUnknown;

      searchNodeLimit=std::min(searchNodeLimit,totalNodeLimit-totalNodeCount);
      this->searchNodeLimit = searchNodeLimit;
      unsigned int proofNumber=1;
      unsigned int disProofNumber=1;
      if (record)
      {
	proofNumber = getProof(record->proofDisProof);
	disProofNumber = getDisProof(record->proofDisProof);
	if (record->moves.empty())
	  record = 0;
      }
      antiLoopHack = false;
      size_t continuousNoExpandLoop = 0;
      CheckMateRecorder::rootLog("hasCheckmateMove start", table.size(),
				 continuousNoExpandLoop);
      for (;;){
	const size_t nodeSizeAtRoot = table.size();
	CheckMateRecorder::setNextMove(0);
	attack(proofNumber+1, disProofNumber+1, 
	       (record ? record->parent : 0), record);
	record->isVisited = false;
	proofNumber=getProof(record->proofDisProof);
	disProofNumber=getDisProof(record->proofDisProof);
	assert(!(proofNumber==0 && disProofNumber==0));
	if (proofNumber == 0 || disProofNumber==0 
	    || (nodeCount > searchNodeLimit)
	    || (((nodeCount + proofNumber) > searchNodeLimit)
		&& ((nodeCount + disProofNumber > searchNodeLimit)))
	    || (proofNumber > ROOT_PROOF_TOL)
	    || (disProofNumber > ROOT_DISPROOF_TOL)
	    || (continuousNoExpandLoop > ROOT_NOEXPAND_TOL)
	  )
	{
	  assert(record);
	  if (record->bestMove)
	  {
	    bestMove = record->bestMove->move;
	    assert(bestMove);
	    assert(isValid(bestMove));
	  }
	  assert((proofNumber != 0) || 
		 (record->bestMove && bestMove && isValid(bestMove)));
	  clearNodeCount();
#ifdef CHECKMATE_DEBUG
	  table.confirmNoVisitedRecords();
#endif
	  return record->proofDisProof;
	}
	if (nodeSizeAtRoot == table.size())
	{
	  if (++continuousNoExpandLoop > toleranceForExpandFailure)
	    antiLoopHack = true;
	}
	else
	{
	  continuousNoExpandLoop = 0;
	}
	CheckMateRecorder::rootLog("hasCheckmateMove", table.size(),
				   continuousNoExpandLoop);
      }
    }

    template<Player P,typename State>
    ProofDisProof CheckmateSearcher<P,State>::
    hasEscapeMove(State& s, size_t searchNodeLimit, Move lastMove)
    {
      state = &s;
      assert(state->getTurn()==alt(P));
      /** õΥΡɿ0˥å */
      clearNodeCount();

      CheckHashRecord *record = table.find(state->getHash());
      if (record && isFinal(record->proofDisProof))
	return record->proofDisProof;

      /** ⤷totalNodeCounttotalNodeLimitĶUnknown֤ */
      if (totalNodeCount>totalNodeLimit)
	return CheckUnknown;
      searchNodeLimit=std::min(searchNodeLimit,totalNodeLimit-totalNodeCount);
      this->searchNodeLimit = searchNodeLimit;

      /** ꤬äƤʤ֤ǸƤФƤʤ */
      assert(state->hasEffectBy(P,(*state).template getKingPosition<PlayerTraits<P>::opponent>()));
      unsigned int proofNumber=1;
      unsigned int disProofNumber=1;
      if (record)
      {
	proofNumber = getProof(record->proofDisProof);
	disProofNumber = getDisProof(record->proofDisProof);
      }
      antiLoopHack = false;
      size_t continuousNoExpandLoop = 0;
      CheckMateRecorder::rootLog("hasEscapeMove start", table.size(),
				 continuousNoExpandLoop);
      for (;;){
	const size_t nodeSizeAtRoot = table.size();
	CheckMateRecorder::setNextMove(0);
	defense(proofNumber+1, disProofNumber+1, 
		(record ? record->parent : 0), record);
	record->isVisited = false;
	/** ξȤ0ˤʤ뤳ȤϤʤ */
	proofNumber=getProof(record->proofDisProof);
	disProofNumber=getDisProof(record->proofDisProof);
	assert(!(proofNumber==0 && disProofNumber==0));
	if (isFinal(record->proofDisProof) 
	    || (nodeCount > searchNodeLimit)
	    || (((nodeCount + proofNumber) > searchNodeLimit)
		&& ((nodeCount + disProofNumber > searchNodeLimit)))
	    || (proofNumber > ROOT_PROOF_TOL)
	    || (disProofNumber > ROOT_DISPROOF_TOL)
	    || (continuousNoExpandLoop > ROOT_NOEXPAND_TOL)
	  )
	{
	  clearNodeCount();
#ifdef CHECKMATE_DEBUG
	  table.confirmNoVisitedRecords();
#endif
	  return record->proofDisProof;
	}
	if (nodeSizeAtRoot == table.size())
	{
	  if (++continuousNoExpandLoop > toleranceForExpandFailure)
	    antiLoopHack = true;
	}
	else
	{	
	  continuousNoExpandLoop = 0;
	}
	CheckMateRecorder::rootLog("hasEscapeMove", table.size(),
				   continuousNoExpandLoop);
      }
    }

    template<Player P,typename State>
    size_t CheckmateSearcher<P,State>::
    generateAttackMoves(Position opKingPosition, 
			CheckMoveList& out,
			CheckMoveList& noPromotionOut) const
    {
      assert(out.empty());
      typedef typename State::effect_state_t effect_state_t;
      MoveVector moves;
      move_action::Store store(moves);
      move_generator::AddEffect<effect_state_t, move_action::Store>::
	generateMoves(P,*state,opKingPosition,store);

      size_t numMoves = 0;
      out.reserve(moves.size());
      for (size_t i=0; i<moves.size(); ++i)
      {
	const Ptype ptype = getPtype(moves[i]);
	const Position to = getTo(moves[i]);
	// ǲ˹Ԥɤޤʤ
	if ((ptype == KING)
	    && state->hasEffectBy(alt(P), to))
	  continue;
#ifdef PAWN_CHECKMATE_SENSITIVE
	const Position from = getFrom(moves[i]);
	if (!isOffBoard(from)
	    && ((ptype == PAWN) || (ptype == ROOK) || (ptype == BISHOP))
	    && (canPromotePosition<P>(from)
		|| canPromotePosition<P>(to)))
	{
	  noPromotionOut.push_back(CheckMove(moves[i]));
#ifdef ENABLE_ATTACK_COST
	  CheckMove& added = noPromotionOut.back();
	  int proof, disProof;
	  computeAttackCost(added.move, proof, disProof);
	  added.costProof = proof;
	  added.costDisProof = disProof;
#endif
	  continue;
	}
#endif
	if (std::find(moves.begin(), moves.begin()+i, moves[i]) 
	    == moves.begin()+i)
	{
	  ++numMoves;
	  out.push_back(CheckMove(moves[i]));
#ifdef ENABLE_ATTACK_COST
	  CheckMove& added = out.back();
	  int proof, disProof;
	  computeAttackCost(added.move, proof, disProof);
	  added.costProof = proof;
	  added.costDisProof = disProof;
#endif
	}
      }
      return numMoves;
    }


    template <Player P,class State>
    static inline void countIfSafePosition(int& count, const State& state, Position target, Move attack)
    {
      if (isEmpty(state.getPieceAt(target))
	  && (! state.hasEffectBy(P, target))
	  && (! state.hasEffectFromTo(getPtypeO(attack), getTo(attack), target)))
	++count;
    }

    template<Player P,typename State>
    int CheckmateSearcher<P,State>::
    safePositionsAfterAttack(Move attack) const
    {
      const Player defender = PlayerTraits<P>::opponent;
      assert(getPlayer(attack) == P);
      const Position kingPosition = (*state).template getKingPosition<defender>();
      // Ψϸ
      int result = 0;
      Position target = kingPosition + DirectionPlayerTraits<UL,defender>::offset;
      countIfSafePosition<P,State>(result, *state, target, attack);
      target = kingPosition + DirectionPlayerTraits<U,defender>::offset;
      countIfSafePosition<P,State>(result, *state, target, attack);
      target = kingPosition + DirectionPlayerTraits<UR,defender>::offset;
      countIfSafePosition<P,State>(result, *state, target, attack);
      target = kingPosition + DirectionPlayerTraits<L,defender>::offset;
      countIfSafePosition<P,State>(result, *state, target, attack);
      target = kingPosition + DirectionPlayerTraits<R,defender>::offset;
      countIfSafePosition<P,State>(result, *state, target, attack);
      target = kingPosition + DirectionPlayerTraits<DL,defender>::offset;
      countIfSafePosition<P,State>(result, *state, target, attack);
      target = kingPosition + DirectionPlayerTraits<D,defender>::offset;
      countIfSafePosition<P,State>(result, *state, target, attack);
      target = kingPosition + DirectionPlayerTraits<DR,defender>::offset;
      countIfSafePosition<P,State>(result, *state, target, attack);
#if 1
      // Ϥ뤬®ʤ¿
      if (state->hasEffectNotBy(defender, state->getPieceOnBoard(kingPosition),
				getTo(attack)))
	++result;
#endif
      return result;
    }
  
    template <Player P,class State>
    static inline void countIfDangerousPosition(int& count, const State& state, 
						Position target, Piece captured)
    {
      const Piece p = state.getPieceOnBoard(target);
      const Player defender = PlayerTraits<P>::opponent;

      // Ψϸ
      if (isEmpty(p) || (getOwner(p) == defender))
      {
	if (isEmpty(captured))
	{
	  if (state.hasEffectBy(alt(defender), target))
	    ++count;
	}
	else
	{
	  if (state.hasEffectNotBy(alt(defender), captured, target))
	    ++count;
	}
      }
    
    }

    template<Player P,typename State>
    int CheckmateSearcher<P,State>::
    dangerousPositionsAfterDefense(Move defense) const
    {
      const Player defender = PlayerTraits<P>::opponent;
      assert(getPlayer(defense) == defender);
      const Position kingPosition = 
	(getPtype(defense) == KING)
	? getTo(defense)
	: (*state).template getKingPosition<defender>();
      // Ψϸ
      const Piece captured = state->getPieceOnBoard(getTo(defense));
      int result = 0;
      Position target = kingPosition + DirectionPlayerTraits<UL,defender>::offset;
      countIfDangerousPosition<P,State>(result, *state, target, captured);
      target = kingPosition + DirectionPlayerTraits<U,defender>::offset;
      countIfDangerousPosition<P,State>(result, *state, target, captured);
      target = kingPosition + DirectionPlayerTraits<UR,defender>::offset;
      countIfDangerousPosition<P,State>(result, *state, target, captured);
      target = kingPosition + DirectionPlayerTraits<L,defender>::offset;
      countIfDangerousPosition<P,State>(result, *state, target, captured);
      target = kingPosition + DirectionPlayerTraits<R,defender>::offset;
      countIfDangerousPosition<P,State>(result, *state, target, captured);
      target = kingPosition + DirectionPlayerTraits<DL,defender>::offset;
      countIfDangerousPosition<P,State>(result, *state, target, captured);
      target = kingPosition + DirectionPlayerTraits<D,defender>::offset;
      countIfDangerousPosition<P,State>(result, *state, target, captured);
      target = kingPosition + DirectionPlayerTraits<DR,defender>::offset;
      countIfDangerousPosition<P,State>(result, *state, target, captured);
      return result;
    }
  } // namespace checkmate
} // namespace osl

#endif /* _CHECKMATE_SEARHCER_TCC */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
