/* dualCheckMateSearcher.tcc
 */
#ifndef _DUALCHECKMATESEARCHER_TCC
#define _DUALCHECKMATESEARCHER_TCC

#include "osl/checkmate/dualCheckMateSearcher.h"
#include <iostream>
#include <iomanip>
namespace osl
{
  namespace checkmate
  {
    
    template <class State>
    DualCheckMateSearcher<State>::DualCheckMateSearcher(size_t totalNodeCount,
							bool verboseDestructor)
      : tableBlack(BLACK), tableWhite(WHITE),
	checkmateBlack(tableBlack,totalNodeCount,verboseDestructor), 
	checkmateWhite(tableWhite,totalNodeCount,verboseDestructor),
	blackOracles(BLACK), blackOraclesAfterAttack(BLACK),
	whiteOracles(WHITE), whiteOraclesAfterAttack(WHITE),
	proofByOracle(0), unknownByOracle(0),
	proofBySearch(0), unknownBySearch(0), disProofBySearch(0)
    {
    }
    template <class State>
    DualCheckMateSearcher<State>::~DualCheckMateSearcher()
    {
      if (checkmateBlack.verbose() && (blackOracles.size() > 1))
      {
	std::cerr << "oracle p " << std::setw(5) << proofByOracle 
		  << " u " << std::setw(5) << unknownByOracle << "\n";
	std::cerr << "search p " << std::setw(5) << proofBySearch
		  << " u " << std::setw(5) << unknownBySearch 
		  << " d " << std::setw(5) << disProofBySearch << "\n";
	std::cerr << "oracles " << blackOracles.size() << " "
		  << blackOraclesAfterAttack.size() << " "
		  << whiteOracles.size() << " "
		  << whiteOraclesAfterAttack.size() << "\n";
      }
    }
  } // namespace checkmate
} // namespace osl

#endif /* _DUALCHECKMATESEARCHER_TCC */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
