/* oraclePool.h
 */
#ifndef _ORACLEPOOL_H
#define _ORACLEPOOL_H

#include "osl/position.h"
#include "osl/player.h"
#include <boost/scoped_ptr.hpp>
#include <cstddef>

namespace osl
{
  class PawnMaskState;

  namespace checkmate
  {
    class CheckHashRecord;
    class OraclePool
    {
      class Table;
      boost::scoped_ptr<Table> oracles;
    public:
      explicit OraclePool(Player attacker);
      ~OraclePool();

      void addOracle(const PawnMaskState&, const CheckHashRecord*);
      const CheckHashRecord *findOracle(const PawnMaskState&) const;
      size_t size() const;
    };

  } // namespace checkmate
} // namespace osl

#endif /* _ORACLEPOOL_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
