/* oracleProver.h
 */
#ifndef _ORACLEPROVER_TCC
#define _ORACLEPROVER_TCC

#include "osl/checkmate/checkHashTable.h"
#include "osl/checkmate/checkMoveGenerator.h"
#include "osl/applyMove.h"

// ͤϤ depth first search ʤΤ loop кϤʤɤ
// Ƥ뤬ȹͤƤʤ

// capture ̵ͭ餤äƤɤȻפ

// Ѿ: parent->record != 0 λϻҶΡɤμλƤ뤳
namespace osl
{
  namespace checkmate
  {
    template <Player P, class State>
    bool OracleProver<P,State>::proofWin(State& state, ProofOracleAttack oracle, 
					 Move& bestMove)
    {
      if (! oracle.isValid())
	return false;
      assert(state.getTurn() == P);
      this->state = &state;
      CheckHashRecord *record = 0;
      attack(record, oracle);
      if (record && isCheckmateSuccess(record->proofDisProof))
      {
	if (record->bestMove)
	{
	  bestMove = record->bestMove->move;
	  assert(bestMove);
	  assert(isValid(bestMove));
	  assert(getPlayer(bestMove) == P);
	  return true;
	}
	// ͤߤ record->bestMove ʤȤΤϤɤʻ?
	// ǰΤԵͰ
	return false;
      }
      return false;
    }

    template <Player P, class State>
    bool OracleProver<P,State>::proofLose(State& state, ProofOracleDefense oracle)
    {
      if (! oracle.isValid())
	return false;
      assert(state.getTurn() == alt(P));
      this->state = &state;
      CheckHashRecord *record = 0;

      defense(record, oracle);
      if (record && isCheckmateSuccess(record->proofDisProof))
      {
	return true;
      }
      return false;
    }

    /**
     * OracleProver::defense Ƥhelper
     */
    template <Player P, class State>
    struct OracleProverDefense
    {
      OracleProver<P,State> *prover;
      CheckHashRecord *& record;
      ProofOracleDefense oracle;
      OracleProverDefense(OracleProver<P,State> *p, 
			  CheckHashRecord *&r, ProofOracleDefense o)
	: prover(p), record(r), oracle(o)
      {
      }
      void operator()(Position)
      {
	prover->defense(record, oracle);
      }
    };

    template <Player P, class State>
    void OracleProver<P,State>::attack(CheckHashRecord *& record, 
				       ProofOracleAttack oracle)
    {
      assert(oracle.isValid());
      if (! record)
      {
	record = table.allocate(state->getHash());
	if (! record)
	  return;
      }
      if (isFinal(record->proofDisProof))
	return;

      const Position targetKingPosition
	=(*state).template getKingPosition<PlayerTraits<P>::opponent>();
      /** ƨˤʤäƤʤä */
      if (state->hasEffectBy(P,targetKingPosition))
      {
	record->proofDisProof = NoEscape;
	return;
      }

      const Move checkMove = oracle.oracle();
      if ((checkMove == MOVE_INVALID)
	  || (! (*state).template isAlmostValidMove<false>(checkMove)))
      {
	record = 0;
	return;
      }

      if (record->moves.empty())
      {
	record->moves.push_back(CheckMove(checkMove));
	record->bestMove = &record->moves.back();
      }
      else
      {
	for (CheckMoveList::iterator p=record->moves.begin(); 
	     p!=record->moves.end(); ++p)
	{
	  if (p->move == checkMove)
	  {
	    record->bestMove = &*p;
	    break;
	  }
	}
	for (CheckMoveList::iterator p=record->noPromoteMoves.begin(); 
	     p!=record->noPromoteMoves.end(); ++p)
	{
	  if (p->move == checkMove)
	  {
	    record->moves.push_back(CheckMove(checkMove));
	    record->bestMove = &record->moves.back();
	    record->noPromoteMoves.erase(p);
	    break;
	  }
	}
	record = 0;		// ˡʲǤʤä
	return;
      }
      ProofOracleDefense newOracle = oracle.expandOracle();
      OracleProverDefense<P,State> 
	oracleProver(this, record->bestMove->record, newOracle);
      ApplyMove<P>::doUndoMove(*state, checkMove,oracleProver);
      if (record->bestMove->record
	  && isCheckmateSuccess(record->bestMove->record->proofDisProof)
	  && (! isPawnDropFoul(record->bestMove->record->proofDisProof, checkMove)))
      {
	// oracle  attack ǵͤμĤƤȤ
	// ̾ϸŪȤǵ;ƤGHI꤬뤫⤷ʤ
	// ɤʬʤ
	record->proofDisProof = CheckMate;
	return;
      }

      record->moves.clear();	// CheckmateSearcher ǲƼ򤹤
      record->bestMove = 0;
      record = 0;
      return;
    }

    /**
     * OracleProver::attack Ƥhelper
     */
    template <Player P, class State>
    struct OracleProverAttack
    {
      OracleProver<P,State> *prover;
      CheckHashRecord *& record;
      ProofOracleAttack oracle;
      OracleProverAttack(OracleProver<P,State> *p, 
			 CheckHashRecord *&r, ProofOracleAttack o)
	: prover(p), record(r), oracle(o)
      {
      }
      void operator()(Position)
      {
	prover->attack(record, oracle);
      }
    };

    template <Player P, class State>
    void OracleProver<P,State>::defense(CheckHashRecord *& record,
					ProofOracleDefense oracle)
    {
      if (! record)
      {
	record = table.allocate(state->getHash());
	if (! record)
	  return;
      }
      if (isFinal(record->proofDisProof))
	return;

      const Position attackKingPosition=(*state).template getKingPosition<P>();
      const Position defenseKingPosition=(*state).template getKingPosition<PlayerTraits<P>::opponent>();
      // 򤫤鼫̤ or ˤʤäƤʤä
      if (state->hasEffectBy(alt(P),attackKingPosition)
	  || (! state->hasEffectBy(P,defenseKingPosition)))
      {
	record = 0;
	return;
      }

      if (record->moves.empty())
      {
	const size_t moveSize
	  = CheckMoveGenerator<P>::generateEscape
	  (*state, record->moves, record->interposeMoves);
	if (moveSize == 0) 
	{
	  record->proofDisProof = NoEscape;
	  return;
	}
      }
      if (! oracle.isValid())
      {
	record = 0;
	return;
      }
      record->proofDisProof = makeProofDisProof(record->moves.size(), 1);
    examine_moves:
      for (CheckMoveList::iterator p=record->moves.begin(); 
	   p!=record->moves.end(); ++p)
      {
	ProofOracleAttack newOracle = oracle.expandOracle(p->move);
	if (! newOracle.isValid())
	  return;
	OracleProverAttack<P,State> 
	  oracleProver(this, p->record, newOracle);
	ApplyMove<PlayerTraits<P>::opponent>::doUndoMove(*state, p->move,oracleProver);
	if (! (p->record && isCheckmateSuccess(p->record->proofDisProof)))
	{
	  p->record = 0;
	  return;			// TODO: proof number 򸺤餷Ƥ
	}
      }
      if (! record->interposeMoves.empty())
      {
	std::copy(record->interposeMoves.begin(), record->interposeMoves.end(),
		  std::back_inserter(record->moves));
	record->interposeMoves.clear();
	goto examine_moves;
      }
      record->proofDisProof = CheckMate;
      return;
    }
  } // namespace checkmate
} // namespace osl

#endif /* _ORACLEPROVER_TCC */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
