#ifndef _PROOF_DISPROOF_H
#define _PROOF_DISPROOF_H

#include "osl/move.h"
#include <cassert>
#include <iosfwd>
namespace osl
{
  namespace checkmate
  {
    /**
     * (proof number)ȿڿ(disproof number)
     * ͤ߶̤ȳꤷ proofNumber=0
     * Եͤ߶̤ȳꤷ disProofNumber=0
     */
#if 0
#  define PROOF_SHIFT 16
#  define DISPROOF_MASK 0xffffu
#  define NO_ESCAPE_DISPROOF 0xffffu
#  define CHECK_MATE_DISPROOF 0xfffeu
#  define NO_CHECK_MATE_PROOF 0xffffu
#  define PAWN_CHECK_MATE_PROOF 0xfffeu
#  define PROOF_MAX 0xffffu
#  define DISPROOF_MAX 0xffffu
#  define PROOF_LIMIT 0xfffdu
#  define DISPROOF_LIMIT 0xfffdu
    typedef unsigned int pdp_t;
#else
#  define PROOF_SHIFT 32l
#  define DISPROOF_MASK 0xffffffffu
#  define NO_ESCAPE_DISPROOF 0xffffffffu
#  define CHECK_MATE_DISPROOF 0xfffffffeu
#  define NO_CHECK_MATE_PROOF 0xffffffffu
#  define PAWN_CHECK_MATE_PROOF 0xfffffffeu
#  define PROOF_MAX 0xffffffffu
#  define DISPROOF_MAX 0xffffffffu
#  define PROOF_LIMIT 0xfffffffdu
#  define DISPROOF_LIMIT 0xfffffffdu
    typedef unsigned long long pdp_t;
#endif
#define MK_PROOF_DISPROOF(proof,disProof) ((static_cast<pdp_t>(proof)<<PROOF_SHIFT)|static_cast<pdp_t>(disProof))
#if 1
    enum ProofDisProof{
      CheckMate=MK_PROOF_DISPROOF(0,CHECK_MATE_DISPROOF),
      NoEscape=MK_PROOF_DISPROOF(0,NO_ESCAPE_DISPROOF),
      NoCheckMate=MK_PROOF_DISPROOF(NO_CHECK_MATE_PROOF,0),
      PawnCheckMate=MK_PROOF_DISPROOF(PAWN_CHECK_MATE_PROOF,0),
      CheckUnknown=MK_PROOF_DISPROOF(1,1),
    };
#else
    typedef pdp_t ProofDisProof;
    const ProofDisProof CheckMate=MK_PROOF_DISPROOF(0,CHECK_MATE_DISPROOF);
    const ProofDisProof NoEscape=MK_PROOF_DISPROOF(0,NO_ESCAPE_DISPROOF);
    const ProofDisProof NoCheckMate=MK_PROOF_DISPROOF(NO_CHECK_MATE_PROOF,0);
    const ProofDisProof PawnCheckMate=MK_PROOF_DISPROOF(PAWN_CHECK_MATE_PROOF,0);
    const ProofDisProof CheckUnknown=MK_PROOF_DISPROOF(1,1);
#endif
    const unsigned int BigProofNumber=PROOF_MAX;
  
    inline ProofDisProof makeProofDisProof(unsigned int proof, unsigned int disProof){
      assert(proof<=PROOF_MAX);
      assert(disProof<=DISPROOF_MAX);
      assert(!(proof==0 && disProof==0));
      return static_cast<ProofDisProof>(MK_PROOF_DISPROOF(proof,disProof));
    }
    inline unsigned int getProof(ProofDisProof proofDisProof){
      return static_cast<pdp_t>(proofDisProof)>>PROOF_SHIFT;
    }
    inline unsigned int getDisProof(ProofDisProof proofDisProof){
      return static_cast<pdp_t>(proofDisProof)&DISPROOF_MASK;
    }
    inline bool isCheckmateSuccess(ProofDisProof proofDisProof){
#if 0
      return static_cast<pdp_t>(proofDisProof)<=CheckMate;
#else
      return getProof(proofDisProof)==0;
#endif
    }
    inline bool isCheckmateFail(ProofDisProof proofDisProof){
      return (static_cast<pdp_t>(proofDisProof)&DISPROOF_MASK)==0;
    }
    inline bool isFinal(ProofDisProof proofDisProof){
      return isCheckmateSuccess(proofDisProof) ||
	isCheckmateFail(proofDisProof);
    }
    inline bool isUnknown(ProofDisProof proofDisProof){
      return !isFinal(proofDisProof);
    }

    /** ͤʤ鿿 */
    inline bool isPawnDropFoul(const ProofDisProof& pdp, Move move)
    {
      return (pdp==NoEscape) 
	&& isOffBoard(getFrom(move))
	&& getPtype(move)==PAWN;
    }

    std::ostream& operator<<(std::ostream& os,const ProofDisProof proofDisProof);
  } // namespace checkmate

  using checkmate::NoCheckMate;
  using checkmate::isFinal;
  using checkmate::CheckMate;
  using checkmate::PawnCheckMate;
  using checkmate::getProof;
  using checkmate::getDisProof;
  using checkmate::ProofDisProof;
} // namespace osl
#endif // _PROOF_DISPROOF_H
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
