/* proofOracle.h
 */
#ifndef _PROOFORACLE_H
#define _PROOFORACLE_H

#include "osl/checkmate/checkHashRecord.h"
#include <cstddef>
#include <cassert>
namespace osl
{
  namespace checkmate
  {
    struct ProofOracleDefense;
  
    /**
     * ;Ǥ ()
     * OracleProver 侭Ūˤ CheckmateSearcher 
     */
    struct ProofOracleAttack
    {
      const CheckHashRecord *guide;
      explicit ProofOracleAttack(const CheckHashRecord *g=0) : guide(g)
      {
	assert((!guide) || isCheckmateSuccess(guide->proofDisProof));
      }
      Move oracle() 
      {
	assert(guide);
	return (guide->bestMove ? guide->bestMove->move : MOVE_INVALID);
      }
      inline ProofOracleDefense expandOracle();
      bool isValid() const { return guide && (! guide->finalByDominance); }
    };

    /**
     * ;Ǥ ()
     * OracleProver 侭Ūˤ CheckmateSearcher 
     */
    struct ProofOracleDefense
    {
      const CheckHashRecord *guide;
      explicit ProofOracleDefense(const CheckHashRecord *g=0) : guide(g)
      {
	assert((!guide) || isCheckmateSuccess(guide->proofDisProof));
      }
      /** bestMove θ˼ defense 򤷤Ȥoracle */
      ProofOracleAttack expandOracle(Move defense)
      {
	assert(guide);
	for (CheckMoveList::const_iterator p=guide->moves.begin();
	     p!=guide->moves.end(); ++p)
	{
	  if (p->move == defense)
	  {
	    if (isCheckmateSuccess(guide->proofDisProof))
	      return ProofOracleAttack(p->record);
	    return ProofOracleAttack(0);
	  }
	}
	return ProofOracleAttack(0);
      }
      bool isValid() const { return guide && (! guide->finalByDominance); }
    };

    inline ProofOracleDefense ProofOracleAttack::expandOracle()
    {
      assert(guide);
      return ProofOracleDefense(guide->bestMove->record);
    }
  } // namespace checkmate
} // namespace osl

#endif /* _PROOFORACLE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
