#ifndef _CSA_TIME_H
#define _CSA_TIME_H
#include <sys/time.h>
#include <sstream>

namespace osl{
  class CsaTime{
    timeval start , opmove , mymove;
    long mytimeleft , optimeleft;
  public:
    CsaTime( long timeleft ) : mytimeleft(timeleft) , optimeleft(timeleft){
      gettimeofday( &start , 0 );
      mymove=opmove=start;
    }
    long makeOpMove(){
      gettimeofday( &opmove , 0 );
      long ret = opmove.tv_sec - mymove.tv_sec;
      if( opmove.tv_usec < mymove.tv_usec ){ ret--; }
      if( ret == 0 ){ ret = 1; }
      optimeleft -= ret;
      return ret;
    }
    long makeMyMove(){
      gettimeofday( &mymove , 0 );
      long ret = mymove.tv_sec - opmove.tv_sec;
      if( mymove.tv_usec < opmove.tv_usec ){ ret--; }
      if( ret == 0 ){ ret = 1; }
      mytimeleft -= ret;
      return ret;
    }
    long getMyLeft(){ return mytimeleft; }
    long getOpLeft(){ return optimeleft; }
    std::string getStart(){
      std::ostringstream oss;
      oss << start.tv_sec;
      return oss.str();
    }
  };
}
#endif //_CSA_TIME
