/* doUndoMoveStack.h
 */
#ifndef _DOUNDOMOVESTACK_H
#define _DOUNDOMOVESTACK_H

#include "osl/move.h"
#include "osl/doUndoMoveLock.h"
#include <stack>

namespace osl
{
  template <class State>
  class DoUndoMoveStack
  {
    std::stack<DoUndoMoveLock*> moveStack;
  public:
    ~DoUndoMoveStack()
    {
      clear();
    }
    void push(State& s, Move m)
    {
      DoUndoMoveLock *l = new DoUndoMoveLock(s, m);
      moveStack.push(l);
    }
    void pop()
    {
      DoUndoMoveLock *l = moveStack.top();
      delete l;
      moveStack.pop();
    }
    void clear()
    {
      while (! moveStack.empty())
	pop();
    }
  };
    
}

#endif /* _DOUNDOMOVESTACK_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
