#ifndef _EFFECTUTIL_H
#define _EFFECTUTIL_H

#include "osl/piece.h"
#include "osl/position.h"
#include "osl/move.h"

#include <iosfwd>
#include <cassert>

namespace osl
{
  class SimpleState;

  /**
   * EffectState Ѥ뤿Υ᥽å
   * NumSimpleEffect ʤɤθ󥿡ե
   * Ȥäƽ񤱤륳
   */
  struct EffectUtil
  {
    /**
     * effectTarget ΤäȤ¤õ
     * @return ޤϡ̵ PIECE_EMPTY ֤
     * @param P õоݤζνͭ
     * @param effectTarget on board Ǥ뤳
     */
    template <class EffectState>
    static Piece cheapestPiece(Player P, const EffectState&, 
			       Position effectTarget);
    /**
     * pos Τ promote ǽ ptype Ķõ
     * pos  promote ǽʥޥɤϸʤ
     * @return ޤϡ̵ PIECE_EMPTY ֤
     * @param P õоݤζνͭ
     * @param effectTarget on board Ǥ뤳
     */
    template <class EffectState>
    static Piece promotablePiece(Player P, const EffectState&, 
				 Position effectTarget);


    /** 
     * Player P βŨ뤫ɤĴ٤
     */
    template <class EffectState>
    static bool isKingInCheck(Player P, const EffectState& state)
    {
      const Position kingPosition=state.getKingPosition(P);
      return state.hasEffectBy(alt(P), kingPosition);
    }
    /** 
     * target ˤɽ
     */
    template <class EffectState>
    static void showEffect(const EffectState& state, Position target,
			   std::ostream&);

    /**
     * Move m ؤ(open ) Position  f Ϥ
     * ĹϼʬưαƤ˼⤵Τ˻ߤޤ
     * @param interestEmpty Υޥ˶̣뤫
     */
    template <class State, class Function, bool interestEmpty>
    static void forEachEffectOfMove(const State& state, Move m, Function& f);
    template <class State, class Function>
    static void forEachEffectPositionOfMove(const State& state, Move m, Function& f)
    {
      forEachEffectOfMove<State,Function,true>(state, m, f);
    }
    template <class State, class Function>
    static void forEachEffectPieceOfMove(const State& state, Move m, Function& f)
    {
      forEachEffectOfMove<State,Function,false>(state, m, f);
    }
    
    /**
     * Move m ؤΡPlayer target ζؤ(open )
     * Ĵ٤(KING ʳ)Ǥͤι⤤֤
     * ̵ PIECE_EMPTY ֤
     */
    static Piece mostValuableEffectOfMoveNotKing(Player target, 
						 const SimpleState& state, Move m);

    /**
     * forEachEffect  Player template ̾ΰˤС
     * @param P õоݤζνͭ
     * @param pos Τõ
     */
    template <class EffectState, class Action>
    static void forEachEffect(Player P, const EffectState& state, Position pos, 
			      Action& a)
    {
      if (P == BLACK)
	state.template forEachEffect<BLACK>(pos,a);
      else
	state.template forEachEffect<WHITE>(pos,a);
    }

    class SelectMostValuable;
  };

  
} // namespace osl

#endif /* _EFFECTUTIL_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
