#ifndef _ALWAYS_MOVE_ACTION
#define _ALWAYS_MOVE_ACTION
#include "osl/player.h"
#include "osl/ptype.h"
#include "osl/piece.h"
#include "osl/move_action/concept.h"

namespace osl
{
  namespace effect_action
  {
    /**
     * Ƥλؼ
     */
    template<class State,class Action>
    class AlwaysMove
    {
      BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
    private:
      const State& state;
      Action& ac;
    public:
      AlwaysMove(const State& s, Action & a) : state(s), ac(a) {}
      /**
       * PtypetemplateˤǤ
       */
      template<Player P,Ptype Type>
      void doActionPtype(Piece p1,Position to){
	Position from=getPosition(p1); 
	if(canPromote(Type) &&
	   !isPromoted(p1) &&
	   (canPromotePosition<P>(to) || canPromotePosition<P>(from))){
	  ac.unknownMove(from,to,state.getPieceAt(to),promote(Type),true,P);
	}
	if(!canPromote(Type) ||
	   PtypePlayerTraits<Type,P>::canDropTo(to) ||
	   isPromoted(p1)){
	  ac.unknownMove(from,to,state.getPieceAt(to),getPtype(p1),false,P);
	}
      }
      /**
       * PtypetemplateˤǤʤ
       */
      template<Player P>
      void doAction(Piece p1,Position to){
	Position from=getPosition(p1); 
	Ptype ptype=getPtype(p1);
	if(canPromote(ptype)){
	  if (canPromotePosition<P>(to)){
	    ac.unknownMove(from,to,state.getPieceAt(to),promote(ptype),true,P);
	    if(canDropTo<P>(ptype,to)){
	      ac.unknownMove(from,to,state.getPieceAt(to),ptype,false,P);
	    }
	  }
	  else if (canPromotePosition<P>(from)){
	    ac.unknownMove(from,to,state.getPieceAt(to),promote(ptype),true,P);
	    ac.unknownMove(from,to,state.getPieceAt(to),ptype,false,P);
	  }
	  else{
	    ac.unknownMove(from,to,state.getPieceAt(to),ptype,false,P);
	  }
	}
	else{
	  ac.unknownMove(from,to,state.getPieceAt(to),ptype,false,P);
	}
      }
      bool done() const{ return false; }
    };
  } // namespace effect_action
} // namespace osl
#endif // _ALWAYS_MOVE_ACTION
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
