#ifndef _SIMPLE_ALWAYS_MOVE_ACTION_H
#define _SIMPLE_ALWAYS_MOVE_ACTION_H
#include "osl/piece.h"
#include "osl/position.h"
#include "osl/move_action/concept.h"

namespace osl
{
  namespace effect_action
  {
    /**
     * ʤȤ
     */
    template <class Action>
    class SimpleMove
    {
      BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
    private:
      Action & ac;
    public:
      SimpleMove(Action & a) :ac(a){}
      template<Player P,Ptype Type>
      void doActionPtype(Piece p1,Position to){
	Position from=getPosition(p1); 
	if(canPromote(Type) &&
	   !isPromoted(p1) &&
	   (canPromotePosition<P>(to) || canPromotePosition<P>(from))){
	  ac.simpleMove(from,to,promote(Type),true,P);
	}
	if(!canPromote(Type) ||
	   PtypePlayerTraits<Type,P>::canDropTo(to) ||
	   isPromoted(p1)){
	  ac.simpleMove(from,to,getPtype(p1),false,P);
	}
      }
      template<Player P>
      void doAction(Piece p1,Position to){
	Position from=getPosition(p1); 
	Ptype ptype=getPtype(p1);
	if(canPromote(ptype)){
	  if (canPromotePosition<P>(to)){
	    ac.simpleMove(from,to,promote(ptype),true,P);
	    if(canDropTo<P>(ptype,to)){
	      ac.simpleMove(from,to,ptype,false,P);
	    }
	  }
	  else if (canPromotePosition<P>(from)){
	    ac.simpleMove(from,to,promote(ptype),true,P);
	    ac.simpleMove(from,to,ptype,false,P);
	  }
	  else{
	    ac.simpleMove(from,to,ptype,false,P);
	  }
	}
	else{
	  ac.simpleMove(from,to,ptype,false,P);
	}
      }
      bool done() const{ return false;}
    };
  } // namespace effect_action
} // namespace osl
#endif
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
