/* evalTraits.h
 */
#ifndef _EVAL_TRAITS_H
#define _EVAL_TRAITS_H

#include "osl/player.h"
#include <algorithm>
namespace osl
{
  template<Player P>
  struct EvalTraits;

  template<>
  struct EvalTraits<BLACK>
  {
    static const int delta=1;
    // minusInfty become specific to Evaluation class
    static inline int max(int v1,int v2){ return std::max(v1,v2); }
    static inline int min(int v1,int v2){ return std::min(v1,v2); }

    static inline bool betterThan(int v1,int v2) 
    {
      return v1 > v2;
    }
    static inline bool notLessThan(int v1,int v2) {
      return v1 >= v2;
    }
  };

  template<>
  struct EvalTraits<WHITE>
  {
    static const int delta=-1;
    static inline int max(int v1,int v2){ return std::min(v1,v2); }
    static inline int min(int v1,int v2){ return std::max(v1,v2); }

    static inline bool betterThan(int v1,int v2) 
    {
      return v1 < v2;
    }
    static inline bool notLessThan(int v1,int v2) 
    {
      return v1 <= v2;
    }
  };

  inline bool betterThan(Player p, int v1,int v2)
  {
    if (p == BLACK)
      return EvalTraits<BLACK>::betterThan(v1,v2);
    else
      return EvalTraits<WHITE>::betterThan(v1,v2);
  }
  inline bool notLessThan(Player p, int v1,int v2)
  {
    if (p == BLACK)
      return EvalTraits<BLACK>::notLessThan(v1,v2);
    else
      return EvalTraits<WHITE>::notLessThan(v1,v2);
  }

} // namespace osl

#endif /* _EVAL_TRAITS_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
