#ifndef _MOVELOGPROB_H
#define _MOVELOGPROB_H

#include "osl/move.h"
#include <iosfwd>

namespace osl
{
  class MoveLogProb{
    Move move;
    int logProb;
  public:
    MoveLogProb(Move m,int l) :move(m),logProb(l)
    {
      assert(isValid(m));
    }
    MoveLogProb() : move(MOVE_INVALID), logProb(0) {}

    void setLogProb(int l)  { logProb=l; }
    /** 
     * logProb  l ˤ
     * ΨȤƤϡ⤹Ψξ硤l 
     */
    void setLogProbAtLeast(int l)  
    { 
      if (logProb < l)
	setLogProb(l);
    }
    /** 
     * logProb ǹ l ˤ
     * ΨȤƤϡ㤹Ψξ硤l 
     */
    void setLogProbAtMost(int l)  
    { 
      if (logProb > l)
	setLogProb(l);
    }

    Move getMove()const{ return move; }
    int getLogProb()const{ return logProb; }
    bool validMove() const { return logProb > 0; }
  };
  std::ostream& operator<<(std::ostream& os,MoveLogProb const& moveLogProb);

  inline bool operator==(MoveLogProb const& lhs,MoveLogProb const& rhs)
  {
    return lhs.getMove()==rhs.getMove() && lhs.getLogProb()==rhs.getLogProb();
  }
  inline bool operator<(MoveLogProb const& lhs,MoveLogProb const& rhs)
  {
    if (lhs.getMove() != rhs.getMove())
      return lhs.getMove() < rhs.getMove();
    return lhs.getLogProb() < rhs.getLogProb();
  }

} // namespace ostream


#endif /* _MOVELOGPROB_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
