#ifndef _MOVE_LOG_PROB_VECTOR_H
#define _MOVE_LOG_PROB_VECTOR_H
#include "osl/moveLogProb.h"

#include "osl/fixedCapacityVector.h"
#include <iosfwd>

namespace osl
{
  typedef FixedCapacityVector<MoveLogProb,MoveMax> MoveLogProbVectorBase;

  class MoveLogProbVector : public MoveLogProbVectorBase
  {
    typedef MoveLogProbVectorBase base_t;
  public:
    void push_back(Move move,int prob) {
      base_t::push_back(MoveLogProb(move,prob));
    }
    void push_back(const MoveLogProb& move) {
      base_t::push_back(move);
    }
    /** Ψ⤤sort */
    void sortByProbability();
    /** Ψ㤤sort */
    void sortByProbabilityReverse();
  };
  std::ostream& operator<<(std::ostream& os,MoveLogProbVector const& mv);

} 
#endif // _MOVE_LOG_PROB_VECTOR_H
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
