/* moveMap.h
 */
#ifndef _MOVEMAP_H
#define _MOVEMAP_H

#include "osl/move.h"
#include "osl/carray.h"
#include <vector>
#include <algorithm>
#include <cassert>

namespace osl
{
  /**
   * õǥΡ move ¸뤿ʪ
   *
   * TODO:  MoveLogVector 򤽤Τޤ޻Ȥ®
   */
  template <class T>
  class MoveMap : private std::vector<T>
  {
  public:
    typedef std::vector<T> base_t;
    using base_t::swap;
    using base_t::clear;
    using base_t::begin;
    using base_t::end;
    using base_t::const_iterator;
    using base_t::size;
    using base_t::empty;

    /**
     * ƱǤʤȤˡ˥ȥ
     * Ƥʤ map ȤƤþ
     */
    T* insertNoCheck(const T& element)
    {
      push_back(element);
      return &back();
    }
    /**
     * ƱǤо񤭤롤ʤп˺
     */
    T* assign(const T& element)
    {
      const Move m = element.getMove();
      T *p = find(m);
      if (p)
      {
	*p = element;
	return p;
      }
      return insertNoCheck(element);
    }
    T* find(Move key)
    {
      for (typename base_t::iterator p=begin(); p!=end(); ++p)
      {
	if (p->getMove() == key)
	  return &*p;
      }
      return 0;
    }
    const T* find(Move key) const
    {
      for (typename base_t::const_iterator p=begin(); p!=end(); ++p)
      {
	if (p->getMove() == key)
	  return &*p;
      }
      return 0;
    }
  };
} // namespace osl


#endif /* _MOVEMAP_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
