#ifndef _MOVE_STACK_H
#define _MOVE_STACK_H
#include "osl/moveVector.h"
#include <cassert>
namespace osl
{
  class MoveStack
  {
    MoveVector data;
  public:
    MoveStack();
    void clear() { data.clear(); }
    void push(Move m) { data.push_back(m); }
    void pop() { data.pop_back(); }
    /** @param last lastLastMove if 2 */
    bool hasLastMove(size_t last=1) const { return size()>=last; }
    Move lastMove(size_t last=1) const
    {
      assert(hasLastMove(last));
      return data[size()-last];
    }
    size_t size() const { return data.size(); }
  };
} 
#endif // _MOVE_STACK_H
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
