/* noEffectFilter.h
 */
#ifndef _NO_EFFECT_FILTER_H
#define _NO_EFFECT_FILTER_H

namespace osl
{
  namespace move_action
  {
    /**
     * ΤʤȤưΥե륿
     */
    template<Player P,class State,class OrigAction>
    class NoEffectFilter
    {
      BOOST_CLASS_REQUIRE(OrigAction,osl::move_action,Concept);
      const State& state;
      OrigAction & action;
      Position removed;
    public:
      NoEffectFilter(const State& s, OrigAction & action,Position pos) : state(s), action(action),removed(pos) {}
      void simpleMove(Position from,Position to,Ptype ptype, bool isPromote,Player p){
	if(!state.template hasEffectByWithRemove<PlayerTraits<P>::opponent>(to,removed))
	  action.simpleMove(from,to,ptype,isPromote,P);
      }
      void unknownMove(Position from,Position to,Piece p1,Ptype ptype,bool isPromote,Player p){
	if(!state.template hasEffectByWithRemove<PlayerTraits<P>::opponent>(to,removed)){
	  action.unknownMove(from,to,p1,ptype,isPromote,P);
	}
      }
      void dropMove(Position to,Ptype ptype,Player p){
	/** ϸƤФʤϤ */
	if(!state.template hasEffectByWithRemove<PlayerTraits<P>::opponent>(to,removed))
	  action.dropMove(to,ptype,P);
      }
    
    };

  } // namespace move_action
} // namespace osl


#endif /* _NO_EFFECT_FILTER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
