/* safeMoveAction.h
 */
#ifndef _MOVE_ACTION_SAFE_FILTER_H
#define _MOVE_ACTION_SAFE_FILTER_H
#include "osl/move_action/concept.h"
namespace osl
{
  namespace move_action
  {
    /**
     * ̤˲꤬äƤʤ
     * ꤷƼˤʤ
     */
    template<Player P,class State,class OrigAction>
    struct SafeFilter
    {
      BOOST_CLASS_REQUIRE(OrigAction,osl::move_action,Concept);
      const State& state;
      OrigAction & action;
    public:
      SafeFilter(const State& s, OrigAction & action) : state(s), action(action) {}
      inline bool isSafeMove(Ptype ptype,Position from,Position to){
	if(ptype==KING){
	  if(!state.template hasEffectBy<PlayerTraits<P>::opponent>(to)) return true;
	  else return false;
	}
	else{
	  Position kingPosition=state.template getKingPosition<P>();
	  Offset offset=directionTable.getShortOffsetNotKnight(positionDiff(kingPosition,from));
	  if(offset==OFFSET_ZERO ||
	     offset==directionTable.getShortOffsetNotKnight(positionDiff(kingPosition,to)))
	    return true;
	  Position pos=kingPosition-offset;
	  /**
	   * Υ롼פɬλϤ
	   */
	  for(;isEmpty(state.getPieceAt(pos));pos-=offset){
	    assert(isOnBoard(pos));
	  }
	  if(pos!=from) return true;
	  Piece p;
	  for(pos-=offset;isEmpty(p=state.getPieceAt(pos));pos-=offset){
	    assert(isOnBoard(pos));
	  }
	  /**
	   * ptypeooffsetưȤƻĤ
	   */
	  return !isEdge(p) && hasEffect(ptypeTable.getEffect(getPtypeO(p),pos,kingPosition));
	}
      }
      void simpleMove(Position from,Position to,Ptype ptype, bool isPromote,Player p){
	if(isSafeMove(ptype,from,to))
	  action.simpleMove(from,to,ptype,isPromote,P);
      
      }
      void unknownMove(Position from,Position to,Piece p1,Ptype ptype,bool isPromote,Player p){
	if(isSafeMove(ptype,from,to))
	  action.unknownMove(from,to,p1,ptype,isPromote,P);
      }
      /**
       * dropMoveˤʤ뤳ȤϤʤ
       */
      void dropMove(Position to,Ptype ptype,Player p){
	action.dropMove(to,ptype,P);
      }
    };
  } // namespace move_action
} // namespace osl

#endif /* _MOVE_ACTION_SAFE_FILTER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
