#ifndef _GENERATE_ADD_EFFECT_MOVES_WITHOUT_EFFECT_H
#define _GENERATE_ADD_EFFECT_MOVES_WITHOUT_EFFECT_H
#include "osl/loki.h"
#include "osl/move_generator/drop.h"
#include "osl/move_generator/open.h"
#include "osl/addEffectTable.h"
#include <boost/static_assert.hpp>

namespace osl
{
  namespace move_generator
  {
    namespace without_effect
    {
    /**
     * @param P(template) - ¦Υץ쥤䡼
     * @param T(template) - ¦ζμ
     * @param state - 
     * @param from - ⤷褦Ȥΰ
     * @param target - ⤷褦Ȥޥ
     */
    template<class State,Player P,Ptype T,class Action,bool isPromote>
    void generateMove(State const& state,Position from,Position target, NearMask nearMask,Action& action){
      NearMask targetMask=(isPromote 
			   ? addEffectTable.getNearMaskWithPromote<P>(PtypeTraits<T>::moveType,from,target)
			   : addEffectTable.getNearMask<P>(PtypeTraits<T>::moveType,from,target)) &nearMask;
      while(targetMask!=0){
	int n=bsf(targetMask);
	targetMask&= ~(1<<n);
	Direction dir=static_cast<Direction>(n);
	Position to=target-directionTable.template getOffset<P>(dir);
	if(!isPromote || 
	   (canPromotePosition<P>(from)||canPromotePosition<P>(to)))
	  action.unknownMove(from,to,state.getPieceAt(to),(isPromote ? PtypeFuns<T>::promotePtype : T) ,isPromote,P);
      }
    }

    template<class State,Player P,Ptype T,class Action>
    void generateLongMoveDirectNoPromote(State const& state,Position from,Position target, NearMask nearMask,Action& action){
      NearMask targetMask=addEffectTable.getNearMask<P>(T,from,target) &nearMask;
      while(targetMask!=0){
	int n=bsf(targetMask);
	targetMask&= ~(1<<n);
	Direction dir=static_cast<Direction>(n);
	Position to=target-directionTable.template getOffset<P>(dir);
	/** 
	 * ֤٤ƶ
	 */
	if(state.isEmptyBetween(from,to))
	  action.unknownMove(from,to,state.getPieceAt(to),T,false,P);
      }
    }

    template<class State,Player P,Ptype T,class Action>
    void generateLongMoveDirectCanPromote(State const& state,Position from,Position target, NearMask nearMask,Action& action){
      NearMask targetMask=addEffectTable.getNearMaskWithPromote<P>(T,from,target) &nearMask;
      NearMask targetMaskNoPromote=addEffectTable.getNearMask<P>(T,from,target) &nearMask;
      while(targetMask!=0){
	int n=bsf(targetMask);
	targetMask&= ~(1<<n);
	Direction dir=static_cast<Direction>(n);
	Position to=target-directionTable.template getOffset<P>(dir);
	/** 
	 * ֤٤ƶ
	 */
	if(state.isEmptyBetween(from,to)){
	  if(canPromotePosition<P>(to)||canPromotePosition<P>(from))
	    action.unknownMove(from,to,state.getPieceAt(to),PtypeFuns<T>::promotePtype,true,P);
	  if((targetMaskNoPromote&(1<<n))!=0)
	    action.unknownMove(from,to,state.getPieceAt(to),T,false,P);
	}
      }
    }
    template<class State,Player P,Ptype T,class Action,bool canPromote>
    void generateLongMove(State const& state,Position from,Position target, NearMask nearMask,Action& action){
      // static assert?
      assert(T==LANCE || T==BISHOP || T==PBISHOP || T==ROOK || T==PROOK);
      /** longofset */
      EffectContent effectContent=
	ptypeTable.getEffect(newPtypeO(BLACK,unpromote(T)),makeBlackOffset32<P>(positionDiff(target,from)));
      if(hasEffect(effectContent) 
	 && !hasDirectEffect(effectContent)
	){
	/** 
	 * ƱlineǤǽϤ
	 */
	if(T==PROOK){
	  generateMove<State,P,T,Action,false>(state,from,target,nearMask,action);
	}
	Offset o1=makeBlackOffset<P>(effectOffset(effectContent));
	assert(o1!=OFFSET_ZERO);
	Piece p;
	Position pos1=target-o1;
	for(;isEmpty(p=state.getPieceAt(pos1));pos1-=o1) ;
	assert(pos1!=from);
	Position pos2=pos1-o1;
	Piece p1;
	for(;isEmpty(p1=state.getPieceAt(pos2));pos2-=o1) ;
	if(pos2==from){
	  if(isOnBoardBy<P>(p)){ 
	    Open<typename State::simple_board_t,Action>::
	      template generateOpenAttack<P>
	      (state,from,p,action,target,
	       longToShort(directionTable.getLongDirection<BLACK>(makeBlackOffset32<P>(positionDiff(target,from)))));
	    /** open attack */
	  
	  }
	  else{
	    /** capture attack */
	    if(canPromote &&          
	       (canPromotePosition<P>(from)||canPromotePosition<P>(pos1)) &&
	       /** LANCEξľʳäƤϥ */
	       (T!=LANCE || pos1==target-o1))
	      action.unknownMove(from,pos1,p,PtypeFuns<T>::promotePtype,true,P);
	    action.unknownMove(from,pos1,p,T,false,P);
	  }
	}
      }
      else{
	/**
	 * ƱlineǤʤ
	 * 8˵˰ưƤβ
	 */
	if(!PtypeTraits<T>::isBasic){
	  generateLongMoveDirectNoPromote<State,P,T,Action>(state,from,target,nearMask,action);
	}
	else{
	  generateLongMoveDirectCanPromote<State,P,T,Action>(state,from,target,nearMask,action);
	}
	if(T!=LANCE){
	  /** 1position */
	  {
	    NearMask targetMask=addEffectTable.getNearMaskLong<P>(T,from,target)&nearMask;
	    while(targetMask!=0){
	      int n=bsf(targetMask);
	      targetMask&= ~(1<<n);
	      Offset offset=addEffectTable.getOffsetLong<P>(T,from,target,n&15);
	      Position mid=target+makeBlackOffset<P>(offset);
	      /** ϰϳΤȤ⤢ */
	      if(!isOnBoardRegion(mid)) continue;
	      Piece p=state.getPieceAt(mid);
	      if(canMoveOn<P>(p) &&
		 state.isEmptyBetween(from,mid) && state.isEmptyBetween(mid,target)){
		if(canPromote &&
		   (canPromotePosition<P>(from)||canPromotePosition<P>(mid)))
		  action.unknownMove(from,mid,p,PtypeFuns<T>::promotePtype,true,P);
		action.unknownMove(from,mid,p,T,false,P);
	      }
	    }
	  }
	  /** 2position */
	  if(T==PBISHOP){
	    NearMask targetMask=addEffectTable.getNearMaskPBISHOP<P>(from,target)&nearMask;
	    while(targetMask!=0){
	      int n=bsf(targetMask);
	      targetMask&= ~(1<<n);
	      Offset offset=addEffectTable.getOffsetPBISHOP<P>(from,target,n&15);
	      Position mid=target+makeBlackOffset<P>(offset);
	      /** */
	      Piece p=state.getPieceAt(mid);
	      if(canMoveOn<P>(p) &&
		 state.isEmptyBetween(mid,target)){
		if(canPromote &&
		   (canPromotePosition<P>(from)||canPromotePosition<P>(mid)))
		  action.unknownMove(from,mid,p,PtypeFuns<T>::promotePtype,true,P);
		action.unknownMove(from,mid,p,T,false,P);
		if(isEmpty(p)){
		  mid=mid+directionTable.getShortOffset(positionDiff(mid,target));
		  p=state.getPieceAt(mid);
		  if(canMoveOn<P>(p)){
		    if(canPromote &&
		       (canPromotePosition<P>(from)||canPromotePosition<P>(mid)))
		      action.unknownMove(from,mid,p,PtypeFuns<T>::promotePtype,true,P);
		    action.unknownMove(from,mid,p,T,false,P);
		  }
		}
	      }
	    }
	  }
	  /** 3position */
	  if(T==PROOK){
	    NearMask targetMask=addEffectTable.getNearMaskPROOK<P>(from,target)&nearMask;
	    while(targetMask!=0){
	      int n=bsf(targetMask);
	      targetMask&= ~(1<<n);
	      Offset offset=addEffectTable.getOffsetPROOK<P>(from,target,n&15);
	      Position mid=target+makeBlackOffset<P>(offset);
	      /** */
	      Piece p=state.getPieceAt(mid);
	      if(canMoveOn<P>(p) &&
		 state.isEmptyBetween(mid,target)){
		if(canPromote &&
		   (canPromotePosition<P>(from)||canPromotePosition<P>(mid)))
		  action.unknownMove(from,mid,p,PtypeFuns<T>::promotePtype,true,P);
		action.unknownMove(from,mid,p,T,false,P);
		for(int i=0;i<2;i++){
		  if(isEmpty(p)){
		    mid=mid+directionTable.getShortOffset(positionDiff(mid,target));
		    p=state.getPieceAt(mid);
		    if(!canMoveOn<P>(p)) break;
		    if(canPromote &&
		       (canPromotePosition<P>(from)||canPromotePosition<P>(mid)))
		      action.unknownMove(from,mid,p,PtypeFuns<T>::promotePtype,true,P);
		    action.unknownMove(from,mid,p,T,false,P);
		  }
		}
	      }
	    }
	  }
	}
      }
    }

    template<class State,Player P,Ptype T,class Action,bool isLong>
    void generateDrop(State const& state,Position target, NearMask nearMask,Action& action){
      NearMask targetMask=((isLong ? (PtypeTraits<T>::moveMask>>10) : 
			    PtypeTraits<T>::moveMask)<<16) &nearMask;
      while(targetMask!=0){
	int n=bsf(targetMask);
	targetMask&= ~(1<<n);
	Direction dir=static_cast<Direction>(n&15);
	Offset offset=directionTable.template getOffset<P>(dir);
	Position to=target-offset;
	/** ζػ */
	if(T!=PAWN || !state.template isPawnMaskSet<P>(getX(to)))
	  action.dropMove(to,T,P);
	if(isLong){
	  for(Position pos1=to-offset;
	      isEmpty(state.getPieceAt(pos1));
	      pos1-=offset)
	    action.dropMove(pos1,T,P);
	}
      } 
    }

    /**
     * promoteԲǽ­ûˤ Functor
     */
    template<class State,Player P,Ptype T,class Action>
    class GoldKingAction{
      State const& state;
      Position target;
      Action& action;
      NearMask nearMask;
    public:
      GoldKingAction(State const& s,Position p,Action& a,NearMask n)
	:state(s),target(p),action(a),nearMask(n){}
      /**
       * forEachOnBoardƤФ
       */
      void operator()(Piece p){
	Position from=getPosition(p);
	generateMove<State,P,T,Action,false>(state,from,target,nearMask,action);
      }
    };
  
    /**
     * promoteǽ­ûˤ Functor
     */
    template<class State,Player P,Ptype T,class Action>
    class ShortPieceAction{
      State const& state;
      Position target;
      Action& action;
      NearMask nearMask;
    public:
      ShortPieceAction(State const& s,Position p,Action& a,NearMask n)
	:state(s),target(p),action(a),nearMask(n){}
      /**
       * forEachOnBoardƤФ
       */
      void operator()(Piece p){
	Position from=getPosition(p);
	if(isPromoted(p)){
	  generateMove<State,P,PtypeFuns<T>::promotePtype,Action,false>(state,from,target,nearMask,action);
	}
	else{
	  generateMove<State,P,T,Action,true>(state,from,target,nearMask,action);
	  generateMove<State,P,T,Action,false>(state,from,target,nearMask,action);
	}  
      }
    };

    /**
     * ­Ĺˤ Functor
     */
    template<class State,Player P,Ptype T,class Action>
    class LongPieceAction{
      State const& state;
      Position target;
      Action& action;
      NearMask nearMask;
    public:
      LongPieceAction(State const& s,Position p,Action& a,NearMask n)
	:state(s),target(p),action(a),nearMask(n){}
      /**
       * forEachOnBoardƤФ
       */
      void operator()(Piece p){
	Position from=getPosition(p);
	if(isPromoted(p)){
	  if(T==LANCE)
	    generateMove<State,P,PtypeFuns<T>::promotePtype,Action,false>(state,from,target,nearMask,action);
	  else{
	    generateLongMove<State,P,PtypeFuns<T>::promotePtype,Action,false>(state,from,target,nearMask,action);
	  }
	}
	else{
	  generateLongMove<State,P,T,Action,true>(state,from,target,nearMask,action);
	}  
      }
    };

    } // namespace without_effect
    /**
     * ʤstateǻȤAddEffect.
     * isAttackToKingtrueξKINGˤ벦ϼʤΤʤ
     * ʬμ꤬꤫ɤΥå򤹤뤫
     */
    template<class State,class Action,bool isAttackToKing=true>
    class AddEffectWithoutEffect
    {
      BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
      BOOST_STATIC_ASSERT(sizeof(typename State::simple_board_t));
    public:
      /**
       * ޥ,Ĥ褦Ȥ, 10˵ξ֤֤
       * @param P(template) - ¦Υץ쥤䡼
       * @param Dir(template) - θĤΥޥ
       * @param state - ̤ɽ
       * @param target - Ĥޥ
       * @return 16ӥå(10ӥå)϶ޤŨλ1,ʳ0
       * 16ӥå(10ӥå) ϶λ1, ʳ0
       */
      template<Player P,Direction Dir>
      static NearMask getNearMask(State const& state,Position target){
	/** ⤹¦Υޥ */
	Position pos=target-DirectionPlayerTraits<Dir,P>::offset;
	Piece p=state.getPieceAt(pos);
	if(canMoveOn<P>(p)){
	  if(isEmpty(p)) return 0x10001<<static_cast<int>(Dir);
	  return 1<<static_cast<int>(Dir);
	}
	return 0;
      }
      /**
       * ­ûˤ
       * @param P(template) - ¦Υץ쥤䡼
       * @param T(template) - Ptype T promoteˤ
       * @param state - 
       * @param target - Ĥޥ
       * @param action - ꤬callbackؿ
       * @param nearMask - target10˵Υޥ
       */
      template<Player P,Ptype T>
      static void generateMovesByPtype(const State& state,Position target,Action& action,NearMask nearMask){
	BOOST_STATIC_ASSERT((PtypeTraits<T>::isBasic));
	typedef without_effect::ShortPieceAction<State,P,T,Action> action_t;
	action_t gkAction(state,target,action,nearMask);
	state.template forEachOnBoard<P,T,action_t>(gkAction);
	/** drop move */
	if(state.template hasOffBoard<P,T>()){
	  without_effect::generateDrop<State,P,T,Action,false>(state,target,nearMask,action);
	}
      }
      /**
       * promoteȤϴطʤ
       */
      template<Player P>
      static void generateMovesByPtypeKing(const State& state,Position target,Action& action,NearMask nearMask){
	typedef without_effect::GoldKingAction<State,P,KING,Action> action_t;
	action_t gkAction(state,target,action,nearMask);
	state.template forEachOnBoard<P,KING,action_t>(gkAction);
      }
      template<Player P>
      static void generateMovesByPtypeGold(const State& state,Position target,Action& action,NearMask nearMask){
	typedef without_effect::GoldKingAction<State,P,GOLD,Action> action_t;
	action_t gkAction(state,target,action,nearMask);
	state.template forEachOnBoard<P,GOLD,action_t>(gkAction);
	/** drop move */
	if(state.template hasOffBoard<P,GOLD>()){
	  without_effect::generateDrop<State,P,GOLD,Action,false>(state,target,nearMask,action);
	}
      }
      /**
       * ĹĤ
       */
      template<Player P,Ptype T>
      static void generateMovesByPtypeLong(const State& state,Position target,Action& action,NearMask nearMask){
	typedef without_effect::LongPieceAction<State,P,T,Action> action_t;
	action_t gkAction(state,target,action,nearMask);
	state.template forEachOnBoard<P,T,action_t>(gkAction);
	/** drop move */
	if(state.template hasOffBoard<P,T>()){
	  without_effect::generateDrop<State,P,T,Action,true>(state,target,nearMask,action);
	}
      }
      /**
       * оݤȤޥդ
       * @param P(template) - ֤Υץ쥤䡼
       * @param state - оݤȤ
       * @param target - Ĥޥ
       * @param action - ꤬¸ߤ˸ƤӽФХåؿ
       */
      template<Player P>
      static void generateMoves(const State& state,Position target,Action& action){
	NearMask nearMask;
	/**
	 * 10˵ζξ֤å
	 */
	nearMask=getNearMask<P,U>(state,target);
	nearMask|=getNearMask<P,UL>(state,target);
	nearMask|=getNearMask<P,UR>(state,target);
	nearMask|=getNearMask<P,L>(state,target);
	nearMask|=getNearMask<P,R>(state,target);
	nearMask|=getNearMask<P,DL>(state,target);
	nearMask|=getNearMask<P,D>(state,target);
	nearMask|=getNearMask<P,DR>(state,target);
	nearMask|=getNearMask<P,UUL>(state,target);
	nearMask|=getNearMask<P,UUR>(state,target);
	/* Ƽˤmove */
	generateMovesByPtype<P,PAWN>(state,target,action,nearMask);
	generateMovesByPtypeLong<P,LANCE>(state,target,action,nearMask);
	generateMovesByPtype<P,KNIGHT>(state,target,action,nearMask);
	generateMovesByPtype<P,SILVER>(state,target,action,nearMask);
	generateMovesByPtypeGold<P>(state,target,action,nearMask);
	if(!isAttackToKing)
	  generateMovesByPtypeKing<P>(state,target,action,nearMask);
	generateMovesByPtypeLong<P,BISHOP>(state,target,action,nearMask);
	generateMovesByPtypeLong<P,ROOK>(state,target,action,nearMask);
      }
      /**
       * оݤȤޥդ
       * @param player - ֤Υץ쥤䡼
       * @param state - оݤȤ
       * @param target - Ĥޥ
       * @param action - ꤬¸ߤ˸ƤӽФХåؿ
       */
      static inline void generateMoves(Player player, const State& state, Position target, Action& action){
	if(player==BLACK)
	  generateMoves<BLACK>(state,target,action);
	else
	  generateMoves<WHITE>(state,target,action);
      }
    };
  } // namespace move_generator
} // namespace osl
#endif /* _GENERATE_ADD_EFFECT_MOVES_WITHOUT_EFFECT_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
