#ifndef _GENERATE_ALL_MOVES_H
#define _GENERATE_ALL_MOVES_H
#include "osl/loki.h"
#include "osl/player.h"
#include "osl/ptype.h"
#include "osl/position.h"
#include "osl/direction.h"
#include "osl/piece.h"
#include "osl/promote.h"
#include "osl/move_action/concept.h"
#include "osl/bitXmask.h"
#include <boost/static_assert.hpp>

// AllMoves<PawnMaskState, StoreMoveAction> ʳȤ߹碌ǻȤ
// generateAllMoves.tcc  include 뤳 (âѥ֤Τǿ侩ʤ)

// ̵̤ instantiate ޤ뤿ˡɬפ򤳤˽񤯤
// inline ʴؿǤ inline ǤʤؿΤ߸Ƥ־ .tcc ˽񤤤ɤ

namespace osl
{
  namespace move_generator
  {
    /**
     * Ƥμ
     *
     * @param Action move_action
     */
    template<class State,class Action>
    class AllMoves
    {
      BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
      BOOST_STATIC_ASSERT(sizeof(typename State::simple_board_t));
    public:
      template<Player P,Ptype Type>
      static void generateMovesPtype(const State& state, Action& action);

      /**
       * StatepawnMaskʤ
       * pawnMaskʤ
       * pawn
       */
      template<Player P>
      static void generateMovesPawn(const State& state, Action& action,BitXmask& pawnMask);

      template<Player P>
      static void generateMoves(const State& state, Action& action);

      template<Player P>
      static void generateMoves(const State& state, Action& action,Int2Type<true> stateHasPawnMask);
      template<Player P>
      static void generateMoves(const State& state, Action& action,Int2Type<false> stateHasPawnMask);


      static void generateMoves(Player p, const State& state, Action& action)
      {
	if(p==BLACK)
	  generateMoves<BLACK>(state,action);
	else
	  generateMoves<WHITE>(state,action);
      }
    };


  } // namespace move_generator
} // namespace osl

#endif /* _GENERATE_ALL_MOVES_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
