/* generateCaptureMoves.tcc
 */
#ifndef _GENERATECAPTUREMOVES_TCC
#define _GENERATECAPTUREMOVES_TCC

#include "osl/move_generator/capture.h"
#include "osl/effect_action/alwaysMove.h"
#include "osl/player.h"

namespace osl
{
  namespace move_generator
  {
    using namespace effect_action;
    template<class State,class Action>
    template<Player P>
    void Capture<State,Action>::
    generateMoves(const State& state,Position target,Action& action){
      AlwaysMove<State,Action> captureAction(state, action);
      state.template forEachEffect<P,AlwaysMove<State,Action> >(target,captureAction);
    }

    template<class State,class Action>
    template<Player P>
    void Capture<State,Action>::
    generateMovesNotBy(const State& state,Position target,Piece piece,Action& action)
    {
      AlwaysMove<State,Action> captureAction(state, action);
      state.template forEachEffectNotBy<P,AlwaysMove<State,Action> >(target,piece,captureAction);
    }

    template<class State,class Action>
    void Capture<State,Action>::
    generateMoves(Player p, const State& state,Position target,Action& action)
    {
      if (p == BLACK)
	Capture<State,Action>::template generateMoves<BLACK>(state,target,action);
      else
	Capture<State,Action>::template generateMoves<WHITE>(state,target,action);
    }

    template<class State,class Action>
    void Capture<State,Action>::
    generateMovesNotBy(Player p, const State& state,Position target,Piece piece,Action& action)
    {
      if (p == BLACK)
	Capture<State,Action>::template generateMovesNotBy<BLACK>(state,target,piece,action);
      else
	Capture<State,Action>::template generateMovesNotBy<WHITE>(state,target,piece,action);
    }
  } // namespace move_generator
} // namespace osl

#endif /* _GENERATECAPTUREMOVES_TCC */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
