#ifndef _GENERATE_DROP_MOVES_TCC
#define _GENERATE_DROP_MOVES_TCC
#include "osl/move_generator/drop.h"
#include "osl/move_action/concept.h"
namespace osl 
{
  namespace move_generator
  {
    template<class State>
    bool isPawnMaskSet(State const& state,int x,BitXmask pawnMask,Int2Type<BLACK>){
      return isSet(pawnMask,x);
    }
    template<class State>
    bool isPawnMaskSet(State const& state,int x,BitXmask pawnMask,Int2Type<WHITE>){
      return isSet(pawnMask,x);
    }

    template<class State>
    bool isPawnMaskSet(State const& state,int x,EmptyType pawnMask,Int2Type<BLACK>){
      return state.template isPawnMaskSet<BLACK>(x);
    }
    template<class State>
    bool isPawnMaskSet(State const& state,int x,EmptyType pawnMask,Int2Type<WHITE>){
      return state.template isPawnMaskSet<WHITE>(x);
    }


    template<class State,class Action>
    template<Player P,typename PawnMaskT,bool hasPawn,bool hasLance,bool hasKnight,bool hasSilver,bool hasGold,bool hasBishop,bool hasRook>
    void Drop<State, Action>::
    generateDropMoves(const State& state,Action& action,PawnMaskT pawnMask)
    {
      if(hasPawn || hasLance || hasKnight || hasSilver || hasGold || hasBishop || hasRook){
	if(hasPawn){
	  if(hasLance || hasKnight || hasSilver || hasGold || hasBishop || hasRook){
	    for(int x=9;x>0;x--){
	      if(isPawnMaskSet(state,x,pawnMask,Int2Type<P>()))
		generateDropMovesX<P,false,hasLance,hasKnight,hasSilver,hasGold,hasBishop,hasRook>(state,action,x);
	      else
		generateDropMovesX<P,true,hasLance,hasKnight,hasSilver,hasGold,hasBishop,hasRook>(state,action,x);
	    }
	  }
	  else{
	    for(int x=9;x>0;x--){
	      if(!isPawnMaskSet(state,x,pawnMask,Int2Type<P>()))
		generateDropMovesX<P,true,hasLance,hasKnight,hasSilver,hasGold,hasBishop,hasRook>(state,action,x);
	    }
	  }
	}
	else{ // pawnʤ
	  for(int x=9;x>0;x--){
	    generateDropMovesX<P,false,hasLance,hasKnight,hasSilver,hasGold,hasBishop,hasRook>(state,action,x);
	  }
	}
      }
    }

    /**
     * Ԥɤ̵ǤƤʤȿ§򡤸ΨŪ˽褦ȤƤ褦
     */
    template<class State,class Action>
    template<Player P,bool hasPawn,bool hasLance,bool hasKnight,bool hasSilver,bool hasGold,bool hasBishop,bool hasRook>
    void Drop<State, Action>::
    generateDropMovesX(const State& state,Action& action,int x)
    {
      assert(hasPawn || hasLance || hasKnight || hasSilver || hasGold || hasBishop || hasRook);
      if(P==BLACK){
	if(hasSilver || hasGold || hasBishop || hasRook){
	  Position pos=newPosition(x,1);
	  Piece p=state.getPieceAt(pos);
	  if(p==PIECE_EMPTY){
	    if(hasRook)
	      action.dropMove(pos,ROOK,P);
	    if(hasBishop)
	      action.dropMove(pos,BISHOP,P);
	    if(hasGold)
	      action.dropMove(pos,GOLD,P);
	    if(hasSilver)
	      action.dropMove(pos,SILVER,P);
	  }
	}
	if(hasPawn || hasLance || hasSilver || hasGold || hasBishop || hasRook){
	  Position pos=newPosition(x,2);
	  Piece p=state.getPieceAt(pos);
	  if(p==PIECE_EMPTY){
	    if(hasRook)
	      action.dropMove(pos,ROOK,P);
	    if(hasBishop)
	      action.dropMove(pos,BISHOP,P);
	    if(hasGold)
	      action.dropMove(pos,GOLD,P);
	    if(hasSilver)
	      action.dropMove(pos,SILVER,P);
	    if(hasLance)
	      action.dropMove(pos,LANCE,P);
	    if(hasPawn)
	      action.dropMove(pos,PAWN,P);
	  }
	}
	for(int y=3;y<=9;y++){
	  Position pos=newPosition(x,y);
	  Piece p=state.getPieceAt(pos);
	  if(p==PIECE_EMPTY){
	    if(hasRook)
	      action.dropMove(pos,ROOK,P);
	    if(hasBishop)
	      action.dropMove(pos,BISHOP,P);
	    if(hasGold)
	      action.dropMove(pos,GOLD,P);
	    if(hasSilver)
	      action.dropMove(pos,SILVER,P);
	    if(hasKnight)
	      action.dropMove(pos,KNIGHT,P);
	    if(hasLance)
	      action.dropMove(pos,LANCE,P);
	    if(hasPawn)
	      action.dropMove(pos,PAWN,P);
	  }
	}
      }
      else{
	if(hasSilver || hasGold  || hasBishop || hasRook){
	  Position pos=newPosition(x,9);
	  Piece p=state.getPieceAt(pos);
	  if(p==PIECE_EMPTY){
	    if(hasRook)
	      action.dropMove(pos,ROOK,P);
	    if(hasBishop)
	      action.dropMove(pos,BISHOP,P);
	    if(hasGold)
	      action.dropMove(pos,GOLD,P);
	    if(hasSilver)
	      action.dropMove(pos,SILVER,P);
	  }
	}
	if(hasPawn || hasLance || hasSilver || hasGold|| hasBishop || hasRook){
	  Position pos=newPosition(x,8);
	  Piece p=state.getPieceAt(pos);
	  if(p==PIECE_EMPTY){
	    if(hasRook)
	      action.dropMove(pos,ROOK,P);
	    if(hasBishop)
	      action.dropMove(pos,BISHOP,P);
	    if(hasGold)
	      action.dropMove(pos,GOLD,P);
	    if(hasSilver)
	      action.dropMove(pos,SILVER,P);
	    if(hasLance)
	      action.dropMove(pos,LANCE,P);
	    if(hasPawn)
	      action.dropMove(pos,PAWN,P);
	  }
	}
	for(int y=7;y>=1;y--){
	  Position pos=newPosition(x,y);
	  Piece p=state.getPieceAt(pos);
	  if(p==PIECE_EMPTY){
	    if(hasRook)
	      action.dropMove(pos,ROOK,P);
	    if(hasBishop)
	      action.dropMove(pos,BISHOP,P);
	    if(hasGold)
	      action.dropMove(pos,GOLD,P);
	    if(hasSilver)
	      action.dropMove(pos,SILVER,P);
	    if(hasKnight)
	      action.dropMove(pos,KNIGHT,P);
	    if(hasLance)
	      action.dropMove(pos,LANCE,P);
	    if(hasPawn)
	      action.dropMove(pos,PAWN,P);
	  }
	}
      }
    }

  } // namespace move_generator
} // namespace osl
#endif /* _GENERATE_DROP_MOVES_TCC */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
