#ifndef _GENERATE_ESCAPE_MOVES_H
#define _GENERATE_ESCAPE_MOVES_H
#include "osl/move_generator/pieceOnBoard.h"
#include "osl/move_generator/capture.h"
#include "osl/effect_action/simpleMove.h"
#include "osl/effect_action/pieceFilter.h"
#include "osl/move_action/noEffectFilter.h"
#include "osl/move_action/concept.h"
#include "osl/move.h"
// EscapeMoves<NumEffectState, StoreMoveAction> ʳȤ߹碌ǻȤȤ
// generateEscapeMoves.tcc include 뤳 (âѥ֤Τǿ侩ʤ)

namespace osl
{
  namespace move_generator
  {
    /**
     * ƨ
     */
    template<Player P,class State,class Action>
    class Escape
    {
      BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
      typedef typename State::simple_board_t simple_board_t;
    private:
      /**
       * ζ뤳Ȥˤäƨ.
       * ƨФǼʤ2003/5/12
       * @param target toru koma no pos
       */
      static void generateCapture(const State& state,Piece p,Position target,Action& action) {
	Capture<State,Action>::template generateMovesNotBy<P>(state,target,p,action);
      }
      /**
       * @param p ƨФ
       */
      template<Ptype Type>
      static void generateEscape(const State& state,Piece p,Action& action){
	typedef move_action::NoEffectFilter<P,State,Action> CheckAction;
	CheckAction checkAction(state,action,getPosition(p));
	PieceOnBoard<simple_board_t,CheckAction>::template generateMoves<P,Type>(state,p,checkAction);
      }

      template<Ptype Type>
      static void generateDrop(const State& state,Position to,Action& action){
	if(state.template hasOffBoard<P,Type>()){
	  if((Type!=PAWN || !state.isPawnMaskSet(P,getX(to))) &&
	     PtypePlayerTraits<Type,P>::canDropTo(to)){
	    action.dropMove(to,Type,P);
	  }
	}
      }

      static void generateDropAll(const State& state,Position to,Action& action);
      /**
       *  
       */
      static void generateBlocking(const State& state,Piece p,Position from,Action& action);
    public:
      static void generateKingEscape(const State& state,Move lastMove,Action& action);

      /** 
       * @param p 㤨 king
       */
      template<Ptype Type>
      static void generateMovesBy(const State& state,Piece p,Piece attackerPiece,Action& action);
      template<Ptype Type>
      static void generateMovesBy(const State& state,Piece p,Move lastMove,Action& action);
      template<Ptype Type>
      static void generateMovesBy(const State& state,Piece p,Action& action);
    
      /**
       * ƨ
       * ¤ƨƤʤǽĤäƤ
       * @param p ƨplayer
       * @param piece ƨ
       * @param lastMove - μ
       */
      static /* inline */ void generateMoves(const State& state,Piece piece,Move lastMove,Action& action);
      /**
       */
      static /* inline */ void generateMoves(const State& state,Piece piece,const Piece attackerPiece,Action& action);
      /**
       * lastMoveƨ
       */
      static /* inline */ void generateMoves(const State& state,Piece piece,Action& action);
    };

  } // namespace move_generator
} // namespace osl
#endif // _GENERATE_ESCAPE_MOVES_H
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
