#ifndef _GENERATE_OPEN_MOVES_H
#define _GENERATE_OPEN_MOVES_H
#include "osl/move_generator/pieceOnBoard.h"
#include "osl/move_action/concept.h"
#include <boost/static_assert.hpp>
// Open<SimpleState, StoreMoveAction> ʳȤ߹碌ǻȤȤ
// generateOpenMoves.tcc include 뤳 (âѥ֤Τǿ侩ʤ)

namespace osl
{
  namespace move_generator
  {
    /**
     * ĹߤƤư, 򿭤Ф.
     * 
     * ư, Position to褦ʤΤϼ
     */
    template<class State,class Action>
    class Open
    {
      BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
      BOOST_STATIC_ASSERT(sizeof(typename State::simple_board_t));

      template<Player P,Ptype Type,PromoteType CanP,Direction Dir,bool B>
      static void generateMoveNotDir3(const State& state,Piece p,Action& action,Position to,Int2Type<B>);

      template<Player P,Ptype Type,PromoteType CanP,Direction Dir>
      static void generateMoveNotDir3(const State& state,Piece p,Action& action,Position to,Int2Type<true>);

      template<Player P,Ptype Type,PromoteType CanP,Direction Dir>
      static void generateMoveNotDir3(const State& state,Piece p,Action& action,Position to,Int2Type<false>){
	// no call
      }

      template<Player P,Ptype Type,Direction Dir,PromoteType CanP,Direction MoveDir>
      static void generateMoveNotDir2(const State& state,Piece p,Action& action,Position to){
	generateMoveNotDir3<P,Type,CanP,MoveDir>(state,p,action,to,
						 Int2Type<Dir!=DirectionTraitsGen<MoveDir>::primDir && PtypeDirectionTraits<Type,MoveDir>::hasMove>());
      }

      template<Player P,Ptype Type,Direction Dir,PromoteType CanP>
      static void generateMoveNotDir1(const State& state,Piece p,Action& action,Position to){
	generateMoveNotDir2<P,Type,Dir,CanP,UL>(state,p,action,to);
	generateMoveNotDir2<P,Type,Dir,CanP,U>(state,p,action,to);
	generateMoveNotDir2<P,Type,Dir,CanP,UR>(state,p,action,to);
	generateMoveNotDir2<P,Type,Dir,CanP,L>(state,p,action,to);
	generateMoveNotDir2<P,Type,Dir,CanP,R>(state,p,action,to);
	generateMoveNotDir2<P,Type,Dir,CanP,DL>(state,p,action,to);
	generateMoveNotDir2<P,Type,Dir,CanP,D>(state,p,action,to);
	generateMoveNotDir2<P,Type,Dir,CanP,DR>(state,p,action,to);
	generateMoveNotDir2<P,Type,Dir,CanP,UUL>(state,p,action,to);
	generateMoveNotDir2<P,Type,Dir,CanP,UUR>(state,p,action,to);
	generateMoveNotDir2<P,Type,Dir,CanP,LONG_UL>(state,p,action,to);
	generateMoveNotDir2<P,Type,Dir,CanP,LONG_U>(state,p,action,to);
	generateMoveNotDir2<P,Type,Dir,CanP,LONG_UR>(state,p,action,to);
	generateMoveNotDir2<P,Type,Dir,CanP,LONG_L>(state,p,action,to);
	generateMoveNotDir2<P,Type,Dir,CanP,LONG_R>(state,p,action,to);
	generateMoveNotDir2<P,Type,Dir,CanP,LONG_DL>(state,p,action,to);
	generateMoveNotDir2<P,Type,Dir,CanP,LONG_D>(state,p,action,to);
	generateMoveNotDir2<P,Type,Dir,CanP,LONG_DR>(state,p,action,to);
      }

      template<Player P,Ptype Type,Direction Dir>
      static void generateMoveNotDirSub(const State& state,Piece p,Action& action,Position to,Int2Type<true>){
	if(canPromotePosition<P>(getPosition(p)))
	  generateMoveNotDir1<P,Type,Dir,CanPromoteType>(state,p,action,to);
	else{
	  // DirectionˤäƤcheck
	  generateMoveNotDir1<P,Type,Dir,CheckPromoteType>(state,p,action,to);
	}
      }

      template<Player P,Ptype Type,Direction Dir>
      static void generateMoveNotDirSub(const State& state,Piece p,Action& action,Position to,Int2Type<false>){
	generateMoveNotDir1<P,Type,Dir,NoPromoteType>(state,p,action,to);
      }

    public:
      template<Player P,Ptype Type,Direction Dir>
      static void generateMoveNotDir(const State& state,Piece p,Action& action,Position to);


      /**
       * fromˤpDirʳưӤ
       * toФΤϽ
       */
      template<Player P,Direction Dir>
      static void generateOpenAttack(const State& state,Position from,Piece p,Action& action,Position to);

      template<Player P>
      static void generateOpenAttack(const State& state,Position from,Piece p,Action& action,Position to,Direction dir){
	switch(dir){
	case UL: generateOpenAttack<P,UL>(state,from,p,action,to); break;
	case U: generateOpenAttack<P,U>(state,from,p,action,to); break;
	case UR: generateOpenAttack<P,UR>(state,from,p,action,to); break;
	case L: generateOpenAttack<P,L>(state,from,p,action,to); break;
	case R: generateOpenAttack<P,L>(state,from,p,action,to); break;
	case DL: generateOpenAttack<P,UR>(state,from,p,action,to); break;
	case D: generateOpenAttack<P,U>(state,from,p,action,to); break;
	case DR: generateOpenAttack<P,UL>(state,from,p,action,to); break;
	default: assert(0);
	}
      }
      static void generateOpenAttack(Player pl,const State& state,Position from,Piece p,Action& action,Position to,Direction dir){
	if(pl==BLACK)
	  generateOpenAttack<BLACK>(state,from,p,action,to,dir);
	else
	  generateOpenAttack<WHITE>(state,from,p,action,to,dir);
      }
    };
  } // namespace move_generator
} // namespace osl
#endif /* _GENERATE_OPEN_MOVES_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
