#ifndef _GENERATE_OPEN_MOVES_TCC
#define _GENERATE_OPEN_MOVES_TCC

#include "osl/move_generator/open.h"
#include "osl/move_generator/pieceOnBoard.tcc"
#include "osl/move_action/noAddEffectFilter.h"

namespace osl
{
  namespace move_generator
  {

    template<class State,class Action>
    template<Player P,Ptype Type,PromoteType CanP,Direction Dir>
    // inline
    void Open<State,Action>::
    generateMoveNotDir3(const State& state,Piece p,Action& action,Position to,Int2Type<true>){
      // 
      // DirˤPromoteΥåɬ
      typedef move_action::NoAddEffectFilter<State,Action> action_t;
      action_t newAction(state,action,to);
      
      // to򺣤ϼΤƤƤ
      PieceOnBoard<typename State::simple_board_t,action_t>::template 
	generateMovesDirSub<P,Type,CanP,Dir>(state,p,getNum(p),getPosition(p),newAction);
    }


    /** Ȥ礭Τ inline */
    template<class State,class Action>
    template<Player P,Ptype Type,Direction Dir>
    void Open<State,Action>::
    generateMoveNotDir(const State& state,Piece p,Action& action,Position to){
      generateMoveNotDirSub<P,Type,Dir>(state,p,action,to,Int2Type<PtypeTraits<Type>::canPromote>());
    }

    template<class State,class Action> 
    template<Player P,Direction Dir>
    void Open<State,Action>::
    generateOpenAttack(const State& state,Position from,Piece p,Action& action,Position to){
      // 
      assert(getOwner(p)==P);
      switch(getPtype(p)){
      case PAWN: generateMoveNotDir<P,PAWN,Dir>(state,p,action,to); break;
      case LANCE: generateMoveNotDir<P,LANCE,Dir>(state,p,action,to); break;
      case KNIGHT: generateMoveNotDir<P,KNIGHT,Dir>(state,p,action,to); break;
      case SILVER: generateMoveNotDir<P,SILVER,Dir>(state,p,action,to); break;

      case GOLD:     generateMoveNotDir<P,GOLD,Dir>(state,p,action,to); break;
      case PPAWN:    generateMoveNotDir<P,PPAWN,Dir>(state,p,action,to); break;
      case PLANCE:   generateMoveNotDir<P,PLANCE,Dir>(state,p,action,to); break;
      case PKNIGHT:  generateMoveNotDir<P,PKNIGHT,Dir>(state,p,action,to); break;
      case PSILVER:  generateMoveNotDir<P,PSILVER,Dir>(state,p,action,to); break;

      case BISHOP:  generateMoveNotDir<P,BISHOP,Dir>(state,p,action,to); break;
      case PBISHOP:  generateMoveNotDir<P,PBISHOP,Dir>(state,p,action,to); break;
      case ROOK:  generateMoveNotDir<P,ROOK,Dir>(state,p,action,to); break;
      case PROOK:  generateMoveNotDir<P,PROOK,Dir>(state,p,action,to); break;
      case KING:  generateMoveNotDir<P,KING,Dir>(state,p,action,to); break;
      default: abort();
      }
    }
  } // namespace move_action
} // namespace osl
#endif /* _GENERATE_OPEN_MOVES_TCC */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
