#ifndef _GENERATE_PIECE_MOVES_TCC
#define _GENERATE_PIECE_MOVES_TCC
#include "osl/move_generator/pieceOnBoard.h"
#include "osl/move_action/concept.h"
namespace osl
{
  namespace move_generator
  {
    template<class State,class Action>
    template<Player P,Ptype Type,PromoteType CanP,Direction Dir>
    void PieceOnBoard<State, Action>::
    generateLongMovesDir(const State& state,Piece p,int num,Position pos, Action& action){
      const Offset offset=DirectionPlayerTraits<Dir,P>::offset;
      //  assert(offset!=0);
      Position toPos=pos+offset;
      Piece p1=state.getPieceAt(toPos);
      while(isEmpty(p1)){
	if(CanP==CanPromoteType
	   || (CanP==CheckPromoteType  && canPromotePosition<P>(toPos))){
	  action.simpleMove(pos,toPos,PtypeFuns<Type>::promotePtype,true,P);
	  if(PtypePlayerTraits<Type,P>::canDropTo(toPos))
	    action.simpleMove(pos,toPos,Type,false,P);
	}
	else{
	  action.simpleMove(pos,toPos,Type,false,P);
	}
	toPos=toPos+offset;
	p1=state.getPieceAt(toPos);
      }
      if(canMoveOn<P>(p1)){
	if(CanP==CanPromoteType 
	   || (CanP==CheckPromoteType && canPromotePosition<P>(toPos))){
	  action.unknownMove(pos,toPos,p1,PtypeFuns<Type>::promotePtype,true,P);
	  if (PtypePlayerTraits<Type,P>::canDropTo(toPos))
	    action.unknownMove(pos,toPos,p1,Type,false,P);
	}
	else{
	  action.unknownMove(pos,toPos,p1,Type,false,P);
	}
      }
    }


    template<class State,class Action>
    template<Player P,Ptype Type,Ptype MoveType,PromoteType CanP>
    void PieceOnBoard<State, Action>::
    generateMovesSub(const State& state,Piece p,int num,Position pos, Action& action){
      generateMovesDir<P,Type,MoveType,CanP,UL>(state,p,num,pos,action);
      generateMovesDir<P,Type,MoveType,CanP,U>(state,p,num,pos,action);
      generateMovesDir<P,Type,MoveType,CanP,UR>(state,p,num,pos,action);
      generateMovesDir<P,Type,MoveType,CanP,L>(state,p,num,pos,action);
      generateMovesDir<P,Type,MoveType,CanP,R>(state,p,num,pos,action);
      generateMovesDir<P,Type,MoveType,CanP,DL>(state,p,num,pos,action);
      generateMovesDir<P,Type,MoveType,CanP,D>(state,p,num,pos,action);
      generateMovesDir<P,Type,MoveType,CanP,DR>(state,p,num,pos,action);
      generateMovesDir<P,Type,MoveType,CanP,UUL>(state,p,num,pos,action);
      generateMovesDir<P,Type,MoveType,CanP,UUR>(state,p,num,pos,action);
      generateMovesDir<P,Type,MoveType,CanP,LONG_UL>(state,p,num,pos,action);
      generateMovesDir<P,Type,MoveType,CanP,LONG_U>(state,p,num,pos,action);
      generateMovesDir<P,Type,MoveType,CanP,LONG_UR>(state,p,num,pos,action);
      generateMovesDir<P,Type,MoveType,CanP,LONG_L>(state,p,num,pos,action);
      generateMovesDir<P,Type,MoveType,CanP,LONG_R>(state,p,num,pos,action);
      generateMovesDir<P,Type,MoveType,CanP,LONG_DL>(state,p,num,pos,action);
      generateMovesDir<P,Type,MoveType,CanP,LONG_D>(state,p,num,pos,action);
      generateMovesDir<P,Type,MoveType,CanP,LONG_DR>(state,p,num,pos,action);
    }

  } // namespace move_generator
} // namespace osl

#endif /* _GENERATE_PIECE_MOVES_TCC */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:

