/* neighboring8.h
 */
#ifndef _NEIGHBORING8_H
#define _NEIGHBORING8_H

#include "osl/pawnMaskState.h"
#include "osl/direction.h"
namespace osl
{
  struct Neighboring8
  {
  private:
    static bool hasEffectFromTo(const PawnMaskState& state,
				PtypeO ptypeo, Position from, 
				Position target, Direction d)
    {
      target += directionTable.getOffsetForBlack(d); // 8 ˵ƻʤ֤ˤѴ
      return isOnBoard(target)
	&& state.hasEffectFromTo(ptypeo, from, target);
    }
  public:
    static bool hasEffectFromNeighboring8(const PawnMaskState& state,
					  PtypeO ptypeo, Position from, 
					  Position target)
    {
      const Ptype ptype = getPtype(ptypeo);
      if (! ptypeTable.hasLongMove(ptype))
      {
	if (abs(getY(from) - getY(target)) > 3)	// knight 3
	  return false;
	if (abs(getX(from) - getX(target)) > 2)
	  return false;
      }
      else if (ptype == LANCE)
      {
	if (abs(getX(from) - getX(target)) > 1)
	  return false;
      }

      // naive ʼ
      return hasEffectFromTo(state, ptypeo, from, target, UL)
	|| hasEffectFromTo(state, ptypeo, from, target, U)
	|| hasEffectFromTo(state, ptypeo, from, target, UR)
	|| hasEffectFromTo(state, ptypeo, from, target, L)
	|| hasEffectFromTo(state, ptypeo, from, target, R)
	|| hasEffectFromTo(state, ptypeo, from, target, DL)
	|| hasEffectFromTo(state, ptypeo, from, target, D)
	|| hasEffectFromTo(state, ptypeo, from, target, DR);
    }
    static bool isNeighboring8(Position from,Position to)
    {
      return (from != to)
	&& (to == from+directionTable.getShortOffsetNotKnight(positionDiff(to,from)));
    }
  };

} // namespace osl

#endif /* _NEIGHBORING8_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
