#ifndef _NULL_PIECE_EFFECT_H
#define _NULL_PIECE_EFFECT_H
namespace osl {

  template<class State>
  class NullPieceEffect<State> : public State{
  public:
    // effect
    explicit NullPieceEffect(State& st) :State(st){
    }
    template<Player P>
    bool hasEffectPos(Position pos);
    bool hasEffectBy(Player pl,Position pos){
      if(pl==BLACK)
	return hasEffectPos<BLACK>(pos);
      else
	return hasEffectPos<WHITE>(pos);
    }
    virtual ~NullPieceEffect(){}
  };

  template<class State>
  template<Player P>
  bool NullPieceEffect<State>::hasEffectPos(Position pos){
    // short
    int onMask0=getOnBoardMask(P).getMask(0);
    while(onMask0){
      int num=bsf(onMask0);
      onMask0 ^= (1<<num);
      Piece p=getPieceOf(num);
      Position pos1=getPosition(p);
      if(hasEffect(ptypeTable.getEffect(getPtypeO(p),pos-pos1)))
	return true;
    }
      
    // long
    int onMask1=getOnBoardMask(P).getMask(1);
    while(onMask1){
      int num=bsf(onMask1);
      onMask1 ^= (1<<num);
      Piece p=getPieceOf(num+32);
      Position pos1=getPosition(p);
      EffectContent effect=ptypeTable.getEffect(getPtypeO(p),pos-pos1);
      if(hasEffect(effect)){
	if(hasDirectEffect(effect)) return true;
	else{
	  Offset offset=effectOffset(effect);
	  Position pos2=pos1+offset;
	  do{
	    if(!isEmpty(getPieceAt(pos2))) goto retry;
	    pos2+=offset;
	  } while(pos2!=pos);
	  return true;
	}
      }
    retry:;
    }
    return false;
  }
}
#endif // _NULL_PIECE_EFFECT_H
