#ifndef _PERFMON_H
#define _PERFMON_H
#include <iostream>
#include <iomanip>
namespace osl{
  static unsigned long long beg, end;
  static inline void clock_start() {
#if 0
    asm volatile(".byte 0x0f,0x31":"=A"(beg));
#else
    unsigned int ax,dx;
    asm volatile("rdtsc\nmovl %%eax,%0\nmovl %%edx,%1":"=g"(ax),"=g"(dx)::"eax","edx");
    beg= (static_cast<unsigned long long>(dx)<<32)+static_cast<unsigned long long>(ax);
#endif
  }
  static inline unsigned long long clock_stop(){
#if 0
    asm volatile(".byte 0x0f,0x31":"=A"(end));
#else
    unsigned int ax,dx;
    asm volatile("rdtsc\nmovl %%eax,%0\nmovl %%edx,%1":"=g"(ax),"=g"(dx)::"eax","edx");
    end= (static_cast<unsigned long long>(dx)<<32)+static_cast<unsigned long long>(ax);
#endif
    return (end-beg);
  }

  static inline void clock_message(unsigned long long cycles,
				   const char *message,int loop){
    std::cerr << std::dec << message << " : take " << cycles << " clocks, loop= " << loop 
	      << " clocks/loop= " <<  (cycles/loop) << "." 
	      << std::setfill('0') << std::setw(2) 
	      << (cycles*100/loop)-(cycles/loop)*100 
	      << std::endl;
  }

  static inline void clock_stop(const char *message,int loop){
    const unsigned long long cycles=clock_stop();
    clock_message(cycles, message, loop);
  }
}

#endif
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
