/* pieceEval.tcc
 */
#ifndef _PIECEEVAL_TCC
#define _PIECEEVAL_TCC
#include "osl/ptype.h"
#include "osl/pieceEval.h"
#include "osl/pieceVector.h"
#include "osl/applyMove.h"
#include "osl/effect_action/storePtypeOPosition.h"
namespace osl 
{
  struct TakeBackValue
  {
    /** effectTo Τƽ */
    template <class State, Player P>
    static void findEffectPieces(const State& state, Position effectTo,
				 PtypeOPositionVector& myPieces, 
				 PtypeOPositionVector& oppPieces)
    {
      typedef effect_action::StorePtypeOPosition store_t;
      store_t oppPiecesStore(&oppPieces, effectTo);
      state.template forEachEffect<PlayerTraits<P>::opponent,store_t>
	(effectTo, oppPiecesStore);
      if (! oppPieces.empty())
      {
	store_t myPiecesStore(&myPieces, effectTo);
	state.template forEachEffect<P,store_t>(effectTo, myPiecesStore);
      }
    }
    /** move  getTo(move) Τƽ */
    template <class State, Player P>
    static void findEffectPiecesAfterMove(const State& state, Move move, 
					  PtypeOPositionVector& myPieces, 
					  PtypeOPositionVector& oppPieces)
    {
      using namespace effect_action;
      
      const Position from=getFrom(move);
      const Position to=getTo(move);
      const Player Opponent = PlayerTraits<P>::opponent;
      StorePtypeOPosition myPiecesStore(&myPieces, to);
      StorePtypeOPosition oppPiecesStore(&oppPieces, to);
      {
	// moveηŪΥޥѤΤĴ
	/** ʬ effectμˤäƤϹ®˵ޤ뤫⤷ʤ */
	/** offsetshort */
	/** knight move0ˤdirectionTableˤбΤϤʤ */
	Offset shortOffset=directionTable.getShortOffsetNotKnight(positionDiff(to,from));
	// knightξѤʤ
	if (shortOffset!=OFFSET_ZERO){
	  Piece p;
	  for (Position pos=from-shortOffset;isEmpty(p=state.getPieceAt(pos));
	       pos-=shortOffset)
	    ;
	  if (isOnBoardBy<P>(p)){
	    // 
	    const int moveMask=ptypeTable.getMoveMask(getPtype(p));
	    Direction dir=directionTable.getLongDirection<P>(positionDiff(to,from));
	    if ((moveMask&dirToMask(dir))!=0){
	      myPiecesStore.store(p);
	    }
	  }
	  else if (isOnBoardBy<Opponent>(p)){
	    // 
	    const int moveMask=ptypeTable.getMoveMask(getPtype(p));
	    Direction dir=directionTable.getLongDirection<P>(positionDiff(from,to));
	    if ((moveMask&dirToMask(dir))!=0){
	      oppPiecesStore.store(p);
	    }
	  }
	}
      }
      state.template forEachEffect<PlayerTraits<P>::opponent,StorePtypeOPosition>
	(to, oppPiecesStore);
      if (! oppPieces.empty())
      {
	const Piece movePiece=state.getPieceAt(from);
	state.template forEachEffectNotBy<P,StorePtypeOPosition>
	  (to, movePiece,myPiecesStore);
      }
    }
    
    /**
     * PtypeOPositionVector Ȥ˼֤ͤ׻
     * 
     * FIXME: Фɤ PtypeOPositionVector  
     * PtypeO,Position Υ٥ˤѹɬפ롥 
     * computeDiffAfterMoveMulti ʤɤǶưˡ
     * move μ礤ͤƤˡgetPosition(piece) ɬ
     * 礤Τposition ǤϤʤᡥ
     *
     * @param P alt(P) μ֤
     * @param target ˴ؤ֤
     * @param ptypeo target ˤꤵ
     */
    template <Player P>
    static int computeValue(Position target, PtypeO ptypeO, 
			    const PtypeOPositionVector& myPieces, 
			    const PtypeOPositionVector& oppPieces)
    {
      int val = 0;
      int vals[PIECE_SIZE];
      const Player Opponent = PlayerTraits<P>::opponent;
      size_t i;
      for (i=0;i<oppPieces.size();i++)
      {
	vals[i*2]=val;
	// opponentMove
	val+=ptypeEvalTable.getCaptureVal(ptypeO);
	{
	  ptypeO = oppPieces[i].first;
	  const bool promotable = canPromote(ptypeO) 
	    && (canPromotePosition<Opponent>(target) 
		|| canPromotePosition<Opponent>(oppPieces[i].second));
	  if (promotable)
	  {
	    ptypeO=promote(ptypeO);
	    val+=ptypeEvalTable.getPromoteVal(ptypeO);
	  }
	}
	vals[i*2+1]=val;
	// myMove
	if (i>=myPieces.size()){
	  break;
	}
	val+=ptypeEvalTable.getCaptureVal(ptypeO);
	{
	  ptypeO=myPieces[i].first;
	  const bool promotable = canPromote(ptypeO) 
	    && (canPromotePosition<P>(target) 
		|| canPromotePosition<P>(myPieces[i].second));
	  if (promotable)
	  {
	    ptypeO=promote(ptypeO);
	    val+=ptypeEvalTable.getPromoteVal(ptypeO);
	  }
	}
      }
      for (int j=i-1;j>=0;j--)
      {
	val=EvalTraits<P>::max(val,vals[j*2+1]);
	val=EvalTraits<Opponent>::max(val,vals[j*2]);
      }
      return val;
    }
  };

  /** P  PTYPE ζä */
  template <Ptype PTYPE> inline int captureVal(Player P)
  {
    // unpromote(PTYPE) ǵ¨ͤ˽
    return ptypeEvalTable.getCaptureVal(newPtypeO(alt(P),PTYPE));
  }
} // namespace osl

template<class State, osl::Player P>
int osl::PieceEval::
computeDiffAfterTakeBackLimited(const State& state, Position focus)
{
  const Piece target = state.getPieceOnBoard(focus);
  assert(isPiece(target));
  assert(P == getOwner(target));

  PtypeOPositionVector myPieces,oppPieces;
  TakeBackValue::findEffectPieces<State,P>(state, focus, 
					   myPieces, oppPieces);

  if (oppPieces.empty())
    return 0;

  myPieces.sort();
  oppPieces.sort();

  return TakeBackValue::computeValue<P>(focus, getPtypeO(target), 
					myPieces, oppPieces);
}

template<class State, osl::Player P>
int osl::PieceEval::computeDiffAfterMove(const State& state,Move move)
{
  assert(P == state.getTurn());
  assert(state.isAlmostValidMove(move));

  /** getTo(move) Τ򽸤 */
  PtypeOPositionVector myPieces,oppPieces;
  /**
   * moveη, Ӥ뤫
   */ 
  const Position from=getFrom(move);
  const Position to=getTo(move);
  int val=0; 
  /**
   * Ǽʬ٤Ƥζ
   */
  if (isOffBoard(from)) // drop moveϴñ
  {
    TakeBackValue::findEffectPieces<State,P>(state, to, 
					     myPieces, oppPieces);
  }
  else
  {
    val+=diffWithMove(state,move);
    TakeBackValue::
      findEffectPiecesAfterMove<State,P>(state, move, myPieces, oppPieces);
  }

  if (oppPieces.empty())
    return val;

  /** pieceVectorФsort򤹤 */
  myPieces.sort();
  oppPieces.sort();

  return val + TakeBackValue::
    computeValue<P>(to,getPtypeO(move), myPieces, oppPieces);
}

namespace osl
{
  /**
   * ؼμ֤ͤɾ
   * P ζõƤǤμ礤
   * alt(P) λɤʤ result 򹹿롥
   */
  template <class State,Player P>
  struct UpdateTakeBackAfterMove
  {
    const State& state;
    int& bestValue;
    const Position moveTo, moveFrom;
    const Piece captured;
    const PtypeO movedType;
    UpdateTakeBackAfterMove(const State& s, Move m, int &v) 
      : state(s), bestValue(v), moveTo(getTo(m)), moveFrom(getFrom(m)),
	captured(s.getPieceAt(moveTo)), movedType(getPtypeO(m))
    {
    }
    void operator()(Piece targetPiece)
    {
      using namespace effect_action;
      
      if (getPosition(targetPiece) == moveFrom)	// ư
	return;
      const Position target = getPosition(targetPiece);
      PtypeOPositionVector myPieces, oppPieces;
      StorePtypeOPosition myPiecesStore(&myPieces, target), 
	oppPiecesStore(&oppPieces, target);

      if (isPiece(captured))
	state.template forEachEffectNotBy<PlayerTraits<P>::opponent,StorePtypeOPosition>
	  (target, captured, oppPiecesStore);
      else
	state.template forEachEffect<PlayerTraits<P>::opponent,StorePtypeOPosition>
	  (target, oppPiecesStore);

      if (oppPieces.empty())
	return;

      if (isOffBoard(moveFrom))
	state.template forEachEffect<P,StorePtypeOPosition>
	  (target, myPiecesStore);
      else
	state.template forEachEffectNotBy<P,StorePtypeOPosition>
	  (target, state.getPieceAt(moveFrom), myPiecesStore);

      if (state.hasEffectFromTo(movedType, moveTo, target))
      {
	myPieces.push_back(std::make_pair(movedType, moveTo));
      }
	
      myPieces.sort();
      oppPieces.sort();

      const int cur
	= TakeBackValue::computeValue<P>
	(target, getPtypeO(targetPiece), myPieces, oppPieces);

      if (EvalTraits<PlayerTraits<P>::opponent>::betterThan(cur, bestValue))
	bestValue = cur;
    }
  };
} // namespace osl

template<class State, osl::Player P>
int osl::PieceEval::computeDiffAfterMoveMulti(const State& state,Move move)
{
  assert(P == state.getTurn());
  assert(P == getPlayer(move));
  assert(state.isAlmostValidMove(move));

  const Player Opp = PlayerTraits<P>::opponent;
  int bestValue = computeDiffAfterMove<State,P>(state, move);
  // computeDiffAfterMove 2ƤǤ̵̤ɤνʣ򤱤
  const int directDiff = diffWithMove(state,move);
  bestValue -= directDiff;
  
  // դ if ʬư promotion ΤǤʤ
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<PROOK>(Opp)))
    return bestValue+directDiff;
  typedef UpdateTakeBackAfterMove<State,P> updator_t;
  updator_t updator(state, move, bestValue);
  state.template forEachOnBoard<P,ROOK,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<PBISHOP>(Opp)))
    return bestValue+directDiff;
  state.template forEachOnBoard<P,BISHOP,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<GOLD>(Opp)))
    return bestValue+directDiff;
  state.template forEachOnBoard<P,GOLD,updator_t>(updator);
  // ä϶Ʊ  ɤøʤΤǻ޴ͥ
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<SILVER>(Opp)))
    return bestValue+directDiff;
  state.template forEachOnBoard<P,SILVER,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<KNIGHT>(Opp)))
    return bestValue+directDiff;
  state.template forEachOnBoard<P,KNIGHT,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<LANCE>(Opp)))
    return bestValue+directDiff;
  state.template forEachOnBoard<P,LANCE,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<PAWN>(Opp)))
    return bestValue+directDiff;
  state.template forEachOnBoard<P,PAWN,updator_t>(updator);
  return bestValue+directDiff;
}

namespace osl
{
  /**
   * P ζõƤǤμ礤
   * alt(P) λɤʤ result 򹹿롥
   */
  template <class State,Player P>
  struct UpdateTakeBack
  {
    const State& state;
    int& bestValue;
    UpdateTakeBack(const State& s, int &v) 
      : state(s), bestValue(v)
    {
    }
    void operator()(Piece target)
    {
      const int cur = PieceEval::
	computeDiffAfterTakeBackLimited<State,P>(state, getPosition(target));

      if (EvalTraits<PlayerTraits<P>::opponent>::betterThan(cur, bestValue))
	bestValue = cur;
    }
  };
} // namespace osl

template<class State, osl::Player P>
int osl::PieceEval::computeDiffAfterTakeBackMulti(const State& state)
{
  const Player Opp = PlayerTraits<P>::opponent;
  int bestValue = 0;
  
  // դ if ʬư promotion ΤǤʤ
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<PROOK>(Opp)))
    return bestValue;
  typedef UpdateTakeBack<State,P> updator_t;
  updator_t updator(state, bestValue);
  state.template forEachOnBoard<P,ROOK,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<PBISHOP>(Opp)))
    return bestValue;
  state.template forEachOnBoard<P,BISHOP,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<GOLD>(Opp)))
    return bestValue;
  state.template forEachOnBoard<P,GOLD,updator_t>(updator);
  // ä϶Ʊ  ɤøʤΤǻ޴ͥ
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<SILVER>(Opp)))
    return bestValue;
  state.template forEachOnBoard<P,SILVER,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<KNIGHT>(Opp)))
    return bestValue;
  state.template forEachOnBoard<P,KNIGHT,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<LANCE>(Opp)))
    return bestValue;
  state.template forEachOnBoard<P,LANCE,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<PAWN>(Opp)))
    return bestValue;
  state.template forEachOnBoard<P,PAWN,updator_t>(updator);
  return bestValue;
}

#endif /* _PIECEEVAL_TCC */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
