#ifndef _PLAYER_H
#define _PLAYER_H
#include <cassert>
#include <iosfwd>
namespace osl{
  enum Player{
    BLACK=0,
    WHITE= -1
  };
  
  static inline Player alt(Player player){
    return static_cast<Player>(-1-static_cast<int>(player));
  }
  static inline void changeTurn(Player &player){
    player= alt(player);
  }
  static inline int playerToIndex(Player player){
    return -static_cast<int>(player);
  }
  static inline int playerToMul(Player player){
    int ret=1+(static_cast<int>(player)<<1);
    assert(ret==1 || ret== -1);
    return ret;
  }
  static inline int playerToMask(Player player){
    return static_cast<int>(player);
  }
  
  /**
   * castǺ줿playerɤ֤
   */
  static inline bool isValid(Player player){
    return player==BLACK || player==WHITE; 
  }
    
    template<Player P>
  struct PlayerTraits;
  
  template<>
  struct PlayerTraits<BLACK>{
    static const int offsetMul=1;
    static const int index=0;
    static const int mask=0;
    static const Player opponent=WHITE;
  };
  
  template<>
  struct PlayerTraits<WHITE>{
    static const int offsetMul=-1;
    static const int index=1;
    static const int mask= -1;
    static const Player opponent=BLACK;
  };
  
  std::ostream& operator<<(std::ostream& os,Player player);
}
#endif /* _PLAYER_H */
