/* position.h
 */
#ifndef _POSITION_H
#define _POSITION_H

namespace osl {

  enum Position{
    OFFBOARD=0,
    POSITION_MIN=0,
    POSITION_SIZE=0x100
  };
  
  static inline bool isOffBoard(Position pos){
    return pos==OFFBOARD;
  }

  template<typename Xmask>
  inline void setPos(Xmask& mask,const Position pos){
    set(mask,getX(pos));
  }
  
  template<typename Xmask>
  inline void clearPos(Xmask& mask,const Position pos){
    clear(mask,getX(pos));
  }

} // namespace osl

#endif /* _POSITION_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
