/* positionCompressor.h
 */
#ifndef _POSITIONCOMPRESSOR_H
#define _POSITIONCOMPRESSOR_H

#include "osl/position.h"
#include "osl/board.h"
#include "osl/carray.h"
namespace osl
{

  /**
   * Position  [0..81] ˰̤
   * 0: 桤1..81 ׾
   */
  struct PositionCompressor
  {
  private:
    /** const ˤɽ֤ʤΤǸ */
    static CArray<signed char, POSITION_SIZE> positionToIndex;
  public:
    class Initializer;
    friend class Initializer;

    static int compress(Position pos)
    {
      const int result = positionToIndex[pos];
      assert(result >= 0);
      return result;
    }
    static Position melt(int index)
    {
      assert(0 <= index);
      assert(index < 82);
      if (index == 0)
	return OFFBOARD;
      --index;
      return newPosition(index/9+1, index%9+1);
    }
  };

} // namespace osl

#endif /* _POSITIONCOMPRESSOR_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
