/* progress.h
 */
#ifndef _PROGRESS_H
#define _PROGRESS_H

#include "osl/ptype.h"
#include "osl/pawnMaskState.h"
#include <iosfwd>
namespace osl
{
  /** οʹ٤¬μ̤η */
  template<Ptype T>
  struct PtypeProgressTraits;
  // 
  template<>
  struct PtypeProgressTraits<PAWN>{
    static const int val=2;
  };
  template<>
  struct PtypeProgressTraits<PPAWN>{
    static const int val=2;
  };
  //
  template<>
  struct PtypeProgressTraits<LANCE>{
    static const int val=5;
  };
  template<>
  struct PtypeProgressTraits<PLANCE>{
    static const int val=5;
  };
  //
  template<>
  struct PtypeProgressTraits<KNIGHT>{
    static const int val=5;
  };
  template<>
  struct PtypeProgressTraits<PKNIGHT>{
    static const int val=5;
  };
  //
  template<>
  struct PtypeProgressTraits<SILVER>{
    static const int val=7;
  };
  template<>
  struct PtypeProgressTraits<PSILVER>{
    static const int val=7;
  };
  //
  template<>
  struct PtypeProgressTraits<GOLD>{
    static const int val=8;
  };
  //
  template<>
  struct PtypeProgressTraits<BISHOP>{
    static const int val=7;
  };
  template<>
  struct PtypeProgressTraits<PBISHOP>{
    static const int val=7;
  };
  //
  template<>
  struct PtypeProgressTraits<ROOK>{
    static const int val=10;
  };
  template<>
  struct PtypeProgressTraits<PROOK>{
    static const int val=10;
  };
  //
  template<>
  struct PtypeProgressTraits<KING>{
    static const int val=15;
  };

  /** οʹ٤𤬼ؤɤ˿ʤǤ뤫¤ɽ
   */
  class PtypeProgressTable{
  private:
    int ptype2Val[PTYPE_SIZE];
    int pos2Val[PTYPEO_SIZE][POSITION_SIZE];
    static const int yVals[];
  public:
    PtypeProgressTable();
    ~PtypeProgressTable();
    int getVal(PtypeO ptypeo,Position pos) const{
      return pos2Val[ptypeo-PTYPEO_MIN][pos];
    }
  };
  extern const PtypeProgressTable ptypeProgressTable;

  class PawnMaskState;
  class Progress
  {
    int val;
  public:
    explicit Progress(PawnMaskState const& state);
    int getVal() const{ return val; }
    void addVal(int d) { val+=d; }
    static int getProgress(const PawnMaskState& state)
    {
      const Progress progress(state);
      return progress.getVal();
    }
    void doSimpleMove(const PawnMaskState& state,Position from, Position to, 
		      int promoteMask)
    {
      const Piece moving = state.getPieceOnBoard(from);
      const PtypeO ptypeo = getPtypeO(moving); //  promote ͤ˱ƶʤ
      val += ptypeProgressTable.getVal(ptypeo,to)
	- ptypeProgressTable.getVal(ptypeo,from);
    }
    void doDropMove(const PawnMaskState& state,Position to,Ptype ptype)
    {
      PtypeO ptypeo = newPtypeO(state.getTurn(), ptype);
      val += ptypeProgressTable.getVal(ptypeo,to)
	- ptypeProgressTable.getVal(ptypeo,OFFBOARD);
    }
    void doCaptureMove(const PawnMaskState& state,Position from, Position to, 
		       Piece target,int promoteMask)
    {
      const Piece moving = state.getPieceOnBoard(from);
      const PtypeO ptypeo = getPtypeO(moving); //  promote ͤ˱ƶʤ
      const PtypeO capturePtypeO = getPtypeO(target);

      val += ptypeProgressTable.getVal(capturePtypeO, OFFBOARD)
	- ptypeProgressTable.getVal(capturePtypeO, to)
	+ ptypeProgressTable.getVal(ptypeo, to)
	- ptypeProgressTable.getVal(ptypeo, from);
    }

    bool operator==(const Progress rhs) const { return val == rhs.val; }
  };
  std::ostream& operator<<(std::ostream& os, Progress prog);
} // namespace osl


#endif /* _PROGRESS_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
