#ifndef _CSA_H
#define _CSA_H

#include "record.h"
#include <iosfwd>
#include <string>
namespace osl
{
  namespace record
  {
    struct CsaIOError;

    /** CSA http://www.computer-shogi.org/wcsc12/record.html */
    class ICsaRecordStream : public IRecordStream{
    private:
      std::istream& is;
      PawnMaskState state;
      RecordVisitor rv;
    public:
      ICsaRecordStream(std::istream& is);
      virtual ~ICsaRecordStream();

      /** @throw CsaIOError */
      virtual void load(Record*);
      PawnMaskState getState() const { return state;}
    };

    class CsaFile{
    private:
      Record rec;
    public:
      CsaFile(std::string fileName);
      Record const& getRecord() const;
      PawnMaskState const& getInitialState() const;
    };

    Move csaStrToMove(const std::string& s,const PawnMaskState& st);
    extern Player csaCharToPlayer(char c);
    extern Position csaStrToPos(const std::string& s);
    extern Ptype csaStrToPtype(const std::string& s);
  } // namespace record
  using record::CsaFile;
} // namespace osl
#endif /* _CSA_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
