#ifndef _CSA_STRING_H
#define _CSA_STRING_H

#include "osl/pawnMaskState.h"

#include <boost/scoped_ptr.hpp>
#include <iosfwd>
namespace osl
{
  namespace record
  {
    class Record;

    // use of string is intentionally avoided here in order to reduce the cost of compilation 
    class CsaString{
    private:
      boost::scoped_ptr<Record> rec;
    public:
      CsaString(const char *recordString);
      ~CsaString();
    
      Record const& getRecord() const;
      PawnMaskState const& getInitialState() const;
    };
  } // namespace record
  using record::CsaString;
} // namespace osl
#endif /* _CSA_STRING_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
