#ifndef _KISEN_H
#define _KISEN_H

#include "osl/record/record.h"
#include "osl/position.h"
#include "osl/carray.h"
#include <iosfwd>
#include <sstream>
#include <fstream>
namespace osl
{
  namespace record
  {
    class KisenUtils{
    public:
      static Position convertPosition( int pos );
      static Move convertMove( PawnMaskState const& state,int c0,int c1 );
    };

    class IKisenStream : public IRecordStream{
    private:
      CArray<unsigned char, 512> cbuf;
      PawnMaskState state;
      RecordVisitor rv;
    public:
      IKisenStream(char const readbuf[]) : state(HIRATE) {
	std::copy(&readbuf[0],&readbuf[512],&cbuf[0]);
      }
      PawnMaskState getState() const { return state;}
      virtual void load(Record*);
      virtual ~IKisenStream(){};
    };

    class KisenFile{
    private:
      std::ifstream ifs;
      size_t numberOfGames;
      PawnMaskState const initialState;
    public:
      static const size_t maxMoves=256;
      KisenFile(std::string fileName);
      size_t size() const{ return numberOfGames; }
      PawnMaskState const& getInitialState() const{ return initialState; }
      std::vector<Move> getMoves(size_t index);
    };
  } // namespace record
  using record::KisenFile;
} // namespace osl
#endif // _KISEN_H 
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
