#ifndef _OPENING_BOOK_H
#define _OPENING_BOOK_H
#include "osl/record/csa.h"
#include <fstream>

namespace osl
{
  namespace record
  {
    class OBMove{
      Move move;
      int stateIndex;
    public:
      OBMove(Move m,int i) :move(m),stateIndex(i) {}
      Move getMove() const;
      int getStateIndex() const;
    };

    class OBState{
      int winCount, loseCount;
      int nMoves;
      int moveIndex;
      std::vector<OBMove> moves;
    public:
      OBState(int w,int l,int nm,int mi) :winCount(w),loseCount(l),nMoves(nm),moveIndex(mi){}
      std::vector<OBMove> getMoves() const;
      void addMoves(OBMove const&);
      int getWinCount() const;
      int getLoseCount() const;
      int getNMoves() const;
      int getMoveIndex() const;
    };

    class OpeningBook{
      int nStates;
      std::ifstream ifs;
      //    std::vector<OBState> states;
    public:
      int readInt();
      void seek(int offset);
      OpeningBook(char *filename);
      int getWinCount(int stateIndex);
      int getLoseCount(int stateIndex);
      std::vector<OBMove> getMoves(int stateIndex);
    };
  } // namespace record
  using record::OpeningBook;
} // namespace osl
#endif // _OPENING_BOOK_H
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
