/* killerMoveTable.h
 */
#ifndef _KILLERMOVETABLE_H
#define _KILLERMOVETABLE_H

#include "osl/moveLogProb.h"
#include "osl/carray.h"
#include <cstddef>
#include <cassert>
namespace osl
{
  namespace search
  {
    /**
     * ñkiller move
     *
     * ȤκϿ롥ơ֥ϿƤʤ̤ǡ
     * ּʬؤ꤫餳ؤȺפȸȤͭ
     * ȽϤøǡοǺǸbestMoveȤȯ줿move
     *
     * (killer move)ݻƤߤ?
     */
    class KillerMoveTable
    {
    public:
      static const int KillerMoveMax = 30;
    private:
      CArray<MoveLogProb,KillerMoveMax> killerMoves;
    public:
      KillerMoveTable();
      ~KillerMoveTable();
      void clear();
      void setMove(size_t i, const MoveLogProb& move, int prob)
      {
	assert(isValid(move.getMove()));
	killerMoves[i] = move;
	killerMoves[i].setLogProbAtLeast(prob);
      }
      const MoveLogProb& operator[](size_t i) const
      {
	return killerMoves[i];
      }
    };
  } // namespace search
} // namespace osl

#endif /* _KILLERMOVETABLE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
