/* quiescenceSearch.h
 */
#ifndef _QUIESCENCESEARCH_H
#define _QUIESCENCESEARCH_H

#include "osl/pieceEval.h"
#include "osl/search/searchEvalBase.h"
#include "osl/search/searchWindow.h"
namespace osl
{
  class MoveVector;
  namespace search
  {
    /**
     * 礤õ
     *
     * - ΤϼΤ
     *
     * TODO:
     * - ϡꡤƨꡤͭ?
     *
     * @param State ߤ NumEffectState ɸ
     */
    template <class State, class EvalT>
    class QuiescenceSearch : protected SearchEvalBase<EvalT>
    {
      typedef SearchEvalBase<EvalT> base_t;
      State& state;
    public:
      static const int maxDepth = 7;
      typedef typename base_t::eval_t eval_t;
      using base_t::isWinValue;
    
      explicit QuiescenceSearch(State& s) : state(s)
      {
      }
      template <Player P>
      int search(eval_t ev, Position lastTo)
      {
	// assert(state.getTurn() == P);
	assert(getOwner(state.getPieceOnBoard(lastTo)) == alt(P));
	return search<P>(winValue(alt(P)), winValue(P), 0, ev, lastTo);
      }
      int search(Player P, eval_t ev, Position lastTo)
      {
	if (P == BLACK)
	  return search<BLACK>(ev, lastTo);
	else
	  return search<WHITE>(ev, lastTo);
      }

      template <Player P>
      int search(NullWindow window, eval_t ev, Position lastTo)
      {
	const int beta = EvalTraits<P>::min
	  (winValue(P), 
	   window.beta()+delta(P)
	   +eval_t::getCaptureVal(newPtypeO(alt(P),PAWN)));
	return search<P>(winValue(alt(P)), beta, 0, ev, lastTo);
      }
      template <Player P>
      int search(const AlphaBetaWindow& window, eval_t ev, Position lastTo)
      {
	return search<P>(window.alpha(), window.beta(), 0, ev, lastTo);
      }
      template <Player P>
      int search(int alpha, int beta, int depth, eval_t ev, Position lastTo);

      /**
       * @return cut Ǥ뤫
       */
      template <Player P, bool allowCut>
      bool examineMoves(int& curVal, const MoveVector& moves, int& alpha, 
			int beta, int depth, eval_t ev);

      /**
       * P Ũ PTYPE 롥
       * @param exceptFor Ͻ
       */
      template <Player P, Ptype PTYPE>
      void generateCaptureMoves(MoveVector& moves, Piece exceptFor) const;
      /**
       * P Ũ target 롥
       */
      template <Player P>
      void generateCaptureMoves(Piece target, MoveVector& moves) const;
    };
  } // namespace search
  using search::QuiescenceSearch;
} // namespace osl


#endif /* _QUIESCENCESEARCH_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
