/* searchWindow.h
 */
#ifndef _SEARCHWINDOW_H
#define _SEARCHWINDOW_H

namespace osl
{
  namespace search
  {
    struct AlphaBetaWindow
    {
      int alphaValue, betaValue;
      AlphaBetaWindow(int a, int b) : alphaValue(a), betaValue(b)
      {
      }
      int& alpha() { return alphaValue; }
      int& beta()  { return betaValue; }
      int alpha() const { return alphaValue; }
      int beta()  const { return betaValue; }
      AlphaBetaWindow flipPlayer() const
      {
	return AlphaBetaWindow(beta(), alpha());
      }
    };
    struct NullWindow
    {
      int value;

      NullWindow(int v) :value(v)
      {
      }
      int& alpha() { return value; }
      int& beta()  { return value; }
      int alpha() const { return value; }
      int beta()  const { return value; }
    };
    
  } // namespace search
} // namespace osl


#endif /* _SEARCHWINDOW_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
