/* simpleHashRecord.h
 */
#ifndef _SIMPLEHASHRECORD_H
#define _SIMPLEHASHRECORD_H

#include "osl/moveLogProb.h"
#include "osl/moveLogProbSet.h"
#include "osl/evalTraits.h"
#include "osl/category/categoryFlags.h"
#include <cassert>

namespace osl
{
  namespace search
  {
    /**
     * SimpleHashTable ˵Ͽ륨ȥ
     */
    struct SimpleHashRecord
    {
      /** upperBound ϿȤlimit */
      signed short upperLimit;
      /** lowerBound ϿȤlimit */
      signed short lowerLimit;
      int upperBound;
      int lowerBound;
      MoveLogProb bestMove;
      /** ޤǤ˵;õΡɿ */
      int checkMateNodes;
      /** ޤǤꡤɾͤȥåȤǼФ褦ˤ */
      MoveLogProbSet moves;
      /** moves ä˻Ȥäƥ */
      category::CategoryFlags usedCategories;
      /** moves 򹹿Ȥlimit */
      int limitOfMoves;

      SimpleHashRecord() 
	: upperLimit(-1), lowerLimit(-1), checkMateNodes(0), limitOfMoves(-1)
      {
      }
      bool hasUpperBound(int limit) const
      {
	return (upperLimit >= limit);
      }
      bool hasLowerBound(int limit) const
      {
	return (lowerLimit >= limit);
      }
    
      /** high fail 뤫 */
      bool hasGreaterLowerBound(Player P, int limit, int threshold, int& val) const
      {
	if ((lowerLimit < limit)
	    || (betterThan(P, threshold, lowerBound)))
	  return false;
	val = lowerBound;
	return true;
      }
      /** low fail 뤫 */
      bool hasLesserUpperBound(Player P, int limit, int threshold, int& val) const
      {
	if ((upperLimit < limit)
	    || (betterThan(P, upperBound, threshold)))
	  return false;
	val = upperBound;
	return true;
      }

      void setBestMove(int limit, const MoveLogProb& bestMove)
      {
	if ((limit >= upperLimit)
	    || (limit >= lowerLimit))
	  this->bestMove= bestMove;
      }

      /**
       * lowerBound 
       * 
       * limit Ƥ⹹ϤΤХεΤ
       * ñ˿椹롥
       * mtdf ǺǽϤޤ F 򹹿 100 ɤ
       *  500 ɤǤϰϤޤäƤʤɡ
       */
      void setLowerBound(Player P, int limit, const MoveLogProb& bestMove, 
			 int value)
      {
	assert((value % 2) == 0);
	if (limit < lowerLimit)
	  return;
	this->bestMove= bestMove;
	lowerLimit = limit;
	lowerBound = value;
      }

      void setUpperBound(Player P, int limit, const MoveLogProb& bestMove, 
			 int value)
      {
	assert((value % 2) == 0);
	if (limit < upperLimit)
	  return;
	this->bestMove= bestMove;
	upperLimit = limit;
	upperBound = value;
      }

      /**
       * ¤Ȳ¤̷⤬äĴ
       *
       * Ʊä夫褿ͥ褷ʤȡơõη̤ϿǤʤ
       * @param PreferLowerBound Ʊä lower bound ͥ褹
       */
      template <bool PreferLowerBound>
      void makeConsistent(Player P)
      {
	if (betterThan(P, upperBound, lowerBound))
	  return;
	if ((upperLimit < lowerLimit)
	    || (PreferLowerBound && (upperLimit == lowerLimit)))
	{
	  upperBound = lowerBound;
	  assert((upperBound % 2) == 0);
	}
	else
	{
	  lowerBound = upperBound;
	  assert((lowerBound % 2) == 0);
	}
      }
    };
  } // namespace search

  using search::SimpleHashRecord;
} // namespace osl


#endif /* _SIMPLEHASHRECORD_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
