/* simpleHashTable.h
 */
#ifndef _SIMPLE_HASHTABLE_H
#define _SIMPLE_HASHTABLE_H

#include "osl/search/searchTable.h"
#include <boost/scoped_ptr.hpp>

namespace osl
{
  class MoveLogProb;
  class HashKey;

  namespace search
  {
    struct SimpleHashRecord;
    /**
     * Ū hash table
     * Ȥꤢ g++ (SGI STL)  hash_map ȤäƼ
     *
     * ǽ:
     * - lower bound  upper bound Ͽ롣
     * - ⤷ϿƤ̤˺ƤϿä顤ƾ񤭤
     * - ꤬դ줿ñ̵뤹
     * - upperBound  lowerBound  player ¸(betterThan)ʤΤ
     *   ֤ΰ㤦Ʊ̤þ
     * - Ͽ
     *
     * ٴŪʵǽ顤ʬǼʤۤbetter
     *  hash_map Ǥ GC뤳ȤϺȻפ뤿
     *
     * find, allocate  ݥ󥿤֤ᡤǤɲäƤ⡤¸Ǥ
     * ɥ쥹Ѳʤǡ¤Ѥɬפ롥
     */
    class SimpleHashTable
    {
    private:
      class Table;
      boost::scoped_ptr<Table> table;
    public:
      /**
       * @param capacity ɽݻ
       * @param minimumRecordLimit recordUpperBound, recordLowerBound ˤ
       *    limit ̤ΤΤϿ׵̵뤹
       */
      explicit SimpleHashTable(unsigned int capacity=1000, 
			       int minimumRecordLimit=1,
			       bool verboseDestructor=true);
      ~SimpleHashTable();
      void clear();
      /**
       * @param newLimit recordUpperBound, recordLowerBound ˤ 
       *   limit ̤ΤΤϿ׵̵뤹
       */
      void setMinimumRecordLimit(int newLimit);

      /**
       * ɽõϿƤʤпȥϿ
       * @return ơ֥뤬äѤälimit 0
       *   ǤʤǳݤؤΥݥ
       *   (ְäƤ delete ʤ)
       */
      SimpleHashRecord *allocate(const HashKey& key, int limit);
      /**
       * ɽõϿϤʤ
       * @return ¸ߤʤ0
       *   ǤʤǳݤؤΥݥ
       *   (ְäƤ delete ʤ)
       */
      SimpleHashRecord *find(const HashKey& key);
      const SimpleHashRecord *find(const HashKey& key) const;

      unsigned int size() const;
      unsigned int capacity() const;
    };
    
    template <>
    struct TableTraits<SimpleHashTable>
    {
      static const bool available = true;
    };
  } // namespace search

  using search::SimpleHashTable;
} // namespace osl

#endif /* _SIMPLE_HASHTABLE_H_ */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
