/* tableAnalyzer.h
 */
#ifndef _TABLE_HANALYZER_H
#define _TABLE_HANALYZER_H

#include "osl/hashEffectState.h"
#include <iosfwd>

namespace osl
{
  namespace search
  {
    class SimpleHashTable;
    /**
     * õΥơ֥ʬ
     *
     * ꤷͤ +,  -, lower bound  L, upper bound  U ɽ
     *
     * Ū 
     * - +L ޤäƤ̤ϡ
     *   Τ٤Ƥμ(ؤζ) -U 
     * - +U ޤäƤ̤ϡ
     *   ξʤȤĤμ -L 
     */
    class TableAnalyzer
    {
      const SimpleHashTable& table;
      std::ostream & os;
    public:
      TableAnalyzer(const SimpleHashTable&, std::ostream&);
      ~TableAnalyzer();
    
      /**
       * ɽĴ٤Ϳ줿̤ξ̤θĴ٤
       * õ root  (best move ޤäƤ) 
       *
       * - ΰϡ+L (= -U)
       * - ʳμˤϡ+U (= -L)
       *
       * 뤳Ȥǧ
       */
      void examineTopLevel(HashEffectState& state, int numBestMoves) const;
      /**
       * ɽĴ٤Ϳ줿̤ξ̤θĴ٤
       * õ root ̤ best move ؤ
       *
       * Ƽ +U 뤳Ȥǧ
       */
      void examineUpperBounds(HashEffectState& state, int numBestMoves) const;
    };
  } // namespace search
  using search::TableAnalyzer;
} // namespace osl

#endif /* _TABLE_HANALYZER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
