/* tableUtil.h
 */
#ifndef _TABLEUTIL_H
#define _TABLEUTIL_H

#include "osl/search/searchTable.h"
#include "osl/player.h"
#include "osl/loki.h"
#include "osl/evalTraits.h"
namespace osl
{
  class MoveLogProb;
  class HashKey;
  namespace search
  {
    class SimpleHashRecord;
    /**
     * lookUpTable  record{Lower,Upper}Bound ˤĤ
     * TableTraits::available ΰ㤤ۼ
     */
    struct TableUtil : public SearchTable
    {
      template <class Table>
      static SimpleHashRecord *find(Table *table, const HashKey& key)
      {
	return find(table, key, Int2Type<TableTraits<Table>::available>());
      }
      template <class Table>
      static SimpleHashRecord *allocate(Table *table, const HashKey& key, 
					int limit)
      {
	return allocate(table, key, limit, 
			Int2Type<TableTraits<Table>::available>());
      }

    private:
      template <class Table>
      static SimpleHashRecord *find(Table *table, const HashKey& key, 
				    Int2Type<true>)
      {
	return table->find(key);
      }
      template <class Table>
      static SimpleHashRecord *find(Table *table, const HashKey& key,
				    Int2Type<false>)
      {
	return 0;
      }
      template <class Table>
      static SimpleHashRecord *allocate(Table *table, const HashKey& key, 
					int limit, Int2Type<true>)
      {
	return table->allocate(key, limit);
      }
      template <class Table>
      static SimpleHashRecord *allocate(Table *table, const HashKey& key,
					int limit, Int2Type<false>)
      {
	return 0;
      }
    
    };				// TableUtil

  } // namespace search
} // namespace osl

#endif /* _TABLEUTIL_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
