/* histogram.h
 */
#ifndef _HISTOGRAM_H
#define _HISTOGRAM_H

#include <boost/scoped_array.hpp>
#include <iosfwd>
namespace osl
{
  namespace stat
  {
    /**
     * ҥȥ
     */
    class Histogram
    {
      boost::scoped_array<size_t> data;
      size_t length;
      size_t width;
      int start;
    public:
      Histogram(size_t w, size_t len, int start=0);
      ~Histogram();
      size_t safeIndex(size_t i) const
      {
	return (i >= length) ? length-1 : i;
      }
      size_t& frequency(size_t i) { return data[safeIndex(i)]; }
      void add(int value) 
      {
	if (value < start)
	  value = 0;
	else
	  value -= start;
	++frequency(value/width); 
      }
      size_t frequency(size_t i) const { return data[safeIndex(i)]; }
      void show(std::ostream& os) const;

      /** ̤绻 length  width ۤʤäƤ鲿⤷ʤ*/
      void merge(const Histogram&);
      /** \frac{*this}{numerator} ɽ length  width ۤʤäƤ鲿⤷ʤ*/
      void showRatio(std::ostream& os, const Histogram& numerator) const;
    };
  } // namespace stat
} // namespace osl

#endif /* _HISTOGRAM_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
