#include "osl/addEffectTable.h"

namespace osl{
  /**
   * nearMaskLong, nearMaskPBISHOP, nearMaskPROOK٤
   */
  unsigned int nearMaskOf(Ptype ptype,int dx, int dy,bool isPromote){
    unsigned int mask=0;
    /**
     * ʬưƸΥޥĤʤ
     */
    if(dx==0 && dy==0)
      return mask;
    for(int i=0;i<=SHORT_DIRECTION_MAX;i++){
      /* ޤϤ뤫? */
      Direction dir=static_cast<Direction>(i);
      /** longĤˤΤϤ᤿ */
      if((ptypeTable.getMoveMask(isPromote ? promote(ptype) : ptype)&
	  dirToMask(dir))==0) continue;
      /* ˤ˰ưǤ뤫 */
      /* offsetForBlack = target - piece */
      /* directionTable.offsetForBlack = target - middle */
      /* offset = middle-piece */
      int dx1=dx-directionTable.getDxForBlack(dir);
      int dy1=dy-directionTable.getDyForBlack(dir);
      if(dx1<-8 || 8<dx1 || dy1<-8 || 8<dy1) continue;
      Offset32 offset32=newOffset32(dx1,dy1);
      EffectContent effectContent=ptypeTable.getEffect(newPtypeO(BLACK,ptype),offset32);
      if(hasEffect(effectContent)){
	/** 
	 * ľδ֤ block ƤΤϽ 
	 * ξ̤Υ롼ǽ
	 */
	Direction dir1=directionTable.getLongDirection<BLACK>(offset32);
	/** dir1shortޤdirΰ㤦long */
	if((ptypeTable.getMoveMask(ptype) &(1<<dir1))==0 ||
	   longToShort(dir1)!=dir){
	  mask |= dirToMask(dir);
	}
      }
    }
    return mask;
  }
  /**
   * offsetForBlack pos - from
   */
  void AddEffectTable::setNearMaskLong(Ptype ptype,int offsetX, int offsetY){
    unsigned int maskLong=0,maskPBISHOP=0,maskPROOK=0;
    Offset32 offset32ForBlack=newOffset32(offsetX,offsetY);
    for(int i=0;i<=SHORT_DIRECTION_MAX;i++){
      /* ޤϤ뤫? */
      Direction dir=static_cast<Direction>(i);
      Direction longDir=shortToLong(dir);
      if((ptypeTable.getMoveMask(ptype)&dirToMask(longDir))==0) continue;
      /* ˤ˰ưǤ뤫 */
      int offsetX1=directionTable.getDxForBlack(dir);
      int offsetY1=directionTable.getDyForBlack(dir);
      for(size_t j=1;j<=8;j++){
	int x=offsetX-offsetX1*j;
	int y=offsetY-offsetY1*j;
	Offset offset2FromPos=newOffset(x-offsetX,y-offsetY);
	if(x<-8 || 8<x || y<-8 || 8<y) goto retry;
	Offset offset2=newOffset(x,y);
	Offset offset3=directionTable.getShortOffset(newOffset32(x,y));
	if(offset3==0) continue;
	Direction dir1=directionTable.getLongDirection<BLACK>(newOffset32(x,y));
	/** offset3non-nullǤϤoffsetΤȤ */
	if(dir1==longDir || 
	   longDir==directionTable.getLongDirection<BLACK>(newOffset32(-x,-y)))
	  goto retry;
	if(isShort(dir1)) continue;
	if(offset2==offset3 &&
	   (ptypeTable.getMoveMask(ptype)&dirToMask(longToShort(dir1)))!=0){
	  assert(ptype==PROOK || ptype==PBISHOP);
	  if(ptype==PROOK){
	    if(j==1)
	      maskPROOK|=dirToMask(dir);
	    else
	      maskPROOK|=dirToMask(dir)<<16;
	    offsetPROOK[offset32ForBlack-OFFSET32_MIN][i]=offset2FromPos;
	    break;
	  }
	  else{ /**  ptype==PBISHOP) */
	    if(j==1)
	      maskPBISHOP|=dirToMask(dir);
	    else
	      maskPBISHOP|=dirToMask(dir)<<16;
	    offsetPBISHOP[offset32ForBlack-OFFSET32_MIN][i]=offset2FromPos;
	    break;
	  }
	}
	else if((ptypeTable.getMoveMask(ptype)&dirToMask(dir1))!=0){
	  if(j==1)
	    maskLong|=dirToMask(dir);
	  else
	    maskLong|=dirToMask(dir)<<16;
	  offsetLong[ptype][offset32ForBlack-OFFSET32_MIN][i]=offset2FromPos;
	  break;
	}
      }
    retry:;
    }
    nearMaskLong[ptype][offset32ForBlack-OFFSET32_MIN]=maskLong;
    if(ptype==PBISHOP)
      nearMaskPBISHOP[offset32ForBlack-OFFSET32_MIN]=maskPBISHOP;
    else if(ptype==PROOK)
      nearMaskPROOK[offset32ForBlack-OFFSET32_MIN]=maskPROOK;
  }
  AddEffectTable::AddEffectTable(){
    /**
     * ǻȤơ֥
     */
    directionTable.init();
    /** 
     * ޤϥꥢ
     * carrayǤ? */
    nearMaskPBISHOP.clear();
    offsetPBISHOP.clear();
    nearMaskPROOK.clear();
    offsetPROOK.clear();
    for(int i=PTYPE_MAX;i>=PTYPE_PIECE_MIN;i--){
      Ptype ptype=static_cast<Ptype>(i);
      nearMask[i].clear();
      nearMaskWithPromote[i].clear();
      nearMaskLong[i].clear();
      offsetLong[i].clear();
      for(int dx= -8;dx<=8;dx++){
	for(int dy= -8;dy<=8;dy++){
	  Offset32 offset32=newOffset32(dx,dy);
	  int index=offset32-OFFSET32_MIN;
	  nearMask[i][index]=nearMaskOf(ptype,dx,dy,false);
	  if(canPromote(ptype))
	    nearMaskWithPromote[i][index]=nearMaskOf(ptype,dx,dy,true);
	  if(ptypeTable.hasLongMove(ptype)){
	    setNearMaskLong(ptype,dx,dy);
	  }
	}
      }
    }
  }
  AddEffectTable addEffectTable;
}
