
/* probTable.cc
 */
#include "osl/category/probTable.h"
#include "osl/category/ptypePtypeProbTable.h"
#include "osl/category/probTable.tcc"

template class osl::category::ProbTable<172>;
template class osl::category::ProbTable<1>;

osl::category::PieceValueTable::
PieceValueTable(const char *home, const char *name)
  : base_t(home, name)
{
}

void osl::category::PieceValueTable::
interpolate()
{
  int lastVal = CategoryTraits::maxProb();
  for (size_t i=0; i<indexMax(); ++i)
  {
    if (prob[i] == 0)
    {
      prob[i] = lastVal;	// 0 ä(갭֤)Ƥ
    }
    else
    {
      lastVal = prob[i];
    }
  }
}

osl::category::
PtypePtypeProbTable::PtypePtypeProbTable(const char *h, const char *n)
  : base_t(h,n)
{
}

void osl::category::PtypePtypeProbTable::
interpolate()
{
  int lastVal = CategoryTraits::maxProb();
  for (size_t i=0; i<indexMax(); ++i)
  {
    if ((i % PieceValueTable::indexMax()) == 0)
      lastVal = CategoryTraits::maxProb();
    if (prob[i] == 0)
    {
      prob[i] = lastVal;	// 0 ä(갭֤)Ƥ
    }
    else
    {
      lastVal = prob[i];
    }
  }
}

osl::category::
PtypeValueTable::PtypeValueTable(const char *h, const char *n)
  : base_t(h,n)
{
}

void osl::category::PtypeValueTable::
interpolate()
{
  int lastVal = CategoryTraits::maxProb();
  for (size_t i=0; i<indexMax(); ++i)
  {
    if ((i % PieceValueTable::indexMax()) == 0)
      lastVal = CategoryTraits::maxProb();
    if (prob[i] == 0)
    {
      prob[i] = lastVal;	// 0 ä(갭֤)Ƥ
    }
    else
    {
      lastVal = prob[i];
    }
  }
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
