#include "osl/checkmate/arrayCheckHashTable.h"
#include <iostream>

osl::checkmate::ArrayCheckHashTable::ArrayCheckHashTable(Player a)
  : buckets(new ElementList[bucketSize]), numElements(0), attacker(a)
{
}
osl::checkmate::ArrayCheckHashTable::~ArrayCheckHashTable()
{
}

void osl::checkmate::ArrayCheckHashTable::confirmNoVisitedRecords() const
{
  int visited = 0;
  for (unsigned int i=0; i<bucketSize; ++i)
  {
    const ElementList& e = buckets[i];
    for (list_t::const_iterator p=e.list.begin(); p!=e.list.end(); ++p)
    {
      const BoardEntry& b = *p;
      for (same_board_list_t::const_iterator q=b.colleagues.begin();
	   q!=b.colleagues.end(); ++q)
      {
	if (q->second.isVisited)
	{
	  ++visited;
	  std::cerr << q->first << " " << &q->second << " "
		    << b.v0 
#ifdef HASH_KEY_128_BIT
		    << " " << b.v3 
#endif
		    << "\n";
	}
      }
    }
  }
  if (visited)
  {
    std::cerr << "ArrayCheckHashTable::confirmNoVisitedRecords " 
	      << visited << " visited nodes found\n";
    abort();
  }
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
