/* oraclePool.cc
 */
#include "osl/checkmate/oraclePool.h"
#include "osl/pawnMaskState.h"
#include "osl/hashKeyEqual.h"
#include <algorithm>
#include <ext/hash_map>
using namespace __gnu_cxx;

namespace osl
{
  namespace checkmate
  {
    typedef hash_map<HashKey,const CheckHashRecord*,hash<HashKey>,HashKeyEqual> hash_map_t;

    /** Ȥꤢ8˵ȽꤷƤߤ
     * (ä˾)25˵ʤɤ¾θ
     */
    struct OraclePool::Table 
    {
      hash_map_t table;
      Player defense;
      Table(Player attacker) : defense(alt(attacker))
      {
      }
      template <Direction DIR>
      void addKey(HashKey& key, const PawnMaskState& state, Position target)
      {
	const Offset offset = directionTable.getOffsetForBlack(DIR);
	target += offset;	// 8 ˵ƻʤ֤ˤѴ
	const Piece p = state.getPieceAt(target);
	if (isPiece(p))
	{
	  hashGenTable.addHashKey(key, target, getPtypeO(p));
	}
      }
      const CheckHashRecord *& operator[](const PawnMaskState& state)
      {
	const Position targetKing=state.getKingPosition(defense);

	HashKey key;
	hashGenTable.addHashKey(key, targetKing, newPtypeO(defense, KING));
	addKey<UL>(key, state, targetKing);
	addKey<U>(key, state, targetKing);
	addKey<UR>(key, state, targetKing);
	addKey<L>(key, state, targetKing);
	addKey<R>(key, state, targetKing);
	addKey<DL>(key, state, targetKing);
	addKey<D>(key, state, targetKing);
	addKey<DR>(key, state, targetKing);
	return table[key];
      }
      size_t size() const
      {
	return table.size();
      }
    };
  
    OraclePool::OraclePool(Player attacker)
      : oracles(new Table(attacker))
    {
    }
  
    OraclePool::~OraclePool()
    {
    }
  
    void OraclePool::addOracle(const PawnMaskState& state,
			       const CheckHashRecord* oracle)
    {
      (*oracles)[state] = oracle;
    }
  
    const CheckHashRecord *OraclePool::findOracle(const PawnMaskState& state) const
    {
      return (*oracles)[state];
    }

    size_t OraclePool::size() const
    {
      return oracles->size();
    }
  
  } // namespace checkmate
} // namespace osl


/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
