#include "osl/checkmate/simpleCheckHashTable.h"
#include "osl/hashKey.h"
#include "osl/checkmate/checkHashRecord.h"
#include <algorithm>
#if __GNUG__ >= 3
#  include <ext/hash_map>
   using namespace __gnu_cxx;
#else
#  include <hash_map>
#endif

namespace osl
{
  namespace checkmate
  {
    static const int initial_capacity = 1000000;
    typedef hash_map<HashKey,CheckHashRecord> hash_map_t;
    struct SimpleCheckHashTable::Table : public hash_map_t
    {
      explicit Table(size_t capacity) : hash_map_t(capacity)
      {
      }
    };
  
    SimpleCheckHashTable::SimpleCheckHashTable(Player a)
      : table(new Table(initial_capacity)), attacker(a)
    {
    }
    SimpleCheckHashTable::~SimpleCheckHashTable()
    {
    }

    CheckHashRecord * SimpleCheckHashTable::find(const HashKey& key)
    {
      Table::iterator it=table->find(key);
      if (it==table->end()) 
	return 0;
      return &it->second;
    }
  
    CheckHashRecord * SimpleCheckHashTable::allocate(const HashKey& key)
    {
      return &(*table)[key];
    }

    void SimpleCheckHashTable::clear(){
      table->clear();
    }

    const CheckHashRecord * SimpleCheckHashTable::find(const HashKey& key) const
    {
      Table::const_iterator it=table->find(key);
      if (it==table->end()) 
	return 0;
      return &it->second;
    }
    size_t SimpleCheckHashTable::size() const{
      return table->size();
    }
    void SimpleCheckHashTable::confirmNoVisitedRecords() const
    {
    }
  } // namespace checkmate
} // namespace osl
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
