#include "osl/direction.h"
#include <iostream>

namespace osl{

  const CArray<Offset,DIRECTION_SIZE> DirectionTable::offsets = { {
    DirectionTraits<static_cast<Direction>(0)>::blackOffset,
    DirectionTraits<static_cast<Direction>(1)>::blackOffset,
    DirectionTraits<static_cast<Direction>(2)>::blackOffset,
    DirectionTraits<static_cast<Direction>(3)>::blackOffset,
    DirectionTraits<static_cast<Direction>(4)>::blackOffset,
    DirectionTraits<static_cast<Direction>(5)>::blackOffset,
    DirectionTraits<static_cast<Direction>(6)>::blackOffset,
    DirectionTraits<static_cast<Direction>(7)>::blackOffset,
    DirectionTraits<static_cast<Direction>(8)>::blackOffset,
    DirectionTraits<static_cast<Direction>(9)>::blackOffset,
    DirectionTraits<static_cast<Direction>(10)>::blackOffset,
    DirectionTraits<static_cast<Direction>(11)>::blackOffset,
    DirectionTraits<static_cast<Direction>(12)>::blackOffset,
    DirectionTraits<static_cast<Direction>(13)>::blackOffset,
    DirectionTraits<static_cast<Direction>(14)>::blackOffset,
    DirectionTraits<static_cast<Direction>(15)>::blackOffset,
    DirectionTraits<static_cast<Direction>(16)>::blackOffset,
    DirectionTraits<static_cast<Direction>(17)>::blackOffset
  } };
  const CArray<int,DIRECTION_SIZE> DirectionTable::dxs = { {
    DirectionTraits<static_cast<Direction>(0)>::blackDx,
    DirectionTraits<static_cast<Direction>(1)>::blackDx,
    DirectionTraits<static_cast<Direction>(2)>::blackDx,
    DirectionTraits<static_cast<Direction>(3)>::blackDx,
    DirectionTraits<static_cast<Direction>(4)>::blackDx,
    DirectionTraits<static_cast<Direction>(5)>::blackDx,
    DirectionTraits<static_cast<Direction>(6)>::blackDx,
    DirectionTraits<static_cast<Direction>(7)>::blackDx,
    DirectionTraits<static_cast<Direction>(8)>::blackDx,
    DirectionTraits<static_cast<Direction>(9)>::blackDx,
    DirectionTraits<static_cast<Direction>(10)>::blackDx,
    DirectionTraits<static_cast<Direction>(11)>::blackDx,
    DirectionTraits<static_cast<Direction>(12)>::blackDx,
    DirectionTraits<static_cast<Direction>(13)>::blackDx,
    DirectionTraits<static_cast<Direction>(14)>::blackDx,
    DirectionTraits<static_cast<Direction>(15)>::blackDx,
    DirectionTraits<static_cast<Direction>(16)>::blackDx,
    DirectionTraits<static_cast<Direction>(17)>::blackDx
  } };
  const CArray<int,DIRECTION_SIZE> DirectionTable::dys = { {
    DirectionTraits<static_cast<Direction>(0)>::blackDy,
    DirectionTraits<static_cast<Direction>(1)>::blackDy,
    DirectionTraits<static_cast<Direction>(2)>::blackDy,
    DirectionTraits<static_cast<Direction>(3)>::blackDy,
    DirectionTraits<static_cast<Direction>(4)>::blackDy,
    DirectionTraits<static_cast<Direction>(5)>::blackDy,
    DirectionTraits<static_cast<Direction>(6)>::blackDy,
    DirectionTraits<static_cast<Direction>(7)>::blackDy,
    DirectionTraits<static_cast<Direction>(8)>::blackDy,
    DirectionTraits<static_cast<Direction>(9)>::blackDy,
    DirectionTraits<static_cast<Direction>(10)>::blackDy,
    DirectionTraits<static_cast<Direction>(11)>::blackDy,
    DirectionTraits<static_cast<Direction>(12)>::blackDy,
    DirectionTraits<static_cast<Direction>(13)>::blackDy,
    DirectionTraits<static_cast<Direction>(14)>::blackDy,
    DirectionTraits<static_cast<Direction>(15)>::blackDy,
    DirectionTraits<static_cast<Direction>(16)>::blackDy,
    DirectionTraits<static_cast<Direction>(17)>::blackDy
  } };

  DirectionTable directionTable;

  std::ostream& operator<<(std::ostream& os,const Direction d){
    static char* names[]={
      "UL","U","UR","L","R","DL","D","DR","UUL","UUR","LONG_UL",
      "LONG_U","LONG_UR","LONG_L","LONG_R","LONG_DL","LONG_D","LONG_DR"
    };
    return os << names[static_cast<int>(d)];
  }

  template<Direction Dir>
  void DirectionTable::setDirections(){
    Offset offset=newOffset(DirectionTraits<Dir>::blackDx,
			    DirectionTraits<Dir>::blackDy);
    for(int i=1;i<=8;i++){
      int dx=i*DirectionTraits<Dir>::blackDx;
      int dy=i*DirectionTraits<Dir>::blackDy;
      Offset32 offset32=newOffset32(dx,dy);
      directions[offset32-OFFSET32_MIN]=Dir;
      shortOffsets[offset32-OFFSET32_MIN]=offset;
      shortOffsetsNotKnight[offset32-OFFSET32_MIN]=offset;
    }
  }
  template<Direction Dir>
  void DirectionTable::setKnightDirections(){
    int dx=DirectionTraits<Dir>::blackDx;
    int dy=DirectionTraits<Dir>::blackDy;
    Offset32 offset32=newOffset32(dx,dy);
    Offset offset=newOffset(dx,dy);
    shortOffsets[offset32-OFFSET32_MIN]=offset;
    shortOffsets[-offset32-OFFSET32_MIN]= -offset;
  }
  void DirectionTable::init(){
    directions.clear();
    shortOffsetsNotKnight.clear();

    setDirections<LONG_UL>();
    setDirections<LONG_U>();
    setDirections<LONG_UR>();
    setDirections<LONG_L>();
    setDirections<LONG_R>();
    setDirections<LONG_DL>();
    setDirections<LONG_D>();
    setDirections<LONG_DR>();
    setKnightDirections<UUL>();
    setKnightDirections<UUR>();
  }
  DirectionTable::DirectionTable(){
    init();
  }
}
