/* effectUtil.cc
 */
#include "osl/effectUtil.h"
#include "osl/effectUtil.tcc"
#include "osl/pieceEval.h"
#include "osl/numEffectState.h"
#include <iostream>

namespace osl
{
  template Piece 
  EffectUtil::cheapestPiece(Player, const NumEffectState&, Position);
  template Piece 
  EffectUtil::promotablePiece(Player, const NumEffectState&, Position);
  template void
  EffectUtil::showEffect(const NumEffectState&, Position, std::ostream&);
}

struct osl::EffectUtil::SelectMostValuable
{
  const SimpleState& state;
  Player target;
  Position moveFrom;
  Piece result;
  int resultValue;
  SelectMostValuable(const SimpleState& s, Player t, Position f) 
    : state(s), target(t), moveFrom(f),
      result(PIECE_EMPTY), resultValue(0)
  {
  }
  void operator()(Position pos)
  {
    if (pos == moveFrom)
      return;
    const Piece cur = state.getPieceOnBoard(pos);
    assert(isPiece(cur));
    if (getOwner(cur) == target)
    {
      const Ptype ptype = getPtype(cur);
      const int curValue = ptypeEvalTable.getCaptureVal(newPtypeO(WHITE,ptype));
      assert(curValue > 0);
      if ((ptype != KING) && (curValue > resultValue))
      {
	result = cur;
	resultValue = curValue;
      }
    }
  }
};

osl::Piece osl::EffectUtil::
mostValuableEffectOfMoveNotKing(Player target, const SimpleState& state, Move m)
{
  SelectMostValuable selector(state, target, getFrom(m));
  forEachEffectPieceOfMove(state, m, selector);
  return selector.result;
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
