#include "osl/piece.h"
#include "osl/move.h"
#include <boost/static_assert.hpp>
#include <iterator>

namespace osl{

BOOST_STATIC_ASSERT(sizeof(Move) == 4);

std::ostream& operator<<(std::ostream& os,const Move move){
  if (move == MOVE_INVALID)
      return os << "MOVE_INVALID";
  Player turn=getPlayer(move);
  Ptype capturePtype=getCapturePtype(move);
  if(getFrom(move)==OFFBOARD){
    os << "Drop(" << turn << "," << getPtype(move) << "," << getTo(move) << ")";
  }
  else if(capturePtype==PTYPE_EMPTY){
    os << "Move(" << turn << "," << getPtype(move) << "," 
       << getFrom(move) << "->" << getTo(move) 
       << ",promote=" << getPromoteMask(move) << ")";
  }
  else{
    os << "Move(" << turn << "," << getPtype(move) << "," 
       << "capture=" << capturePtype << "," 
       << getFrom(move) << "->" << getTo(move) 
       << ",promote=" << getPromoteMask(move) << ")";
  }
  return os;
}

#if 0
std::ostream& operator<<(std::ostream& os,const std::vector<Move>& moves){
  os << "Moves(\n  ";
  copy(moves.begin(),moves.end(),std::ostream_iterator<Move>(os,"\n  "));
  return os << ")" << std::endl;
}
#endif

std::ostream& csaShow(std::ostream& os,const Move move){
  os << getPlayer(move);
  csaShow(os,getFrom(move));
  csaShow(os,getTo(move));
  csaShow(os,getPtype(move));
  return os;
}

} //namespace osl
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
