/* moveSorter.cc
 */
#include "osl/moveSorter.h"
#include <iostream>
namespace osl
{
  // explicit template instantiation
  template MtdfMoveSorter<BLACK>;
  template MtdfMoveSorter<WHITE>;

  template<Player P>
  MtdfMoveSorter<P>::MtdfMoveSorter()
  {
  }
  
  template<Player P>
  MtdfMoveSorter<P>::~MtdfMoveSorter()
  {
  }

  template<Player P>
  void MtdfMoveSorter<P>::insert(const std::pair<int,MoveLogProb>& data)
  {
    assert(data.second.getLogProb() < 2000);
    assert(isValid(data.second.getMove()));
    base_t::insert(data);
  }

  template<Player P>
  void MtdfMoveSorter<P>::insert(typename base_t::iterator hint, const std::pair<int,MoveLogProb>& data)
  {
    base_t::insert(hint, data);
  }
  
  template<Player P>
  void MtdfMoveSorter<P>::erase(typename base_t::iterator first, typename base_t::iterator last)
  {
    base_t::erase(first, last);
  }
  
  template<Player P>
  void MtdfMoveSorter<P>::clear()
  {
    base_t::clear();
  }

  template<Player P>
  void MtdfMoveSorter<P>::dump(size_t showElements) const
  {
    if ((showElements == 0)
	|| (showElements > size()))
      showElements = size();
    
    size_t i=0;
    for (typename base_t::const_iterator p=begin(); i<showElements; ++p, ++i)
    {
      assert(p != end());
      std::cerr << i << "\t" << p->first << "\t";
      csaShow(std::cerr, p->second.getMove());
      std::cerr << " " << p->second.getLogProb() << "\n";
    }
  }

  template<Player P>
  void MtdfMoveSorter<P>::swap(MtdfMoveSorter& o)
  {
    base_t::swap(o);
  }
} // namespace osl


/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
