#include "osl/piece.h"
#include <boost/static_assert.hpp>
#include <iostream>

namespace osl{

BOOST_STATIC_ASSERT(sizeof(Piece) == 4);

const NumTable numTable;
#if 0
const NumToPtypeTable numToPtype;

#if 1
const NumToMaskLowTable numToMaskLow;
#else
//  singleton patternȤäƽ񤯤٤
const unsigned int numToMaskLow[40]={
#if 1
  PtypeTraits<PAWN>::indexMask,
#else
  0x3ffff, 
#endif
  0x3ffff, 0x3ffff, 0x3ffff, 0x3ffff, 0x3ffff, 0x3ffff, 0x3ffff, 0x3ffff,
  0x3ffff, 0x3ffff, 0x3ffff, 0x3ffff, 0x3ffff, 0x3ffff, 0x3ffff, 0x3ffff, 0x3ffff,

  0x3c0000, 0x3c0000, 0x3c0000, 0x3c0000,
  0x3c00000, 0x3c00000, 0x3c00000, 0x3c00000, 
  0x3c000000, 0x3c000000, 0x3c000000, 0x3c000000, 
  0xc0000000, 0xc0000000, 
  0xf, 0xf, 0xf, 0xf, 
  0x30, 0x30, 0xc0, 0xc0,
};
#endif
#endif

const CArray<unsigned int, 16> ptypeToNum = {{
  0,0,0,0,0,0,0,0,
  30,26,0,32,18,22,36,38,
}};

std::ostream& operator<<(std::ostream& os,const Piece piece)
{
  if (isPiece(piece))
    os << "Piece(" << getOwner(piece) << "," << getPtype(piece) 
	       << ",num=" << getNum(piece) 
	       << ",position=" << getPosition(piece) << ')';
  else if (piece == PIECE_EMPTY)
    os << "PIECE_EMPTY";
  else if (piece == PIECE_EDGE)
    os << "PIECE_EDGE";
  else
    os << "unkown piece?!";
  return os;
}

std::ostream& csaShow(std::ostream& os, const Piece piece){
  if(isEdge(piece)){
    return os << "   ";
  }
  else if(isEmpty(piece)){
    return os << " * ";
  }
  os << getOwner(piece);
#if 0
  assert( unpromote(getPtype(piece))==numToPtype[getNum(piece)] );
#else
  if( unpromote(getPtype(piece))!=numTable.getPtype(getNum(piece)) ){
    std::cout << piece << ",ptype=" << getPtype(piece) 
	      << ",unpromote=" <<unpromote(getPtype(piece)) 
	      << "num=" << getNum(piece) << ",numtoPtype=" 
	      << numTable.getPtype(getNum(piece))  << std::endl;
    assert(0);
  }
#endif
  return csaShow(os,getPtype(piece));
}


} // namespace osl

template<osl::Ptype T>
void osl::NumTable::initPtype(){
  for(int num=PtypeTraits<T>::indexMin;num<PtypeTraits<T>::indexLimit;num++){
    ptypes[num]=T;
#if 0
    masks[num]=PtypeFuns<T>::indexMask;
#endif
  }
}
osl::NumTable::NumTable(){
  initPtype<PAWN>();
  initPtype<LANCE>();
  initPtype<KNIGHT>();
  initPtype<SILVER>();
  initPtype<GOLD>();
  initPtype<KING>();
  initPtype<BISHOP>();
  initPtype<ROOK>();
}

#if 0
class NumToPtypeTable{
 private:
  Ptype contents[PIECE_SIZE];
  template<Ptype T>
    void initPtype(){
    for(int num=PtypeTraits<T>::indexMin;num<PtypeTraits<T>::indexLimit;num++)
      contents[num]=T;
  }
 public:
  NumToPtypeTable() {
    initPtype<PAWN>();
    initPtype<LANCE>();
    initPtype<KNIGHT>();
    initPtype<SILVER>();
    initPtype<GOLD>();
    initPtype<KING>();
    initPtype<BISHOP>();
    initPtype<ROOK>();
  }
  const Ptype& operator[](int num) const{
    assert(validNum(num));
    return const_cast<Ptype&>(contents[num]);
  }
};
extern const NumToPtypeTable numToPtype;

class NumToMaskLowTable{
 private:
  unsigned int contents[PIECE_SIZE];
  template<Ptype T>
    void initPtype(){
    for(int num=PtypeTraits<T>::indexMin;num<PtypeTraits<T>::indexLimit;num++)
      contents[num]=PtypeFuns<T>::indexMask;
  }
 public:
  NumToMaskLowTable(){
    initPtype<PAWN>();
    initPtype<LANCE>();
    initPtype<KNIGHT>();
    initPtype<SILVER>();
    initPtype<GOLD>();
    initPtype<KING>();
    initPtype<BISHOP>();
    initPtype<ROOK>();
  }
  const unsigned int& operator[](int num) const{
    assert(validNum(num));
    return const_cast<unsigned int&>(contents[num]);
  }
};
extern const NumToMaskLowTable numToMaskLow;
#endif
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
