/* pieceStand.cc
 */
#include "osl/pieceStand.h"
#include <boost/static_assert.hpp>
#include <iostream>

namespace osl
{
  BOOST_STATIC_ASSERT(sizeof(unsigned int)*/*CHARBITS*/8>=32);

  const CArray<unsigned char,PTYPE_MAX+1> PieceStand::shift =
  {{
    0,0,0,0,0,0,0,0,
    28, 24, 18, 14, 10, 6, 3, 0,
  }};
  const CArray<unsigned char,PTYPE_MAX+1> PieceStand::mask =
  {{
    0,0,0,0,0,0,0,0,
    (1<<2)-1, (1<<3)-1, (1<<5)-1, (1<<3)-1, (1<<3)-1, (1<<3)-1, (1<<2)-1, (1<<2)-1
  }};
  
  const unsigned int PieceStand::carryMask;
}

std::ostream& osl::operator<<(std::ostream& os, osl::PieceStand stand)
{
  os << "(stand";
  for (int i=KING; i<=ROOK; ++i)
  {
    const Ptype p = (Ptype)i;
    os << ' ' << stand.get(p);
  }
  return os << ")";
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
