#include "osl/pieceVector.h"
#include "osl/pieceEval.h"
#include <algorithm>
#include <iostream>

namespace osl
{
  struct PieceLessThan{
    bool operator()(Piece p0,Piece p1){
      Ptype ptype0=unpromote(getPtype(p0));
      Ptype ptype1=unpromote(getPtype(p1));
      return ptypeEvalTable.getVal(ptype0)<ptypeEvalTable.getVal(ptype1);
    }
  };

  void PieceVector::sort()
  {
    std::sort(begin(),end(),PieceLessThan());
  }

  std::ostream& operator<<(std::ostream& os,PieceVector const& pv)
  {
    os<< "PieceVector" << std::endl;
    for(size_t i=0; i<pv.size(); i++){
      os << pv[i] << std::endl;
    }
    return os<<std::endl;
  }
}
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
