#include "osl/pawnMaskState.h"
#include "osl/piece.h"
#include "osl/progress.h"
#include <iostream>

osl::PtypeProgressTable const osl::ptypeProgressTable;
/** y ɸбʹ٤ηǽ0 (Ѥʤ)*/
const int osl::PtypeProgressTable::yVals[]={0,4,4,4,3,2,1,0,0,0};

osl::
Progress::Progress(PawnMaskState const& state)
{
  int ret=0;
  for(int num=0;num<PIECE_SIZE;num++)
  {
    if(state.getOffBoardMask(BLACK).isSet(num)){
      ret+=ptypeProgressTable.getVal(newPtypeO(BLACK,numTable.getPtype(num)),
				     OFFBOARD);
    }
    else if(state.getOffBoardMask(WHITE).isSet(num)){
      ret+=ptypeProgressTable.getVal(newPtypeO(WHITE,numTable.getPtype(num)),
				     OFFBOARD);
    }
    else{
      assert(state.isOnBoardNum(num));
      const Piece p=state.getPieceOf(num);
      ret+=ptypeProgressTable.getVal(getPtypeO(p),getPosition(p));
    }
  }
  val=ret;
}

osl::PtypeProgressTable::PtypeProgressTable()
{
  ptype2Val[PAWN]=PtypeProgressTraits<PAWN>::val;
  ptype2Val[PPAWN]=PtypeProgressTraits<PPAWN>::val;
  ptype2Val[LANCE]=PtypeProgressTraits<LANCE>::val;
  ptype2Val[PLANCE]=PtypeProgressTraits<PLANCE>::val;
  ptype2Val[KNIGHT]=PtypeProgressTraits<KNIGHT>::val;
  ptype2Val[PKNIGHT]=PtypeProgressTraits<PKNIGHT>::val;
  ptype2Val[SILVER]=PtypeProgressTraits<SILVER>::val;
  ptype2Val[PSILVER]=PtypeProgressTraits<PSILVER>::val;
  ptype2Val[GOLD]=PtypeProgressTraits<GOLD>::val;
  ptype2Val[KING]=PtypeProgressTraits<KING>::val;
  ptype2Val[BISHOP]=PtypeProgressTraits<BISHOP>::val;
  ptype2Val[PBISHOP]=PtypeProgressTraits<PBISHOP>::val;
  ptype2Val[ROOK]=PtypeProgressTraits<ROOK>::val;
  ptype2Val[PROOK]=PtypeProgressTraits<PROOK>::val;
  for(int i=PTYPE_MIN;i<=PTYPE_MAX;i++){
    Ptype ptype=static_cast<Ptype>(i);
    pos2Val[newPtypeO(BLACK,ptype)-PTYPEO_MIN][OFFBOARD]=ptype2Val[i]*yVals[5];
    pos2Val[newPtypeO(WHITE,ptype)-PTYPEO_MIN][OFFBOARD]=ptype2Val[i]*yVals[5];
    for(int y=1;y<10;y++)
    {
      for(int x=9;x>0;x--)
      {
	pos2Val[newPtypeO(BLACK,ptype)-PTYPEO_MIN][newPosition(x,y)]
	  = ptype2Val[i]*yVals[y];
	pos2Val[newPtypeO(WHITE,ptype)-PTYPEO_MIN][newPosition(x,10-y)]
	  = ptype2Val[i]*yVals[y];
      }
    }
  }
}

osl::PtypeProgressTable::~PtypeProgressTable() {
}

std::ostream& osl::operator<<(std::ostream& os, Progress prog)
{
  return os << "progress " << prog.getVal();
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
