#include "osl/ptypeOPositionVector.h"
#include "osl/pieceEval.h"
#include <algorithm>
#include <iostream>

namespace osl
{
  struct PtypeOPositionLessThan
  {
    bool operator()(const std::pair<PtypeO,Position>& l,
		    const std::pair<PtypeO,Position>& r)
    {
      const Ptype ptypel=unpromote(getPtype(l.first));
      const Ptype ptyper=unpromote(getPtype(r.first));
      const int vall = ptypeEvalTable.getVal(ptypel);
      const int valr = ptypeEvalTable.getVal(ptyper);
      if (vall != valr)
	return vall < valr;
      return l.second < r.second;
    }
  };

  void PtypeOPositionVector::sort()
  {
    std::sort(begin(),end(),PtypeOPositionLessThan());
  }

}
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
