#include "osl/record/csaString.h"
#include "osl/record/csa.h"
#include "osl/pawnMaskState.h"
#include <cassert>

#if __GNUC__ == 2
#include <strstream>
#else
#include <sstream>
#endif

namespace osl
{
namespace record
{
  CsaString::CsaString(const char *recordString) : rec(new Record) {
#if __GNUC__==2
    std::istrstream 
#else
    std::istringstream 
#endif
      iss(recordString);
    ICsaRecordStream irs(iss);
    irs.load(&*rec);
  }
  CsaString::~CsaString() {
  }

  Record const& CsaString::getRecord() const{
    return *rec;
  }
  PawnMaskState const& CsaString::getInitialState() const{
    return rec->getInitialState();
  }


} // namespace record
} // namespace osl
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
