#include "osl/record/openingBook.h"
namespace osl
{
namespace record
{
  Move OBMove::getMove() const{
    return move;
  }
  int OBMove::getStateIndex() const{
    return stateIndex;
  }
  std::vector<OBMove> OBState::getMoves() const{
    return moves;
  }
  int OBState::getWinCount() const{
    return winCount;
  }
  int OBState::getLoseCount() const{
    return loseCount;
  }
  int OBState::getNMoves() const{
    return nMoves;
  }
  int OBState::getMoveIndex() const{
    return moveIndex;
  }
  void OBState::addMoves(OBMove const& move){
    moves.push_back(move);
  }
  
  OpeningBook::OpeningBook(char *filename) :ifs(filename){
    nStates=readInt();
#if 0
    for(int i=0;i<nStates;i++){
      int winCount=readInt();
      int loseCount=readInt();
      int nMoves=readInt();
      int moveIndex=readInt();
      states.push_back(OBState(winCount,loseCount,nMoves,moveIndex));
    }
    for(int i=0;i<nStates;i++){
      seek(4+16*nStates+8*states[i].getMoveIndex());
      for(int j=0;j<states[i].getNMoves();j++){
	Move move=static_cast<Move>(readInt());
	int stateIndex=readInt();
	states[i].addMoves(OBMove(move,stateIndex));
      }
    }
#endif
  }
  int OpeningBook::readInt(){
    int ret=0;
    char cs[4];
    ifs.read(cs,4);
    for(int i=0;i<4;i++){
      ret=(ret<<8)|(cs[i]&255);
    }
    return ret;
  }
  void OpeningBook::seek(int offset){
    ifs.seekg(offset,std::ios::beg);
  }
  std::vector<OBMove> OpeningBook::getMoves(int stateIndex){
#if 0
    return states[stateIndex].getMoves();
#else
    seek(4+16*stateIndex+8);
    int nMoves=readInt();
    int moveIndex=readInt();
    seek(4+16*nStates+8*moveIndex);
    std::vector<OBMove> moves;
    for(int i=0;i<nMoves;i++){
      Move move=static_cast<Move>(readInt());
      int stateIndex=readInt();
      moves.push_back(OBMove(move,stateIndex));
    }
    return moves;
#endif
  }
  int OpeningBook::getWinCount(int stateIndex){
#if 0
    return states[stateIndex].getWinCount();
#else
    seek(4+16*stateIndex);
    return readInt();
#endif
  }
  int OpeningBook::getLoseCount(int stateIndex){
#if 0
    return states[stateIndex].getLoseCount();
#else
    seek(4+16*stateIndex+4);
    return readInt();
#endif
  }
  
} // namespace record
} // namespace osl
