#include "osl/checkmate/checkHashTable.h"
#include "osl/hashKey.h"
#include "osl/perfmon.h"
#include <boost/scoped_ptr.hpp>

using namespace osl;

inline HashKey makeKey(size_t i)
{
  return HashKey(1+i-i/4,i,i,i); // v[0] ޤ˽Ťʤ褦
}

template <bool findAfter, bool findAgain>
void test(size_t n)
{
  // stack ֤ˤ礭
  boost::scoped_ptr<CheckHashTable> table(new CheckHashTable(BLACK));
  clock_start();
  for (size_t i=0; i<n; ++i)
  {
    const HashKey& k = makeKey(i);
    /*CheckHashRecord *record =*/ table->allocate(k);
    if (findAfter)
      table->find(k);
  }
  if (findAgain)
  {
    for (size_t i=0; i<n; ++i)
    {
      const HashKey& k = makeKey(i);
      table->find(k);
    }
  }
  clock_stop("total", n);
}

int main(int argc, char **argv)
{
  int numEntries=10000;
  extern char *optarg;
  bool findAgain = false;
  bool findAfter = false;
  
  char c;
  while ((c = getopt(argc, argv, "fFn:")) != EOF)
  {
    switch(c)
    {
    case 'f':	findAfter = true;
      break;
    case 'F':	findAgain = true;
      break;
    case 'n':	numEntries = atoi(optarg);
      break;
    default:
      std::cerr << "unknown option\n";
      return 1;
    }
  }

  for (int i=0; i<8; ++i)
  {
    if (findAfter)
    {
      if (findAgain)
	test<true,true>(numEntries);
      else
	test<true,false>(numEntries);
    }
    else
    {
      if (findAgain)
	test<false,true>(numEntries);
      else
	test<false,false>(numEntries);
    }
  }
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
