#include "osl/boardBitMask.h"
#include <iostream>
#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>

class boardBitMaskTest : public CppUnit::TestFixture {
  CPPUNIT_TEST_SUITE( boardBitMaskTest );
  CPPUNIT_TEST( testShowTable );
  CPPUNIT_TEST_SUITE_END();
public:
  boardBitMaskTest();
  void testShowTable();
};

CPPUNIT_TEST_SUITE_REGISTRATION(boardBitMaskTest);
using namespace osl;

extern bool isShortTest;

boardBitMaskTest::boardBitMaskTest(){
}

void boardBitMaskTest::testShowTable(){
  if(isShortTest) return;
  for(int y=1;y<=9;y++)
    for(int x=1;x<=9;x++){
      Position pos=newPosition(x,y);
      std::cout << pos << ":" << boardBitMaskTable.getMask(pos) << std::endl;
    }
  {
    Position pos1=newPosition(1,1);
    Position pos2=newPosition(9,9);
    std::cout << "rookBetweenMask[" << pos1 << "][" << pos2 << "]=" << 
      std::endl <<
      boardBitMaskTable.getRookMask(pos1,pos2) << std::endl;
  }
  {
    Position pos1=newPosition(5,5);
    Position pos2=newPosition(5,9);
    std::cout << "rookBetweenMask[" << pos1 << "][" << pos2 << "]=" << 
      std::endl <<
      boardBitMaskTable.getRookMask(pos1,pos2) << std::endl;
  }
  {
    Position pos1=newPosition(1,1);
    Position pos2=newPosition(9,1);
    std::cout << "rookBetweenMask[" << pos1 << "][" << pos2 << "]=" << 
      std::endl <<
      boardBitMaskTable.getRookMask(pos1,pos2) << std::endl;
  }
  {
    Position pos1=newPosition(1,1);
    Position pos2=newPosition(9,9);
    std::cout << "bishopBetweenMask[" << pos1 << "][" << pos2 << "]=" << 
      std::endl <<
      boardBitMaskTable.getBishopMask(pos1,pos2) << std::endl;
  }
  {
    Position pos1=newPosition(5,5);
    Position pos2=newPosition(5,9);
    std::cout << "bishopBetweenMask[" << pos1 << "][" << pos2 << "]=" << 
      std::endl <<
      boardBitMaskTable.getBishopMask(pos1,pos2) << std::endl;
  }
  {
    Position pos1=newPosition(1,9);
    Position pos2=newPosition(9,1);
    std::cout << "bishopBetweenMask[" << pos1 << "][" << pos2 << "]=" << 
      std::endl <<
      boardBitMaskTable.getBishopMask(pos1,pos2) << std::endl;
  }
  {
    Position pos1=newPosition(1,1);
    Position pos2=newPosition(1,9);
    std::cout << "lanceBetweenMask[" << pos1 << "][" << pos2 << "]=" << 
      std::endl <<
      boardBitMaskTable.getLanceMask(pos1,pos2) << std::endl;
  }
  {
    Position pos1=newPosition(1,9);
    Position pos2=newPosition(1,1);
    std::cout << "lanceBetweenMask[" << pos1 << "][" << pos2 << "]=" << 
      std::endl <<
      boardBitMaskTable.getLanceMask(pos1,pos2) << std::endl;
  }
  {
    Position pos1=newPosition(1,9);
    Position pos2=newPosition(9,1);
    std::cout << "lanceBetweenMask[" << pos1 << "][" << pos2 << "]=" << 
      std::endl <<
      boardBitMaskTable.getLanceMask(pos1,pos2) << std::endl;
  }
}

