#include "osl/category/fWMoveGen.h"
#include "osl/category/categoryListUtil.h"
#include "osl/moveLogProbSet.h"
#include "osl/record/record.h"
#include "osl/record/csa.h"
#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>
#include <string>
#include <fstream>
#include <iostream>

class FWMoveGenTest : public CppUnit::TestFixture 
{
  CPPUNIT_TEST_SUITE(FWMoveGenTest);
  CPPUNIT_TEST(testCover);
  CPPUNIT_TEST_SUITE_END();
public:
  void testCover();
};

CPPUNIT_TEST_SUITE_REGISTRATION(FWMoveGenTest);

using namespace osl;
using namespace osl::category;
extern bool isShortTest;

static void testFile(std::string const& fileName)
{
  const Record rec=CsaFile(fileName).getRecord();
  NumEffectState state(rec.getInitialState());
  const std::vector<osl::Move> moves=rec.getMoves();
  CategoryEnv env(&state, 500, 0);

  for (size_t i=0; i<moves.size(); ++i)
  {
    MoveLogProbSet generated;
    CategoryListUtil::gatherAllMoves<FWMoveGen>(env, generated);
    CPPUNIT_ASSERT(generated.find(moves[i]));
    state.doMove(moves[i]);
  }
}

void FWMoveGenTest::testCover()
{
  std::ifstream ifs("../data/kifdat/FILES");
  CPPUNIT_ASSERT(ifs);
  std::string fileName;
  for(int i=0;i<100 && (ifs >> fileName) ; i++){
    if(fileName == "") 
      break;
    testFile("../data/kifdat/" + fileName);
  }
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
