#include "osl/direction.h"
#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>
#include <iostream>
using namespace osl;
extern bool isShortTest;

class directionTest : public CppUnit::TestFixture {
  CPPUNIT_TEST_SUITE( directionTest );
  CPPUNIT_TEST( testTraits);
  CPPUNIT_TEST( testTable);
  CPPUNIT_TEST( testShow );
  CPPUNIT_TEST_SUITE_END();
 public:
  void testTraits();
  void testTable();
  void testShow();
};

CPPUNIT_TEST_SUITE_REGISTRATION(directionTest);

  void directionTest::testTraits(){
    CPPUNIT_ASSERT(DirectionTraitsGen<LONG_D>::blackDx==0);
    CPPUNIT_ASSERT(DirectionTraitsGen<LONG_D>::blackDy==1);
    CPPUNIT_ASSERT(DirectionTraits<LONG_D>::blackOffset==(newOffset(0,1)));
    CPPUNIT_ASSERT((DirectionPlayerTraits<LONG_D,BLACK>::offset)==(newOffset(0,1)));
    CPPUNIT_ASSERT((DirectionPlayerTraits<LONG_D,BLACK>::offset)!=OFFSET_ZERO);
    CPPUNIT_ASSERT((DirectionPlayerTraits<UUR,WHITE>::offset)==(newOffset(1,2)));
    CPPUNIT_ASSERT((DirectionPlayerTraits<UUR,WHITE>::offset)==18);
  }

  void directionTest::testTable(){
    CPPUNIT_ASSERT_EQUAL(directionTable.getShortOffset(newOffset32(6,0)),
			 newOffset(1,0));
    CPPUNIT_ASSERT(DirectionTraitsGen<LONG_D>::blackDy==1);
    CPPUNIT_ASSERT(DirectionTraits<LONG_D>::blackOffset==(newOffset(0,1)));
    CPPUNIT_ASSERT((DirectionPlayerTraits<LONG_D,BLACK>::offset)==(newOffset(0,1)));
    CPPUNIT_ASSERT((DirectionPlayerTraits<LONG_D,BLACK>::offset)!=OFFSET_ZERO);
  }

template<int i>
static void showDirect(){
  Direction d=static_cast<Direction>(i);
  std::cout << i << "," << d << "," << DirectionTraits<static_cast<Direction>(i)>::mask << std::endl;
}
void directionTest::testShow(){
  if (! isShortTest)
    {
      showDirect<0>();
      showDirect<1>();
      showDirect<2>();
      showDirect<3>();
      showDirect<4>();
      showDirect<5>();
      showDirect<6>();
      showDirect<7>();
      showDirect<8>();
      showDirect<9>();
      showDirect<10>();
      showDirect<11>();
      showDirect<12>();
      showDirect<13>();
      showDirect<14>();
      showDirect<15>();
      showDirect<16>();
      showDirect<17>();
      for(int dy=-8;dy<=8;dy++){
	for(int dx=-8;dx<=8;dx++){
	  std::cout << "LongDirection<BLACK>(" << dx << "," << dy << ")=" << directionTable.getLongDirection<BLACK>(newOffset32(dx,dy)) << std::endl;
	}
      }
    }
}
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
