/* fixedCapacityVectorTest.cc
 */
#include "osl/fixedCapacityVector.h"
#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>
#include <set>

class fixedCapacityVectorTest : public CppUnit::TestFixture {
  CPPUNIT_TEST_SUITE(fixedCapacityVectorTest);
  CPPUNIT_TEST(testUniq);
  CPPUNIT_TEST_SUITE_END();
public:
  void testUniq();
};

CPPUNIT_TEST_SUITE_REGISTRATION(fixedCapacityVectorTest);
using namespace osl;

void fixedCapacityVectorTest::testUniq()
{
  std::multiset<int> s;
  FixedCapacityVector<int,1000> v;
  for (size_t i=0; i<700; ++i)
  {
    const int e = random() % 128;
    s.insert(e);
    v.push_back(e);
  }
  CPPUNIT_ASSERT_EQUAL(s.size(), v.size());
  std::set<int> u(s.begin(), s.end());
  CPPUNIT_ASSERT(u.size() < v.size());
  v.unique();
  CPPUNIT_ASSERT_EQUAL(u.size(), v.size());
  std::sort(v.begin(), v.end());
  CPPUNIT_ASSERT(std::equal(u.begin(), u.end(), v.begin()));
}


/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
