#if 0

// full width ?

#include "fixedProbabilityMovesTest.h"
#include "osl/fixedProbabilityMoves.h"
#include "osl/moveLogProb.h"
#include "osl/moveLogProbVector.h"
#include "osl/generateAllMoves.h"
#include "osl/csaString.h"
#include "osl/simpleHashState.h"
#include "osl/eval.tcc"
#include "osl/storeMoveAction.h"
#include "osl/moveVector.h"

CPPUNIT_TEST_SUITE_REGISTRATION(fixedProbabilityMovesTest);

using namespace osl;

void fixedProbabilityMovesTest::setUp(){
  state=CsaString(
"P1+NY+TO *  *  *  * -OU-KE-KY\n"
"P2 *  *  *  *  * -GI-KI *  *\n"
"P3 * +RY *  * +UM * -KI-FU-FU\n"
"P4 *  * +FU-FU *  *  *  *  *\n"
"P5 *  * -KE * +FU *  * +FU *\n"
"P6-KE *  * +FU+GI-FU *  * +FU\n"
"P7 *  * -UM *  *  *  *  *  *\n"
"P8 *  *  *  *  *  *  *  *  * \n"
"P9 * +OU * -GI *  *  *  * -NG\n"
"P+00HI00KI00KE00KY00FU00FU00FU00FU00FU00FU\n"
"P-00KI00KY00FU00FU\n"
"P-00AL\n"
"+\n").getInitialState();
}

void fixedProbabilityMovesTest::testGenMove(){
  MoveVector rawMoves;
  StoreMoveAction store(rawMoves);

  MoveLogProbVector moves;
  FixedProbabilityMoves action(&moves, 500);
  GenerateAllMoves<SimpleState,StoreMoveAction>::generateMoves(BLACK,state,store);

  for (MoveVector::const_iterator p=rawMoves.begin(); p!=rawMoves.end(); ++p)
    action.addMove(*p);
  
  CPPUNIT_ASSERT(moves.end()!=std::find(moves.begin(),moves.end(),
				    MoveLogProb(newMove(newPosition(9,1),newPosition(9,2),PLANCE,PTYPE_EMPTY,false,BLACK),500)));
}

void fixedProbabilityMovesTest::testOneMove(){
  MoveVector rawMoves;
  StoreMoveAction store(rawMoves);

  MoveLogProbVector moves;
  FixedProbabilityMoves action(&moves, 500);
  GenerateAllMoves<SimpleState,StoreMoveAction>::generateMoves(BLACK,state,store);

  for (MoveVector::const_iterator p=rawMoves.begin(); p!=rawMoves.end(); ++p)
    action.addMove(*p);

  //CPPUNIT_ASSERT(moves.size()==);
  CPPUNIT_ASSERT(moves.end()!=std::find(moves.begin(),moves.end(),
				    MoveLogProb(newMove(newPosition(9,1),newPosition(9,2),PLANCE,PTYPE_EMPTY,false,BLACK),500)));
}


#endif
