/* moveSorterTest.cc
 */
#include "osl/moveSorter.h"
#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>
#include <boost/scoped_ptr.hpp>

class moveSorterTest : public CppUnit::TestFixture {
  CPPUNIT_TEST_SUITE(moveSorterTest);
  CPPUNIT_TEST(testCreation);
  CPPUNIT_TEST(testInsertBlack);
  CPPUNIT_TEST(testInsertWhite);
  CPPUNIT_TEST_SUITE_END();
public:
  void testCreation();
  void testInsertBlack();
  void testInsertWhite();
};

CPPUNIT_TEST_SUITE_REGISTRATION(moveSorterTest);
using namespace osl;

void moveSorterTest::testCreation()
{
    MtdfMoveSorter<BLACK> sorter;
    MtdfMoveSorter<WHITE> sorter2;
}

void moveSorterTest::testInsertBlack()
{
    MtdfMoveSorter<BLACK> sorter;
    MoveLogProb m;
    sorter.insert(std::make_pair(0, m));
    sorter.insert(std::make_pair(1, m));

    MtdfMoveSorter<BLACK>::iterator p=sorter.begin();
    int best = p->first;
    ++p;
    int secondBest = p->first;
    CPPUNIT_ASSERT(EvalTraits<BLACK>::betterThan(best, secondBest));

    sorter.insert(std::make_pair(0, m));
    sorter.insert(std::make_pair(1, m));
    p=sorter.begin();
    best = p->first;
    ++p;
    secondBest = p->first;
    CPPUNIT_ASSERT_EQUAL(best, secondBest);
}

void moveSorterTest::testInsertWhite()
{
    MtdfMoveSorter<WHITE> sorter;
    MoveLogProb m;
    sorter.insert(std::make_pair(0, m));
    sorter.insert(std::make_pair(1, m));

    MtdfMoveSorter<WHITE>::iterator p=sorter.begin();
    int best = p->first;
    ++p;
    int secondBest = p->first;
    CPPUNIT_ASSERT(EvalTraits<WHITE>::betterThan(best, secondBest));

    sorter.insert(std::make_pair(0, m));
    sorter.insert(std::make_pair(1, m));
    p=sorter.begin();
    best = p->first;
    ++p;
    secondBest = p->first;
    CPPUNIT_ASSERT_EQUAL(best, secondBest);
}


/* ------------------------------------------------------------------------- */
