/* progress.t.cc
 */

#include "osl/progress.h"
#include "osl/applyMove.h"
#include "osl/pawnMaskState.h"
#include "osl/record/csa.h"

#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>
#include <iostream>
#include <fstream>

class ProgressTest : public CppUnit::TestFixture 
{
  CPPUNIT_TEST_SUITE(ProgressTest);
  CPPUNIT_TEST(testConsistent);
  CPPUNIT_TEST_SUITE_END();
public:
  void testConsistent();
};

CPPUNIT_TEST_SUITE_REGISTRATION(ProgressTest);

using namespace osl;

void ProgressTest::testConsistent()
{
  extern bool isShortTest;
  std::ifstream ifs("../data/kifdat/FILES");
  CPPUNIT_ASSERT(ifs);
  int max=100;
  if (isShortTest)
      max=10;
  std::string fileName;
  int i=0;
  while((ifs >> fileName) && (++i<max)) 
  {
    if (! isShortTest)
      std::cerr << fileName << " ";
    std::string fullFileName = "../data/kifdat/";
    fullFileName += fileName;

    Record rec=CsaFile(fullFileName).getRecord();
    PawnMaskState state=rec.getInitialState();
    const std::vector<osl::Move> moves=rec.getMoves();
    Progress incremental(state);
    for (size_t i=0; i<moves.size(); ++i)
    {
      ApplyMoveOfTurn::doMove(incremental, state, moves[i]);
      ApplyMoveOfTurn::doMove(state, moves[i]);
      const Progress batch(state);
      CPPUNIT_ASSERT_EQUAL(incremental, batch);
    }
  }
}
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
