#include "kisenTest.h"
#include <iterator>
#include <iostream>
using namespace osl;
extern bool isShortTest;

void kisenTest::setUp(){
}

const char *filename = "../data/kisen/01.kif";

void kisenTest::testShow(){
  KisenFile kisenFile(filename);
  moves = kisenFile.getMoves(0);  
  CPPUNIT_ASSERT( !moves.empty() );
  if (! isShortTest)
      copy(moves.begin(), moves.end(), 
	   std::ostream_iterator<Move>( std::cout , "\n" ));
}

void kisenTest::testConsistent(){
  KisenFile kisenFile(filename);
  extern bool isShortTest;
  size_t count=kisenFile.size();
  if (isShortTest)
      count=100;
  for(size_t i=0;i<count;i++){
    if(i==172518) continue;
    PawnMaskState state=kisenFile.getInitialState();
    std::vector<Move> moves=kisenFile.getMoves(i);
    for(size_t j=0;j<moves.size();j++){
      state.doMove(moves[j]);
      CPPUNIT_ASSERT( state.isConsistent(true) ||
		       (std::cout << state << moves[j] ,0));
    }
  }
}
