#include "osl/search/tableUtil.h"
#include "osl/search/simpleHashTable.h"
#include "osl/hashKey.h"
#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>

extern bool isShortTest;

class tableUtilTest : public CppUnit::TestFixture {
  CPPUNIT_TEST_SUITE(tableUtilTest);
  CPPUNIT_TEST(testFind);
  CPPUNIT_TEST(testAllocate);
  CPPUNIT_TEST_SUITE_END();
public:
  void testFind();
  void testAllocate();
};

CPPUNIT_TEST_SUITE_REGISTRATION(tableUtilTest);

using namespace osl;
using namespace osl::search;

void tableUtilTest::testFind() 
{
  SimpleHashTable table(100,1,false);
  HashKey k;
  CPPUNIT_ASSERT_EQUAL(0u, table.size());
  SimpleHashRecord *result = TableUtil::find(&table, k);
  CPPUNIT_ASSERT(! result);

  void *invalidTable=0;
  result = TableUtil::find(invalidTable, k);
  CPPUNIT_ASSERT(! result);
}

void tableUtilTest::testAllocate() 
{
  SimpleHashTable table(100,1,false);
  HashKey k;
  CPPUNIT_ASSERT_EQUAL(0u, table.size());
  SimpleHashRecord *result = TableUtil::find(&table, k);
  CPPUNIT_ASSERT(! result);

  result = TableUtil::allocate(&table, k, 100);
  CPPUNIT_ASSERT(result);

  SimpleHashRecord *result2 = TableUtil::find(&table, k);
  CPPUNIT_ASSERT_EQUAL(result, result2);

  void *invalidTable=0;
  result = TableUtil::allocate(invalidTable, k, 100);
  CPPUNIT_ASSERT(! result);

  result = TableUtil::find(invalidTable, k);
  CPPUNIT_ASSERT(! result);
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
